// ignore_for_file: library_prefixes

import 'dart:io';
import 'dart:math';
//  美颜版本  有nana美颜库
// import 'package:agora_rtc/FUManager/FUManager.dart';
// import 'package:agora_rtc/FUManager/FUManagerView.dart';
// import 'package:agora_rtc/rtc_local_view.dart' as RtcLocalView;
//  不带美颜
 import 'package:agora_rtc_engine/rtc_local_view.dart' as RtcLocalView;
//
import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:mmoo_base/dao/dao_result.dart';
import 'package:mmoo_base/dao/main_dao.dart';
import 'package:mmoo_base/entity/base_entity.dart';
import 'package:mmoo_base/utils/common_utils.dart';
import 'package:mmoo_live_room/Page/page_live_root.dart';
import 'package:mmoo_live_room/Provider/provider_live_user.dart';
import 'package:mmoo_live_room/Config/config_live_globalkey.dart';
import 'package:mmoo_live_room/Config/config_live_typedef.dart';
import 'package:mmoo_live_room/Page/BeginLivePage/page_beginlive_peoples.dart';
import 'package:mmoo_live_room/Page/BeginLivePage/page_beginlive_single.dart';
import 'package:mmoo_live_room/Page/BeginLivePage/page_beginlive_voice.dart';
import 'package:mmoo_live_room/Utils/utils_engine_manager.dart';
import 'package:mmoo_live_room/Utils/utils_live.dart';
import 'package:mmoo_live_room/Utils/utils_live_alert.dart';
import 'package:mmoo_live_room/Utils/utils_live_image.dart';
import 'package:mmoo_live_room/Utils/utils_live_permission.dart';
import 'package:mmoo_live_room/Utils/widget_round_under_linetab.dart';
import 'package:mmoo_live_room/Widget/widget_begin_live_videoinfo.dart';
import 'package:mmoo_live_room/Widget/widget_live_begin_join.dart';
import 'package:mmoo_live_room/generated/l10n.dart';
import 'package:mmoo_live_room/Model/model_lastLive_entity.dart';
import 'package:mmoo_live_room/Model/model_live_info_entity.dart';
import 'package:mmoo_live_room/Utils/utils_live_dlog.dart';
import 'package:mmoo_live_room/Widget/widget_action_btns.dart';
import 'package:permission_handler/permission_handler.dart';

const _chars = 'AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsTtUuVvWwXxYyZz1234567890';
// typedef
Random _rnd = Random();
String getRandomString(int length) => String.fromCharCodes(Iterable.generate(
    length, (_) => _chars.codeUnitAt(_rnd.nextInt(_chars.length))));

// 开播类型
enum LivePlayType {
  Audio, // 语音
  Single, // 单人视频
  Multi, // 多人视频
}

class PageBeginLive extends StatefulWidget {
  static const String routerName = "PageBeginLive";
  final ClickCallBack clickCallBack;
  final LivePlayType? livePlayType;
  // List<ModelLiveOpenTypeEntity>? openTypeList;
  Map<String, String>? openType;

  PageBeginLive(
      {required this.clickCallBack, this.livePlayType, this.openType});
  @override
  PageBeginLiveState createState() => PageBeginLiveState();
}

class PageBeginLiveState extends State<PageBeginLive>
    with SingleTickerProviderStateMixin {
  TabController? _tabController;
  ModelLastLiveEntity _lastLiveEntity = ModelLastLiveEntity();
  int currentPage = 0;
  bool isSwitchCamera = false;
  bool _isMirroring = false;
  // List tabs = [];
  // List<Widget> tabsWidget = [];
  List<String> _keys = [];
  List<String> _values = [];
  @override
  Widget build(BuildContext context) {
    return WillPopScope(
        onWillPop: () async => false,
        child: Scaffold(
            resizeToAvoidBottomInset: false,
            body: GestureDetector(
              behavior: HitTestBehavior.opaque,
              onTap: () {
                // FocusScope.of(context).requestFocus(FocusNode());
                FocusScope.of(context).unfocus();
              },
              child: Stack(
                children: [
                  // RtcLocalView.SurfaceView(),
                  Positioned.fill(
                    child: RtcLocalView.SurfaceView(),
                  ),
                  Positioned(
                      child: SizedBox(
                    // height: 1.sh,
                    child: TabBarView(
                      controller: _tabController,
                      children: buildTabWidget(),

                      // children: [
                      //   PageBeginLiveVoice(
                      //     lastLiveEntity: _lastLiveEntity,
                      //     clickCallBack: (methon, data) {
                      //       clickBtnWithMethon(methon, data);
                      //     },
                      //   ),
                      //   PageBeginLiveSingle(
                      //     clickCallBack: (methon, data) {
                      //       clickBtnWithMethon(methon, data);
                      //     },
                      //     lastLiveEntity: _lastLiveEntity,
                      //   ),
                      //   PageBeginLivePeoples(
                      //     lastLiveEntity: _lastLiveEntity,
                      //     clickCallBack: (methon, data) {
                      //       clickBtnWithMethon(methon, data);
                      //     },
                      //   ),
                      // ],
                    ),
                  )),
                  Positioned.fill(
                    child: Container(
                        margin: EdgeInsets.all(15.w),
                        padding: EdgeInsets.only(
                            top: ScreenUtil().statusBarHeight + 10.w,
                            bottom: ScreenUtil().bottomBarHeight + 10.w),
                        width: 1.sw,
                        child: Column(
                          mainAxisAlignment: MainAxisAlignment.spaceBetween,
                          children: [
                            Row(
                              mainAxisAlignment: MainAxisAlignment.end,
                              children: [
                                GestureDetector(
                                  child: UtilsLiveImage.getIconByPath(
                                    'icon_live_begin_hangup',
                                  ),
                                  onTap: () async {
                                    //  美颜版本  有nana美颜库
                                    // await FUManager.stopCapture();
                                    //

                                    if (PageLiveRoot.popUntilName != null &&
                                        (PageLiveRoot.popUntilName ?? '')
                                            .isEmpty) {
                                      Navigator.popUntil(
                                          context,
                                          ModalRoute.withName(
                                              (PageLiveRoot.popUntilName ??
                                                  '')));
                                    } else {
                                      Navigator.of(context).popUntil((route) {
                                        DLog((route.settings.name ?? '')
                                            .startsWith(PageLiveRoot.name));
                                        return (route.settings.name ?? '')
                                            .startsWith(PageLiveRoot.name);
                                      });
                                      await Future.delayed(
                                              const Duration(milliseconds: 40))
                                          .then((value) {
                                        Navigator.pop(context);
                                      });
                                    }
                                    // Navigator.of(context).popUntil((route) {
                                    //   DLog(route.settings.name);
                                    //   return (route.settings.name ?? '')
                                    //       .startsWith(PageLiveRoot.name);
                                    // });
                                    // Future.delayed(
                                    //         const Duration(milliseconds: 300))
                                    //     .then((value) {
                                    //   DLog("vadsvhasdkh");
                                    //   Navigator.pop(context);
                                    // });
                                  },
                                )
                              ],
                            ),
                            TabBar(
                              tabs: buildTabsText().map((e) {
                                return Tab(
                                  // height: 40,
                                  child: Align(
                                    alignment: Alignment.center,
                                    child: Text(e),
                                  ),
                                );
                              }).toList(),
                              controller: _tabController,
                              unselectedLabelStyle: TextStyle(
                                  fontSize: 16,
                                  color: Colors.white.withOpacity(0.8),
                                  fontWeight: FontWeight.normal,
                                  wordSpacing: -1,
                                  decoration: TextDecoration.none),
                              labelStyle: const TextStyle(
                                  fontSize: 20,
                                  color: Colors.white,
                                  wordSpacing: -1,
                                  fontWeight: FontWeight.bold,
                                  decoration: TextDecoration.none),
                              isScrollable: true,
                              labelColor: Colors.white,
                              unselectedLabelColor:
                                  Colors.white.withOpacity(0.8),
                              indicator: const RoundUnderlineTabIndicator(
                                  wantWidth: 6,
                                  borderSide: BorderSide(
                                    width: 6,
                                    color: Colors.white,
                                  )),
                              labelPadding: EdgeInsets.only(
                                  left: 10.w, right: 10.w, bottom: 0),
                              onTap: (index) {
                                DLog(index);
                                // _tabsInt = index;
                              },
                            ),
                          ],
                        )),
                  )
                ],
              ),
            )));
  }

  List<String> buildTabsText() {
    List<String> list = [];
    for (var element in _keys) {
      if (element == 'Audio') {
        list.add(S.current.Live_Begin_Audiolive);
      } else if (element == 'Single') {
        list.add(S.current.Live_Begin_Singlelive);
      } else if (element == 'Multi') {
        list.add(S.current.Live_Begin_MultiGuest);
      }
    }
    return list;
  }

  List<Widget> buildTabWidget() {
    List<Widget> list = [];

    for (var element in _keys) {
      if (element == 'Audio') {
        list.add(PageBeginLiveVoice(
          lastLiveEntity: _lastLiveEntity,
          clickCallBack: (methon, data) {
            clickBtnWithMethon(methon, data);
          },
        ));
      } else if (element == 'Single') {
        list.add(PageBeginLiveSingle(
          lastLiveEntity: _lastLiveEntity,
          clickCallBack: (methon, data) {
            clickBtnWithMethon(methon, data);
          },
        ));
      } else if (element == 'Multi') {
        list.add(PageBeginLivePeoples(
          lastLiveEntity: _lastLiveEntity,
          clickCallBack: (methon, data) {
            clickBtnWithMethon(methon, data);
          },
        ));
      }
    }
    return list;
  }

  clickBtnWithMethon(String methon, dynamic data) async {
    DLog(methon);
    DLog(data);
    if (methon == 'Flip camera') {
      //  美颜版本  有nana美颜库
      // FUManager.switchCamera();
      // 不带美颜
      RtcEngineManager.getInstance().getEngine()?.switchCamera();

      isSwitchCamera = !isSwitchCamera;
    } else if (methon == 'Set up') {
      WidgetBeginLiveVideoInfo.showVideoInfoView(context,
          isShowMicSwitch: _keys[_tabController?.index ?? 0] != 'Audio',
          lastLiveEntity: _lastLiveEntity, clickCallBack: (methon, data) {
        clickBtnWithMethon(methon, data);
      }, callback: (liveEntity) {
        if (mounted) {
          setState(() {
            _lastLiveEntity = liveEntity;
          });
        }
      });
    } else if (methon == 'Beautify') {
      //  美颜版本  有nana美颜库
      // FUManagerView.showFaceUnityView(context);
      //
    } else if (methon == 'Mic seat') {
      WidgetActionBtns.showActionTwoBtns(context, leftPressed: () {
        setState(() {
          _lastLiveEntity.micSeat = '6';
        });
      }, rightPressed: () {
        setState(() {
          _lastLiveEntity.micSeat = '9';
        });
      }, leftTitle: "6", rightTitle: "9");
    }  else if (methon == 'startlive') {
      CommonUtils.showLoading();
      DLog(_lastLiveEntity.micSeat);
      DataResult dataResult = await MainDao.livePostCreateLiveImpl(
          imageUrl: _lastLiveEntity.cover ?? '',
          language: _lastLiveEntity.language ?? '01',
          liveNotice: _lastLiveEntity.liveNotice ?? '',
          title: _lastLiveEntity.title ?? '',
          type: _keys[_tabController!.index] == 'Audio' ? 0 : 1,
          // type: _tabController?.index == 0 ? 0 : 1,

          videoPlaceType: _keys[_tabController!.index] == 'Audio'
              ? 0
              : _keys[_tabController!.index] == 'Single'
                  ? 1
                  : 4,
          videoPrice: int.parse(_lastLiveEntity.chooseVideoPrice),
          price: int.parse(_lastLiveEntity.pricatePrice),
          voicePlaceType: int.parse(_lastLiveEntity.micSeat),
          voicePrice: int.parse(_lastLiveEntity.chooseVoicePrice));
      DLog(dataResult);
      CommonUtils.dismiss();
      if (dataResult.result && dataResult.data != null) {
        ModelLiveInfoEntity infoEntity =
            ModelLiveInfoEntity().fromJson(dataResult.data);
        infoEntity.role = 0;
        infoEntity.isSwitchCamera = isSwitchCamera;
        ProviderLiveUser().isLiving = true;
        widget.clickCallBack("begingLive", infoEntity);
      } else {
        BaseEntity baseEntity = dataResult.data;
        if (baseEntity.code == '7510') {
          if (mounted) {
            UtilsLiveAlert.showCenter(context, child: WidgetLiveBeginJoin(
              rightVoidCallBack: () {
                widget.clickCallBack("begingLive", _lastLiveEntity.roomId);
              },
            ));
          }

          // WidgetActionBtnsWidgetLiveBeginJoin
        } else {
          UtilsLiveAlert.showDioTips(context, dataResult);
        }
      }
    } else if (methon == 'openPhotos') {
      UtilsLive.showImageView(context, (path) async {
        if (path is String) {
          CommonUtils.showLoading();
          final res = await MainDao.livePostFileUpload(headImage: path);
          CommonUtils.dismiss();
          if (res.result) {
            if (mounted) {
              setState(() {
                _lastLiveEntity.cover = res.data['url'];
              });
            }
          } else {
            UtilsLiveAlert.showDioTips(context, res);
          }
        }
      }, showCallback: (bool isBool) {});

      // DialogUtil.instance.showImageView(context, (path) {
      //   if (path is String) {
      //     Navigator.push(context, MaterialPageRoute(builder: (context) {
      //       return PageCropUtilsLiveImage(
      //         image: File(path),
      //         cropAspectRatios: CropAspectRatios.ratio1_1,
      //       );
      //     })).then((value) {
      //       if (value is Map && value["fileData"] is Uint8List) {
      //         upLoadImagePicker(value["fileData"]);
      //       }
      //     });
      //   }
      // }, showCallback: (show) {
      //   DLog(show);
      // });

      // final pickedFile = await ImageUpLoadUtil().imagePicker(context);
      // DLog(pickedFile);
      // if (pickedFile != null) {
      //   Navigator.push(context, MaterialPageRoute(builder: (context) {
      //     return PageCropUtilsLiveImage(image: File(pickedFile.path));
      //   })).then((value) => {
      //         if (value != null &&
      //             value is Map &&
      //             value["fileData"] is Uint8List)
      //           {
      //             // ImageRepository repository = ImageRepository();
      //             upLoadImagePicker(value["fileData"])
      //             // value.length.toString(),
      //           }
      //       });
      // }
    } else if (methon == 'Video Seat Price') {
      WidgetActionBtns.showActionMoreBtns(
          context,
          _lastLiveEntity.videoPrice?.map((e) {
                return (e.toString() == '0') ? 'Free' : e.toString();
              }).toList() ??
              [], actionRowsSelect: (index, string) {
        DLog(index.toString() + string);
        _lastLiveEntity.chooseVideoPrice =
            (_lastLiveEntity.videoPrice?[index]).toString();
        ConfigLiveGlobalkey.videoViewKey.currentState
            ?.updateLastLiveInfo(_lastLiveEntity);
        ConfigLiveGlobalkey.beginLiveKey.currentState
            ?.updateLastLiveInfo(_lastLiveEntity);
      });
    } else if (methon == 'Voice seat price') {
      WidgetActionBtns.showActionMoreBtns(
          context,
          _lastLiveEntity.voicePrice?.map((e) {
                return (e.toString() == '0') ? 'Free' : e.toString();
              }).toList() ??
              [], actionRowsSelect: (index, string) {
        DLog(index.toString() + string);
        _lastLiveEntity.chooseVoicePrice =
            (_lastLiveEntity.voicePrice?[index]).toString();
        ConfigLiveGlobalkey.videoViewKey.currentState
            ?.updateLastLiveInfo(_lastLiveEntity);
        ConfigLiveGlobalkey.beginLiveKey.currentState
            ?.updateLastLiveInfo(_lastLiveEntity);
      });
    } else {}
  }

  getLastLiveInfo() async {
    // final re = await LiveRepositoryImpl().apiLiveGetLastRoomInfo();
    DataResult baseEntity = await MainDao.liveGetLastRoomInfo();
    DLog('msg');
    if (baseEntity.result && baseEntity.data != null) {
      try {
        _lastLiveEntity = ModelLastLiveEntity().fromJson(baseEntity.data);
      } catch (e) {
        _lastLiveEntity = ModelLastLiveEntity();
        DLog(e);
      }
      if (mounted) {
        setState(() {
          _lastLiveEntity.type =
              _keys[_tabController?.index ?? 0] == 'Audio' ? 0 : 1;
          _lastLiveEntity.micSeat =
              _keys[_tabController?.index ?? 0] == 'Audio' ? "0 " : '4';
        });
      }
    } else {
      UtilsLiveAlert.showDioTips(context, baseEntity);
    }
    //  美颜版本  有nana美颜库
    // if (Platform.isAndroid) {
    //   FUManager.startCaptureOnSurfaceCreated();
    // }
    //

  }

  // upLoadImagePicker(Uint8List imageUnit) async {
  //   String length = imageUnit.length.toString();
  //   DataResult baseEntity = await repository.apiImageUpload(
  //       contentLength: length,
  //       fileName: DateTime.now().millisecondsSinceEpoch.toString() +
  //           '_' +
  //           getRandomString(5) +
  //           '');
  //   if (baseEntity.result && baseEntity.dataError == false) {
  //     BaseEntity uploadData = await ImageUpLoadUtil().upLoadImageUnit(
  //         preUrl: baseEntity.data['preUrl'],
  //         imageUnit: imageUnit,
  //         contentType: baseEntity.data['contentType'],
  //         length: length);
  //     if (uploadData.code != null && uploadData.code == '0') {
  //       DataResult baseEntitySuccess = await repository.apiImageUploadSuccess(
  //           ossName: baseEntity.data['ossName'],
  //           preUrl: baseEntity.data['preUrl']);
  //       //  DLog(baseEntitySuccess.data);
  //       if (baseEntitySuccess.result) {
  //         if (mounted) {
  //           setState(() {
  //             _lastLiveEntity.cover = baseEntitySuccess.data['url'];
  //           });
  //         }

  //         ConfigLiveGlobalkey.videoViewKey.currentState
  //             ?.updateLastLiveInfo(_lastLiveEntity);
  //         ConfigLiveGlobalkey.beginLiveKey.currentState
  //             ?.updateLastLiveInfo(_lastLiveEntity);
  //       }
  //     } else {
  //       UtilsLiveAlert.showDioTips(context, baseEntity);
  //     }
  //   }
  // }

  checkPermission() async {
    if (await UtilsLivePermission.checkPermission(context, Permission.camera)) {
      await UtilsLivePermission.checkPermission(context, Permission.microphone);
    }
    // FUManager
  }

  @override
  void initState() {
    // DLog(widget.livePlayType.index);
    if ((widget.openType ?? {}).keys.isEmpty) {
      widget.openType = {"Audio": "1", "Single": "0", "Multi": "0"};
    }

    widget.openType = widget.openType!.cast<String, String>();

    widget.openType!.forEach((key, value) {
      _keys.add(key);
      _values.add(value);
    });
    int index = 0;
    if (widget.livePlayType != null) {
      index = widget.livePlayType!.index;
    } else {
      // values.firstWhere((element) => false)
      for (var i = 0; i < _values.length; i++) {
        if (_values[i] == "1") {
          index = i;
          break;
        }
      }
    }
    _tabController =
        TabController(vsync: this, length: _keys.length, initialIndex: index);
    _tabController?.addListener(() {
      DLog(_tabController?.index);
      _lastLiveEntity.type =
          _keys[_tabController?.index ?? 0] == 'Audio' ? 0 : 1;
      if (!_keys.contains('Audio')) {
        if (mounted) {
          setState(() {
            _lastLiveEntity.videoSeat = _keys[index] == "Multi"
                ? '4'
                : _keys[index] == 'Single'
                    ? '1'
                    : '0';
          });
        }
      }
    });
    checkPermission();
    getLastLiveInfo();
    CommonUtils.dismiss();
    
    super.initState();
  }

  @override
  void dispose() {
    // FUManager.dealloc();
    _tabController?.dispose();
    super.dispose();
  }

  @override
  void didUpdateWidget(PageBeginLive oldWidget) {
    super.didUpdateWidget(oldWidget);
  }

  @override
  void didChangeDependencies() {
    super.didChangeDependencies();
  }
}
