import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:mmoo_live_room/Config/config_live_typedef.dart';
import 'package:mmoo_live_room/Widget/widget_beginlive_face.dart';
import 'package:mmoo_live_room/Widget/widget_open_header.dart';
import 'package:mmoo_live_room/Model/model_lastLive_entity.dart';

class PageBeginLiveSingle extends StatefulWidget {
  final ClickCallBack? clickCallBack;
  final ModelLastLiveEntity? lastLiveEntity;
  // ignore: use_key_in_widget_constructors
  const PageBeginLiveSingle({this.clickCallBack, this.lastLiveEntity});
  @override
  PageBeginLiveSingleState createState() => PageBeginLiveSingleState();
}

class PageBeginLiveSingleState extends State<PageBeginLiveSingle> {
  @override
  Widget build(BuildContext context) {
    return Column(
      mainAxisAlignment: MainAxisAlignment.spaceBetween,
      children: [
        Container(
          margin: EdgeInsets.only(top: ScreenUtil().statusBarHeight + 80.w,left: 15.w,right: 15.w),
          child: WidgetOpenHeader(
            isVideo: true,
              clickCallBack: widget.clickCallBack,
              lastLiveEntity: widget.lastLiveEntity),
        ),
        Container(
          margin: EdgeInsets.only(bottom: ScreenUtil().bottomBarHeight + 70.w),
          child: WidgetBeginLiveFace(
            clickCallBack: widget.clickCallBack,
          ),
        )
      ],
    );
  }

  @override
  void initState() {
    super.initState();
  }

  @override
  void dispose() {
    super.dispose();
  }

  @override
  void didUpdateWidget(PageBeginLiveSingle oldWidget) {
    super.didUpdateWidget(oldWidget);
  }

  @override
  void didChangeDependencies() {
    super.didChangeDependencies();
  }
}
