import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:lottie/lottie.dart';
import 'package:mmoo_base/entity/language_entity.dart';
import 'package:mmoo_live_room/Config/config_live_globalkey.dart';
import 'package:mmoo_live_room/Config/config_live_typedef.dart';
import 'package:mmoo_live_room/Config/config_live_app.dart';
import 'package:mmoo_live_room/Utils/utils_live_image.dart';
import 'package:mmoo_live_room/Widget/widget_beginlive_face.dart';
import 'package:mmoo_live_room/Widget/widget_open_header.dart';
import 'package:mmoo_live_room/Model/model_lastLive_entity.dart';
import 'package:mmoo_live_room/Utils/utils_live_dlog.dart';
import 'package:mmoo_live_room/Utils/utils_live_textStyle.dart';
import 'package:mmoo_live_room/generated/l10n.dart';

// import 'package:lottie/lottie.dart';
class PageBeginLiveVoice extends StatefulWidget {
  final ClickCallBack? clickCallBack;
  final ModelLastLiveEntity? lastLiveEntity;
  PageBeginLiveVoice({this.clickCallBack, this.lastLiveEntity})
      : super(key: ConfigLiveGlobalkey.beginLiveKey);
  // PageBeginLiveVoice({this.clickCallBack});
  @override
  PageBeginLiveVoiceState createState() =>
      // ignore: no_logic_in_create_state
      PageBeginLiveVoiceState(lastLiveEntity);
}

class PageBeginLiveVoiceState extends State<PageBeginLiveVoice> {
  // TextEditingController _editingSignaController = TextEditingController();
  // FocusNode _editSignaFocusNode = FocusNode();

  // TextEditingController _editingNameController = TextEditingController();
  // FocusNode _editNameFocusNode = FocusNode();

  // TextEditingController _editPriceController = TextEditingController();
  // FocusNode _editPriceFocusNode = FocusNode();
  // ScrollController _scrollController = ScrollController();
  // var _switchValue = false;
  ModelLastLiveEntity? lastLiveEntity;
  PageBeginLiveVoiceState(lastLiveEntity);
  // bool _visible = false;
  int _chooseType = 0;
  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      child: Stack(
        children: [
          Positioned.fill(
              child: UtilsLiveImage.getIconByPath(
            'live_open_bg',
            
            fit: BoxFit.cover,
          )),
          Positioned(
              // top: 100.w,
              child: Center(
            child: Container(
              margin: EdgeInsets.only(top: 20.w),
              child: Lottie.asset(
                  AssetLottie('lib/assets/json/audiolivebg.json').assetName,
                  width: 200.w,
                  height: 110.w,
                  package: 'mmoo_live_room'),
            ),
          )),
          Positioned.fill(
            child: Column(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: [
                Expanded(
                    child: Column(
                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                  children: [
                    Container(
                      margin: EdgeInsets.only(
                          top: ScreenUtil().statusBarHeight + 80.w,
                          left: 15.w,
                          right: 15.w),
                      child: WidgetOpenHeader(
                          clickCallBack: widget.clickCallBack,
                          lastLiveEntity: widget.lastLiveEntity),
                    ),
                    Container(
                      margin: EdgeInsets.only(bottom: 10.w),
                      child: Row(
                        mainAxisAlignment: MainAxisAlignment.center,
                        children: [
                          GestureDetector(
                            onTap: () {
                              if (mounted) {
                                setState(() {
                                  _chooseType = 0;
                                });
                              }
                            },
                            child: Column(
                              children: [
                                UtilsLiveImage.getIconByPath(
                                  _chooseType == 0
                                      ? 'live_open_6seats_selected'
                                      : 'live_open_6seats',
                                  
                                ),
                                SizedBox(
                                  height: 10.w,
                                ),
                                Text(
                                  S.current.Live_Begin_6seats,
                                  style: TextStyle(
                                      fontSize: 16,
                                      color: _chooseType == 0
                                          ? Colors.white
                                          : Colors.white.withOpacity(0.6),
                                      fontWeight: FontWeight.w600,
                                      decoration: TextDecoration.none),
                                )
                              ],
                            ),
                          ),
                          SizedBox(
                            width: 55.w,
                          ),
                          GestureDetector(
                            onTap: () {
                              if (mounted) {
                                setState(() {
                                  _chooseType = 1;
                                });
                              }
                            },
                            child: Column(
                              children: [
                                UtilsLiveImage.getIconByPath(
                                  _chooseType == 1
                                      ? 'live_open_9seats_selected'
                                      : 'live_open_9seats',
                                  
                                ),
                                SizedBox(
                                  height: 10.w,
                                ),
                                Text(
                                  S.current.Live_Begin_9seats,
                                  style: TextStyle(
                                      fontSize: 16,
                                      color: _chooseType == 1
                                          ? Colors.white
                                          : Colors.white.withOpacity(0.6),
                                      fontWeight: FontWeight.w600,
                                      decoration: TextDecoration.none),
                                )
                              ],
                            ),
                          )
                        ],
                      ),
                    )
                  ],
                )),
                Container(
                  margin: EdgeInsets.only(
                      bottom: ScreenUtil().bottomBarHeight + 70.w),
                  child: WidgetBeginLiveFace(
                    isShowVideo: false,
                    clickCallBack: (methon, data) {
                      if (methon == 'startlive') {
                        widget.lastLiveEntity?.micSeat =
                            _chooseType == 0 ? '6' : '9';
                        widget.lastLiveEntity?.videoSeat = '0';
                      }
                      if (widget.clickCallBack != null) {
                        widget.clickCallBack!(methon, data);
                      }
                    },
                  ),
                )
              ],
            ),
          )
        ],
      ),
      onTap: () {
        DLog("msg");

        FocusScope.of(context).requestFocus(FocusNode());

        // UtilsLiveColor.startColors
      },
    );
  }

  Widget buildCell(String title, String infoStr) {
    return Container(
      height: 70.w,
      color: Colors.transparent,
      child: Column(
        children: [
          Expanded(
              child: Row(
            mainAxisAlignment: MainAxisAlignment.spaceBetween,
            children: [
              Text(
                title,
                style: UtilsLiveTextStyle.smallTextMediumBBBBBB,
              ),
              Row(
                children: [
                  Text(
                    infoStr,
                    style: UtilsLiveTextStyle.smallTextWhite,
                  ),
                  Container(
                    padding: const EdgeInsets.only(left: 10),
                    child: UtilsLiveImage.getIconByPath(
                      'kaibo_icon_xiangyou',
                      
                    ),
                  )
                ],
              )
            ],
          )),
          Visibility(
              visible: title != S.current.Live_Begin_VideoSeatPrice,
              child: Container(
                height: 1,
                color: Colors.white.withAlpha(50),
              ))
        ],
      ),
    );
  }

  Widget buildMicSeatSwitchCell() {
    return Container(
      // height: 70.w,
      color: Colors.transparent,
      child: Column(
        crossAxisAlignment: CrossAxisAlignment.end,
        children: [
          SizedBox(
              height: 69.w,
              child: Row(
                mainAxisAlignment: MainAxisAlignment.spaceBetween,
                children: [
                  Text(
                    S.current.Live_Begin_Micseat,
                    style: UtilsLiveTextStyle.smallTextMediumBBBBBB,
                  ),
                  Row(
                    children: [
                      Text(
                        widget.lastLiveEntity?.micSeat ?? '',
                        style: UtilsLiveTextStyle.smallTextWhite,
                      ),
                      Container(
                        padding: const EdgeInsets.only(left: 10),
                        child: UtilsLiveImage.getIconByPath(
                          'kaibo_icon_xiangyou',
                          
                        ),
                      )
                    ],
                  )
                ],
              )),
          Container(
            height: 1,
            color: Colors.white.withAlpha(50),
          )
        ],
      ),
    );
  }

  LanguageLists getLanguage() {
    LanguageLists language = LanguageLists();
    for (var element in ConfigLiveApp.langList) {
      if (element.code == widget.lastLiveEntity?.language) {
        language = element;
      }
    }
    return language;
  }

  updateLastLiveInfo(ModelLastLiveEntity newLastLiveEntity) {
    setState(() {
      lastLiveEntity = newLastLiveEntity;
    });
  }

  @override
  void initState() {
    super.initState();

    if (int.parse(widget.lastLiveEntity?.micSeat ?? '0') < 5) {
      widget.lastLiveEntity?.micSeat = '6';
      _chooseType = 0;
    }
  }

  @override
  void dispose() {
    super.dispose();
  }

  @override
  void didUpdateWidget(PageBeginLiveVoice oldWidget) {
    super.didUpdateWidget(oldWidget);
  }

  @override
  void didChangeDependencies() {
    super.didChangeDependencies();
  }
}
