
//  美颜版本  有nana美颜库
// import 'package:agora_rtc/FUManager/FUConfig.dart';
// import 'package:agora_rtc/FUManager/FUManager.dart';
//


import 'package:agora_rtc_engine/rtc_engine.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_localizations/flutter_localizations.dart';
import 'package:mmoo_base/entity/language_entity.dart';
import 'package:mmoo_base/utils/common_utils.dart';
import 'package:mmoo_live_room/Config/config_live_app.dart';
import 'package:mmoo_live_room/Model/model_live_user_info.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:mmoo_live_room/Page/BeginLivePage/page_beginlive_live.dart';
import 'package:mmoo_live_room/Page/page_live_rtc.dart';
import 'package:mmoo_live_room/Provider/provider_live_config.dart';
import 'package:mmoo_live_room/Provider/provider_live_im_unread.dart';
import 'package:mmoo_live_room/Provider/provider_live_user.dart';
import 'package:mmoo_live_room/Utils/utils_engine_manager.dart';
import 'package:mmoo_live_room/Model/model_live_info_entity.dart';
import 'package:mmoo_live_room/Utils/utils_live_dlog.dart';
import 'package:provider/provider.dart';
import 'package:wakelock/wakelock.dart';
import 'package:mmoo_base/dao/dao_result.dart';
import 'package:mmoo_base/entity/language_entity.dart';
import 'package:mmoo_live_room/generated/l10n.dart' as LiveS;
import 'package:mmoo_base/dao/main_dao.dart';

class PageLiveParam {
  PageLiveParam({
    this.key, //Key
    this.isBeginPage = false, //是否打开开播页面
    this.beKey = '', //faceUnity token
    this.livePlayType, //开播页面选择开播类型
    this.agoraAppKey, //声网 key
    this.gui = false, //是否是正常模式
    this.popUntilName,
    required this.roomId, //房间id
    required this.uid, //进入房间的用户id
    required this.headImage, //进入房间的用户头像
    required this.money, //进入房间的用户余额
    required this.unReadNum, //进入房间的用户未读数
    required this.isHost, //进入房间的用户是否是主播
    required this.nickName, //进入房间的用户昵称
    required this.liveMethonDelegate, //代理
    required this.languages, //语言列表数据
    required this.openType, //初始化接口 LiveOpenType
  });
  final Key? key;
  final String beKey;
  final bool isBeginPage;
  final int roomId;
  final bool gui;
  final String? agoraAppKey;
  final LivePlayType? livePlayType;
  final int uid;
  final String headImage;
  final int money;
  final String isHost;
  final List<LanguageLists> languages;
  final Map<String, String> openType;
  final String nickName;
  final int unReadNum;
  final String? popUntilName;
  final LiveMethonDelegate liveMethonDelegate;
}

class PageLiveRoot extends StatefulWidget {
  final PageLiveParam liveParam;
  static String name = 'PageLiveRoot';
  static bool inLivePage = false;
  static String? popUntilName;

  PageLiveRoot({
    // Key? key,
    required this.liveParam,
  }) : super(key: liveParam.key);
  @override
  // ignore: no_logic_in_create_state
  PageLiveRootState createState() => PageLiveRootState(liveParam.isBeginPage);
}

class PageLiveRootState extends State<PageLiveRoot> {
  ModelLiveInfoEntity? _infoEntity;
  // PageLiveParam param;
  int roomId = 0;
  bool isBeginPage;
  bool fristBuild = false;
  Future? _future;
  PageLiveRootState(this.isBeginPage);
  @override
  Widget build(BuildContext context) {
    return ScreenUtilInit(
        designSize: const Size(375, 812),
        builder: () {
          // return MaterialApp(
          //   localizationsDelegates: const [
          //     LiveS.S.delegate,
          //     GlobalMaterialLocalizations.delegate,
          //     GlobalWidgetsLocalizations.delegate,
          //   ],
          //   locale: const Locale.fromSubtags(languageCode: "en"),
          //   builder: (context, child) {
            if (!fristBuild) {
              fristBuild = true;
              _initializeData();
            }
          return FutureBuilder(
              future: _future,
              builder: (context, snapshot) {
                if (snapshot.connectionState == ConnectionState.done) {
                  return isBeginPage
                      ? PageBeginLive(
                          livePlayType: widget.liveParam.livePlayType,
                          openType: widget.liveParam.openType,
                          clickCallBack: (methon, data) {
                            DLog(ProviderLiveUser().isLiving);
                            if (data is ModelLiveInfoEntity) {
                              _infoEntity = data;
                              setState(() {
                                isBeginPage = false;
                              });
                            } else if (data is int) {
                              roomId = data;
                              setState(() {
                                isBeginPage = false;
                              });
                            }
                          },
                        )
                      : PageLiveRTC(
                          roomId:
                              roomId > 0 ? roomId : (_infoEntity?.roomId ?? 0),
                          infoEntity: _infoEntity,
                          methonDelegate: widget.liveParam.liveMethonDelegate,
                        );
                } else {
                  return Container();
                }
              });
        });
    // },
    // );

    // return isBeginPage
    //     ? PageBeginLive(
    //         clickCallBack: (methon, data) {
    //           DLog(ProviderLiveUser().isLiving);
    //           if (data is ModelLiveInfoEntity) {
    //             _infoEntity = data;
    //             setState(() {
    //               isBeginPage = false;
    //             });
    //           } else if (data is int) {
    //             roomId = data;
    //             setState(() {
    //               isBeginPage = false;
    //             });
    //           }
    //         },
    //       )
    //     : PageLiveRTC(
    //         roomId: roomId > 0 ? roomId : (_infoEntity?.roomId ?? 0),
    //         infoEntity: _infoEntity,
    //         methonDelegate: widget.liveParam.liveMethonDelegate,
    //       );
  }

  initRtcEngine() async {
    if (RtcEngineManager.getInstance().getEngine() == null) {
      if ((widget.liveParam.agoraAppKey ?? '').isNotEmpty) {
        ConfigLiveApp.agoraAppKey = widget.liveParam.agoraAppKey ?? '';
      }
      await RtcEngineManager.getInstance()
          .creatEngine(ConfigLiveApp.agoraAppKey);
    }
    await _getAppAuthInit();
  }

  Future _getAppAuthInit() async {
    //  美颜版本  有nana美颜库
    // if (widget.liveParam.beKey.isNotEmpty &&
    //     await FUManager.isBuild() == false) {
    //   await FUManager.buildFaceUnity(widget.liveParam.beKey);
    //   FUConfig.initialize();
    // }
    //
    // 没有美颜版本
    RtcEngineManager.getInstance().getEngine()?.setClientRole(ClientRole.Broadcaster);
  }

  updataUserInfo({
    int? uid,
    int? money,
    String? nickName,
    String? headImage,
  }) {
    ModelLiveUserInfo userInfo = ProviderLiveUser().userInfo;
    if (uid != null) {
      userInfo.uid = uid;
    }
    if (money != null) {
      userInfo.money = money;
    }
    if (nickName != null) {
      userInfo.nickName = nickName;
    }
    if (headImage != null) {
      userInfo.headImage = headImage;
    }

    ProviderLiveUser liveUser =
        Provider.of<ProviderLiveUser>(context, listen: false);
    liveUser.userInfo = userInfo;
  }

  updataUnReadMessags(int unRead) {
    ProviderLiveImUnRead liveImUnRead =
        Provider.of<ProviderLiveImUnRead>(context, listen: false);
    liveImUnRead.unReadNum = unRead;
  }

  _initializeData() async {
    if ((ProviderLiveUser().userInfo.language ?? []).isEmpty) {
      DataResult dataResult = await MainDao.getLanguagesList();
      if (dataResult.result && dataResult.data != null) {
        LanguageEntity entity = dataResult.data;
        ProviderLiveUser().userInfo.language = entity.lists ?? [];
      }
    }
    ConfigLiveApp.langList = ProviderLiveUser().userInfo.language ?? [];
  }

  @override
  void initState() {
     CommonUtils.showLoading();
    PageLiveRoot.popUntilName = widget.liveParam.popUntilName;
    _future = initRtcEngine();
    ProviderLiveUser().userInfo = ModelLiveUserInfo(
        uid: widget.liveParam.uid,
        money: widget.liveParam.money,
        isHost: widget.liveParam.isHost,
        nickName: widget.liveParam.nickName,
        language: widget.liveParam.languages,
        headImage: widget.liveParam.headImage);
    roomId = widget.liveParam.roomId;
    ConfigLiveApp.gui = widget.liveParam.gui;
    // _initializeData();
    DLog(ProviderLiveUser().userInfo.money);
    ProviderLiveImUnRead().unReadNum = widget.liveParam.unReadNum;
    // Wa

    PageLiveRoot.inLivePage = true;
    Wakelock.enable();
    super.initState();
  }

  @override
  void dispose() {
    DLog("dispost");
    //  美颜版本  有nana美颜库
    // try {
    //   if (ProviderLiveUser().isLiving) {
    //     FUManager.stopCapture();
    //   }
      
    // } catch (e) {
    //   DLog(e);
    // }
    //
    
    PageLiveRoot.inLivePage = false;
    Wakelock.disable();
     CommonUtils.dismiss();
    super.dispose();
  }

  @override
  void didUpdateWidget(PageLiveRoot oldWidget) {
    // TODO: implement didUpdateWidget
    super.didUpdateWidget(oldWidget);
  }

  @override
  void didChangeDependencies() {
    // TODO: implement didChangeDependencies
    super.didChangeDependencies();
  }
}
