import 'dart:convert';

//  美颜版本  有nana美颜库
// import 'package:agora_rtc/FUManager/FUManager.dart';
// import 'package:agora_rtc/FUManager/FUManagerView.dart';
// import 'package:agora_rtc/rtc_engine.dart';
// 不带美颜版本
import 'package:agora_rtc_engine/rtc_engine.dart';
//

import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:flutter_keyboard_visibility/flutter_keyboard_visibility.dart';
import 'package:mmoo_base/dao/dao_result.dart';
import 'package:mmoo_base/dao/main_dao.dart';
import 'package:mmoo_base/entity/base_entity.dart';
import 'package:mmoo_base/utils/common_utils.dart';
import 'package:mmoo_live_room/Config/config_live_app.dart';
import 'package:mmoo_live_room/Config/config_live_socket.dart';
import 'package:mmoo_live_room/HandlerLive/live_socket_event_handler.dart';
import 'package:mmoo_live_room/Model/model_rtm_message.dart';
import 'package:mmoo_live_room/Page/page_live_root.dart';
import 'package:mmoo_live_room/Utils/utils_engine_manager.dart';
import 'package:mmoo_live_room/Utils/utils_live_alert.dart';
import 'package:mmoo_live_room/Utils/utils_live_colors.dart';
import 'package:mmoo_live_room/Utils/utils_live_permission.dart';
import 'package:mmoo_live_room/Utils/wild_fire_chat_callbacks.dart';
import 'package:mmoo_live_room/Config/config_live_globalkey.dart';
import 'package:mmoo_live_room/Config/config_live_methon.dart';
import 'package:mmoo_live_room/Model/model_live_user_info.dart';
import 'package:mmoo_live_room/Provider/provider_live_header_user.dart';
import 'package:mmoo_live_room/Provider/provider_live_im_unread.dart';
import 'package:mmoo_live_room/Provider/provider_live_info_entity.dart';
import 'package:mmoo_live_room/Provider/provider_live_join_place.dart';
import 'package:mmoo_live_room/Provider/provider_live_online.dart';
import 'package:mmoo_live_room/Provider/provider_live_placelist_info.dart';
import 'package:mmoo_live_room/Widget/widget_action_btns.dart';
import 'package:mmoo_live_room/Widget/widget_begin_live_videoinfo.dart';
import 'package:mmoo_live_room/Widget/widget_live_black_list.dart';
import 'package:mmoo_live_room/Widget/widget_live_flollow_list.dart';
import 'package:mmoo_live_room/Widget/widget_live_guest_list.dart';
import 'package:mmoo_live_room/Widget/widget_live_more.dart';
import 'package:mmoo_live_room/Widget/widget_live_private.dart';
import 'package:mmoo_live_room/Widget/widget_live_room_info.dart';
import 'package:mmoo_live_room/Widget/widget_live_setting.dart';
import 'package:mmoo_live_room/Widget/widget_live_user_info.dart';
import 'package:mmoo_live_room/Widget/widget_live_user_wait_list.dart';
import 'package:mmoo_live_room/Widget/widget_owner_manager.dart';
import 'package:mmoo_live_room/Model/model_lastLive_entity.dart';
import 'package:mmoo_live_room/Model/model_live_gift_list_entity.dart';
import 'package:mmoo_live_room/Model/model_live_user_list_entity.dart';
import 'package:mmoo_easemob_im/mmoo_easemob_im.dart';
import 'package:permission_handler/permission_handler.dart';
import 'package:mmoo_live_room/Page/page_live_streamer.dart';
import 'package:mmoo_live_room/Provider/provider_live_chat_messages.dart';
import 'package:mmoo_live_room/Provider/provider_live_user.dart';
import 'package:mmoo_live_room/Utils/utils_live.dart';
import 'package:mmoo_live_room/Widget/widget_live_giftlist.dart';
import 'package:mmoo_live_room/Widget/widget_live_apply_list.dart';
import 'package:mmoo_live_room/generated/l10n.dart';
import 'package:mmoo_live_room/Model/model_live_info_entity.dart';
import 'package:mmoo_live_room/Utils/utils_live_dlog.dart';
import 'package:provider/provider.dart';

import 'package:mmoo_base/api/address.dart';

// import 'package:pull_to_refresh/pull_to_refresh.dart';
///直播间逻辑处理页   一般都是通过clickBtnWithMethon 回调到clickBtnWithMethon 进行处理
class PageLiveRTC extends StatefulWidget {
  static const String routerName = "PageLiveRTC";
  final int roomId;
  final LiveMethonDelegate methonDelegate;
  final ModelLiveInfoEntity? infoEntity;
  PageLiveRTC({
    required this.roomId,
    this.infoEntity,
    required this.methonDelegate,
  }) : super(key: ConfigLiveGlobalkey.liveRtcKey);
  @override
  // ignore: no_logic_in_create_state
  PageLiveRTCState createState() => PageLiveRTCState(infoEntity: infoEntity);
}

class PageLiveRTCState extends State<PageLiveRTC>
    with EMMessageStatusListener, OnImLivePluginDelegate {
  ModelLiveInfoEntity? infoEntity;

  Future? _future;
  RtcEngineEventHandler? _rtcHandler;
  List animationSvga = [];
  bool _isShowInvite = false;
  PageLiveRTCState({this.infoEntity});
  EMMessage? _emMessage;
  bool _isShowGui = false;
  // List WidgetLiveVioceHeaderState
  String? _rtcToken;
  DataResult? _resultJoin;
  @override
  void onSuccess() {
    if (_emMessage != null) {
      if (_emMessage!.chatType == EMMessageChatType.ChatRoom &&
          _emMessage!.body is EMTextMessageBody) {
        EMTextMessageBody body = _emMessage!.body as EMTextMessageBody;
        ProviderLiveChatMessage messageProvider =
            Provider.of<ProviderLiveChatMessage>(context, listen: false);
        messageProvider.rtmAddMessage(
            ModelRtmMessage.fromJson(jsonDecode(body.content ?? '')));
        // ConfigLiveGlobalkey.inputViewKey.currentState?.sendMessageSuccess();
        ConfigLiveGlobalkey.inputWhiteViewKey.currentState
            ?.sendMessageSuccess();
        _emMessage!.setMessageListener(null);
        _emMessage = null;
      }
    }
    super.onSuccess();
  }

  @override
  void onError(EMError error) {
    DLog(error);
    if (error.code == 201) {
      EMClient.getInstance.login(
          ConfigLiveApp.FIRE_NAME + ProviderLiveUser().userInfo.uid.toString(),
          ConfigLiveApp.FIRE_NAME + ProviderLiveUser().userInfo.uid.toString());
    }
    super.onError(error);
  }

  @override
  Widget build(BuildContext context) {
    //  Navigator.pop(context);
    return Scaffold(
        backgroundColor: Colors.black,
        body: WillPopScope(
            child: GestureDetector(
                behavior: HitTestBehavior.opaque,
                onTap: () {
                  FocusScope.of(context).requestFocus(FocusNode());
                },
                child: Container(
                  decoration: BoxDecoration(
                      color: UtilsLiveColor.hexToColor('#1A0834'),
                      image: const DecorationImage(
                          alignment: Alignment.topCenter,
                          fit: BoxFit.fill,
                          image: AssetImage(
                              'lib/assets/images/icon_live_bg.png',
                              package: 'mmoo_live_room'))),
                  child: FutureBuilder(
                      future: _future,
                      builder: (BuildContext context, AsyncSnapshot snapshot) {
                        if (snapshot.connectionState == ConnectionState.done) {
                          if (snapshot.hasError == false) {
                            return PageLiveStreamer(
                              infoEntity: infoEntity!,
                              isShowGui: _isShowGui,
                              clickCallBack: (methon, data) {
                                clickBtnWithMethon(methon, data);
                              },
                            );
                          } else {
                            return Container();
                          }
                        } else {
                          return Center(
                            child: ConfigLiveApp.showSpinkit(),
                          );
                        }
                      }),
                )),
            onWillPop: () async => false));
  }

  clickBtnWithMethon(String methon, dynamic data) async {
    DLog(methon + '   \n' + data.toString());
    if (!mounted) {
      return;
    }
    if (KeyboardVisibilityController().isVisible) {
      FocusScope.of(context).requestFocus(FocusNode());
      if (methon == ConfigLiveMethon.liveInputSendMessage ||
          methon == ConfigLiveMethon.liveOpenMessageListPage) {
      } else {
        return;
      }
    }
    await Future.delayed(const Duration(milliseconds: 100));

    if (methon == ConfigLiveMethon.liveClickLeaveRoom) {
      if (infoEntity?.userId == ProviderLiveUser().userInfo.uid) {
        WidgetActionBtns.bottomSheet(
            context,
            WidgetLiveSetting(
              clickCallBack: clickBtnWithMethon,
            ));
      } else {
        UtilsLiveAlert.showCenterGeneral(context,
            isLive: true,
            leftStr: S.current.Live_Cancel,
            rightStr: S.current.Live_Yes, rightVoidCallBack: () async {
          userExitRoom();
        }, infoStr: S.current.Live_ExitRoomConfirm);
      }
    } else if (methon == ConfigLiveMethon.liveBottomGift) {
      WidgetLiveGiftList.showGiftListView(context,
          clickCallBack: clickBtnWithMethon, infoEntity: infoEntity!);
    } else if (methon == ConfigLiveMethon.liveBottomMic) {
      // if (data is bool) {

      if (ProviderLiveUser().voice != 0) {
        ModelLiveInfoPlaceList? placeList =
            UtilsLive.getOwenrPlaceInfo(infoEntity!);
        DataResult dataResult = await MainDao.livePostMuteFlushMike(
            status: ProviderLiveUser().voice == 1 ? 2 : 1,
            roomPlaceId: placeList?.roomPlaceId ?? 0,
            roomId: infoEntity?.roomId ?? 0);
        if (dataResult.result) {
          DLog(dataResult.data);
          //  final data1 = dataResult.data as BaseEntity;

          // BaseEntity data = dataResult as BaseEntity;
          updateBottomState(voice: dataResult.data);
        } else {
          UtilsLiveAlert.showDioTips(context, dataResult);
        }
        // getOwenrPlaceInf

      } else {
        CommonUtils.showToast('You are prohibited from using the microphone');
      }
    } else if (methon == ConfigLiveMethon.liveInputSendMessage) {
      if (data is String && data.isNotEmpty) {
        if (_emMessage != null) {
          _emMessage?.setMessageListener(null);
          _emMessage = null;
        }
        try {
          Map<String, dynamic> map = UtilsLive.rtmSendMessageMap(
              ConfigLiveSocket.liveSocketConfig_sendText, data);
          EMMessage message = EMMessage.createTxtSendMessage(
            username: infoEntity?.chatroomId ?? '',
            content: const JsonEncoder().convert(map),
          );
          message.chatType = EMMessageChatType.ChatRoom;
          _emMessage =
              await EMClient.getInstance.chatManager.sendMessage(message);
          _emMessage!.setMessageListener(this);
        } on EMError catch (e) {
          DLog('操作失败，原因是: $e');
        }
      }
    } else if (methon == ConfigLiveMethon.liveBottomCancel) {
      UtilsLiveAlert.showCenterGeneral(context,
          isLive: true,
          leftStr: S.current.Live_Cancel,
          rightStr: S.current.Live_Yes, rightVoidCallBack: () async {
        DataResult result =
            await MainDao.livePostCancelMike(roomId: (infoEntity!.roomId ?? 0));
        if (result.result && result.data != null) {
          updateBottomState(isApplyForMike: false);
          // ProviderLiveBottomState bottomState =
          // Provider.of<ProviderLiveBottomState>(context,
          // listen: false);
          // bottomState.isApplyForMike = false;
          // AgoraRtmManager.getInstance().sendLiveToPeerMessage(
          //     UtilsLive().rtmSendMessageMap(
          //         LiveSocketConfig.liveSocketConfig_cancelPlace, ''),
          //     (infoEntity?.userId ?? '').toString());
          // UtilsLive().rtmSendJoinPlaceMap(placeList: placeList));
        } else {
          UtilsLiveAlert.showDioTips(context, result);
        }
      }, infoStr: S.current.Live_Suretocancel);
    } else if (methon == ConfigLiveMethon.liveBottomJoin) {
      if (ProviderLiveUser().userInfo.uid == infoEntity?.userId) {
// ModelLiveGiftListGifts giftListGifts = ModelLiveGiftListGifts();
        // ConfigLiveGlobalkey.liveGiftShowKey.currentState?.beginAnimation(giftListGifts);
        // WidgetOwnerManagerBottom.showLiveUserList(context,
        // clickCallBack: clickBtnWithMethon, infoEntity: infoEntity!);
        WidgetActionBtns.bottomSheet(
            context,
            WidgetOwnerManager(
              infoEntity: infoEntity!,
              clickCallBack: clickBtnWithMethon,
            ));
      } else {
        if (ProviderLiveUser().isLiving) {
          UtilsLiveAlert.showCenterGeneral(context,
              isLive: true,
              leftStr: S.current.Live_Cancel,
              rightStr: S.current.Live_Yes, rightVoidCallBack: () async {
            // updateBottomState(isLiving: false);
            userRtcPostExitPlace();
          }, infoStr: S.current.Live_Areyoudisconnec);
        } else {
          if (ProviderLiveUser().isBlack) {
            UtilsLiveAlert.showCenterGeneral(context,
                isLive: true, infoStr: S.current.Live_BlackSeat);
            // WidgetActionBtns.showMimoLiveAlert(context,
            //     leftCallBack: () {}, infoString: S.current.Live_BlackSeat);
          } else {
            if (await UtilsLivePermission.checkPermission(
                context, Permission.microphone)) {
              if (await UtilsLivePermission.checkPermission(
                  context, Permission.camera)) {
                WidgetActionBtns.bottomSheet(
                    context,
                    WidgetLiveUserWaitList(
                      clickCallBack: clickBtnWithMethon,
                      infoEntity: infoEntity!,
                    ));
                // WidgetLivÍeJoinType.showLiveJoinType(context,
                // clickCallBack: clickBtnWithMethon, infoEntity: infoEntity!);
              }
            }
          }
        }
      }
    } else if (methon == ConfigLiveMethon.liveBottomPayJoinStream) {
      if (data is int) {
        if (infoEntity?.userId == ProviderLiveUser().userInfo.uid) {
          DataResult result = await MainDao.liveGetOnMike(
              roomId: (infoEntity!.roomId ?? 0), type: data);
          if (result.result && result.data != null) {
            ModelLiveInfoPlaceList placeList =
                ModelLiveInfoPlaceList().fromJson(result.data['newPlace']);
            await userRtcJoinPlace(placeList);
await Future.delayed(const Duration(microseconds: 300));
            await updateBottomState(
                isLiving: true,
                isSpeaker: true,
                chat: placeList.chat,
                voice: placeList.voice);
            // AgoraRtmManager.getInstance().sendLiveMessage(
            //     UtilsLive().rtmSendJoinPlaceMap(placeList: placeList));

          } else {
            UtilsLiveAlert.showDioTips(context, result);
          }
        } else {
          // liveBottomPayJoinStream
          DataResult result = await MainDao.livePostApplyForMike(
              roomId: (infoEntity!.roomId ?? 0), type: data);
          if (result.result && result.data != null) {
            updateBottomState(isApplyForMike: true);
            CommonUtils.showToast(S.current.Live_Youhavejoined);
          } else {
            BaseEntity baseEntity = result.data;
            if (baseEntity.code == '7507') {
              widget.methonDelegate.showRechargeblePage();
            } else {
              UtilsLiveAlert.showDioTips(context, result);
            }
          }
        }
      }
    } else if (methon == ConfigLiveMethon.liveBottomRank) {
      WidgetLiveApplylist.showLiveUserList(context,
          clickCallBack: clickBtnWithMethon, infoEntity: infoEntity!);
    } else if (methon == ConfigLiveMethon.liveBottomlLoudSpeaker) {
      updateBottomState(isSpeaker: !ProviderLiveUser().isSpeaker);
    } else if (methon == ConfigLiveMethon.liveBottomFilp) {
      //  美颜版本  有nana美颜库
      // if (await FUManager.isBuild()) {
      //   FUManager.switchCamera();
      // } else {
      //   RtcEngineManager.getInstance().getEngine()?.switchCamera();
      // }
      //   不带美颜
      RtcEngineManager.getInstance().getEngine()?.switchCamera();
      //
      if (infoEntity != null) {
        widget.infoEntity?.isSwitchCamera = !widget.infoEntity!.isSwitchCamera;
      }

      CommonUtils.showToast(S.current.Live_CameraSuccess);
    } else if (methon == ConfigLiveMethon.liveBottomBeauty) {
      //  美颜版本  有nana美颜库
      // Future.delayed(const Duration(milliseconds: 100)).then((value) {
      //   FUManagerView.showFaceUnityView(context);
      // });
      //
    } else if (methon == ConfigLiveMethon.liveClickUserInfo) {
      if (data is int) {
        WidgetLiveUserInfo.showUserInfoView(context,
            clickCallBack: clickBtnWithMethon,
            userId: data,
            infoEntity: infoEntity!);
      }
    } else if (methon == ConfigLiveMethon.liveHeaderFollow) {
      if (data) {
        careFollowRoom(data);
      } else {
        UtilsLiveAlert.showCenterGeneral(context,
            isLive: true,
            leftStr: S.current.Live_Cancel,
            rightStr: S.current.Live_Yes, rightVoidCallBack: () async {
          careFollowRoom(data);
        }, infoStr: S.current.Live_Confirmtounfollow);
      }
    } else if (methon == ConfigLiveSocket.liveSocketConfig_sendGift) {
      if (data is ModelRtmMessage) {
        ModelLiveGiftListGifts giftListGifts =
            ModelLiveGiftListGifts().fromJson(jsonDecode(data.content ?? ''));
        if (giftListGifts.id != null) {
          animationSvga.add(giftListGifts);
          _showSvga(animationSvga.first);
          widget.methonDelegate.updateMainUserMoney(
              ProviderLiveUser().userInfo.money.toString());
        }
      }
    } else if (methon == ConfigLiveMethon.liveExitRoom) {
      UtilsLiveAlert.showCenterGeneral(context,
          isLive: true,
          leftStr: S.current.Live_Cancel,
          rightStr: S.current.Live_Yes, rightVoidCallBack: () async {
        userExitRoom();
      }, infoStr: S.current.Live_ExitRoomConfirm);
    } else if (methon == ConfigLiveMethon.livePayPrivateRoom) {
      RtcEngineManager.getInstance()
          .getEngine()
          ?.muteAllRemoteAudioStreams(false);
      RtcEngineManager.getInstance()
          .getEngine()
          ?.muteAllRemoteVideoStreams(false);

      // await AgoraRtmManager.getInstance().sendLiveMessage(
      //     UtilsLive().rtmSendMessageMap(LiveSocketConfig.liveSocketConfig_joinPrivate, ''));
      int payNums = ProviderLiveOnline().payNum;
      payNums++;
      ProviderLiveOnline onlineProvider =
          Provider.of<ProviderLiveOnline>(context, listen: false);
      onlineProvider.payNum = payNums;
    } else if (methon == ConfigLiveMethon.liveClickPlcaeInfo) {
      if (data is ModelLiveInfoPlaceList) {
        if ((data.userId ?? 0) > 0) {
          if (data.type == 1 &&
              (infoEntity?.videoPlaceList ?? []).length == 1) {
            return;
          }
          if (data.userId == ProviderLiveUser().userInfo.uid) {
            // if (data.type != 1 &&
            //     (infoEntity?.videoPlaceList ?? []).length != 1) {
            UtilsLiveAlert.showCenterGeneral(context,
                isLive: true,
                leftStr: S.current.Live_Cancel,
                rightStr: S.current.Live_Yes, rightVoidCallBack: () async {
              updateBottomState(isLiving: false);
              userRtcPostExitPlace();
            }, infoStr: S.current.Live_Leavetheseat);
            // }
          } else {
            // if (data.type != 1 &&
            //     (infoEntity?.videoPlaceList ?? []).length != 1) {
            clickBtnWithMethon(
                ConfigLiveMethon.liveClickUserInfo, data.userId ?? 0);
          }
        } else {
          //主播点击自己的直播间的坑位
          if (infoEntity?.userId == ProviderLiveUser().userInfo.uid &&
              ProviderLiveUser().isLiving == false) {
            if (await UtilsLivePermission.checkPermission(
                context, Permission.microphone)) {
              if (await UtilsLivePermission.checkPermission(
                  context, Permission.camera)) {
                clickBtnWithMethon(
                    ConfigLiveMethon.liveBottomPayJoinStream, data.type);
              }
            }
          } else {
            if (ProviderLiveUser().isLiving == true) {
              CommonUtils.showToast(S.current.Live_Youcantchange);
            } else {
              //多人直播点击空位  弹出申请上麦
              if (await UtilsLivePermission.checkPermission(
                  context, Permission.microphone)) {
                if (await UtilsLivePermission.checkPermission(
                    context, Permission.camera)) {
                  WidgetActionBtns.bottomSheet(
                      context,
                      WidgetLiveUserWaitList(
                        clickCallBack: clickBtnWithMethon,
                        infoEntity: infoEntity!,
                      ));
                }
              }
            }
          }
        }
      }
    } else if (methon == ConfigLiveMethon.liveReport) {
      if (data is String) {
        widget.methonDelegate.showLiveReportPage(data);
      }
    } else if (methon == ConfigLiveMethon.liveOpenRechargPage ||
        methon == ConfigLiveMethon.liveBottomRecharge) {
      Future.delayed(const Duration(milliseconds: 300)).then((value) {
        widget.methonDelegate.showRechargeblePage();
      });
    } else if (methon == ConfigLiveMethon.liveOpenMessageListPage) {
      widget.methonDelegate.openIMMessageListPage();
    } else if (methon == ConfigLiveMethon.liveUserIMChat) {
      if (data is String) {
        widget.methonDelegate.showLiveIMChatPage(data);
      }
    } else if (methon == ConfigLiveMethon.liveUserCallVideo) {
      if (data is String) {
        widget.methonDelegate.showLiveCallVideoPage(data);
      }
    } else if (methon == ConfigLiveMethon.liveRefreshInfo) {
      await _getRoomInfo(false);
      if (mounted) {
        setState(() {});
      }

      CommonUtils.showToast(S.current.Live_Operationsucceeded);
    } else if (methon == ConfigLiveMethon.liveUpdataPlaceInfo) {
      if (data is ModelLiveInfoPlaceList) {
        ProviderLivePlaceListInfo placeProvider =
            Provider.of<ProviderLivePlaceListInfo>(context, listen: false);
        placeProvider.voiceList = infoEntity?.voicePlaceList ?? [];
        placeProvider.videoList = infoEntity?.videoPlaceList ?? [];
      }
    } else if (methon == ConfigLiveMethon.liveCloseLive) {
      UtilsLiveAlert.showCenterGeneral(context,
          isLive: true,
          leftStr: S.current.Live_Cancel,
          rightStr: S.current.Live_Yes, rightVoidCallBack: () async {
        DataResult dataResult =
            await MainDao.livePostStopLive(roomId: infoEntity?.roomId ?? 0);
        if (dataResult.result) {
          updataExitRoomPlaceId([], isAll: true);
          updateBottomState(isLiving: false, isApplyForMike: false);
          await userExitRoom();
        } else {
          UtilsLiveAlert.showDioTips(context, dataResult);
        }
      }, infoStr: S.current.Live_CloseRoomConfirm);
    } else if (methon == S.current.Live_operation1) {
      DataResult baseEntity = await MainDao.liveGetLastRoomInfo();
      if (baseEntity.result && baseEntity.data != null) {
        bool isDown = false;
        ModelLastLiveEntity lastLiveEntity =
            ModelLastLiveEntity().fromJson(baseEntity.data);
        lastLiveEntity.pricatePrice = (infoEntity?.price).toString();
        lastLiveEntity.chooseVideoPrice = (infoEntity?.videoPrice).toString();
        lastLiveEntity.chooseVoicePrice = (infoEntity?.voicePrice).toString();
        lastLiveEntity.liveNotice = infoEntity?.liveNotice;
        lastLiveEntity.micSeat =
            ((infoEntity?.voicePlaceList ?? []).length).toString();
        lastLiveEntity.videoSeat =
            ((infoEntity?.videoPlaceList ?? []).length).toString();
        WidgetBeginLiveVideoInfo.showVideoInfoView(context,
            clickCallBack: (methon, data) {
              if (methon == 'downSetting') {
                isDown = true;
              }
            },
            isRoomEdit: true,
            callback: (liveEntity) async {
              DLog("msg");
              DataResult dataResult = await MainDao.livePostLiveEdit(
                  language: liveEntity.language ?? '01',
                  liveNotice: liveEntity.liveNotice ?? '',
                  liveId: infoEntity?.liveId ?? 0,
                  roomId: infoEntity?.roomId ?? 0,
                  title: liveEntity.title ?? '',
                  videoPrice: int.parse(liveEntity.chooseVideoPrice),
                  price: int.parse(liveEntity.pricatePrice),
                  voicePrice: int.parse(liveEntity.chooseVoicePrice));
              if (dataResult.result) {
                ModelLiveInfoEntity entity = ModelLiveInfoEntity();
                entity.language = liveEntity.language;
                infoEntity?.language = liveEntity.language ?? '01';
                infoEntity?.title = liveEntity.title ?? '';
                infoEntity?.liveNotice = liveEntity.liveNotice ?? '';
                infoEntity?.price = int.parse(liveEntity.pricatePrice);
                infoEntity?.videoPrice = int.parse(liveEntity.chooseVideoPrice);
                infoEntity?.voicePrice = int.parse(liveEntity.chooseVoicePrice);
                ProviderLiveInfoEntity liveInfoEntity =
                    Provider.of<ProviderLiveInfoEntity>(context, listen: false);
                liveInfoEntity.infoEntity = infoEntity!;
                if (liveEntity.pricatePrice.isEmpty) {
                  ProviderLiveOnline onlineProvider =
                      Provider.of<ProviderLiveOnline>(context, listen: false);
                  onlineProvider.payNum = 0;
                }
              } else {
                UtilsLiveAlert.showDioTips(context, dataResult);
              }
            },
            lastLiveEntity: lastLiveEntity,
            animatComplete: () async {
              if (isDown) {}
            });
      } else {
        UtilsLiveAlert.showDioTips(context, baseEntity);
      }
    } else if (methon == S.current.Live_operation2) {
      WidgetLiveBlacklist.showLiveUserList(context,
          clickCallBack: clickBtnWithMethon, infoEntity: infoEntity!);
    } else if (methon == S.current.Live_operation3) {
      WidgetLiveFollowlist.showLiveUserList(context,
          clickCallBack: clickBtnWithMethon, infoEntity: infoEntity!);
    } else if (methon == ConfigLiveMethon.liveBottomMore) {
      WidgetActionBtns.bottomSheet(
          context, WidgetLiveMore(clickCallBack: clickBtnWithMethon));
      // WidgetLiveFollowlist.showLiveUserList(context,
      //     clickCallBack: clickBtnWithMethon, infoEntity: infoEntity!);
    } else if (methon == ConfigLiveMethon.liveRoomInformation) {
      WidgetActionBtns.bottomSheet(
          context,
          WidgetLiveRoomInfo(
              infoEntity: infoEntity!, clickCallBack: clickBtnWithMethon));
    } else if (methon == ConfigLiveMethon.liveRoomUserList) {
      WidgetActionBtns.bottomSheet(
          context,
          WidgetLiveGuestList(
              infoEntity: infoEntity!, clickCallBack: clickBtnWithMethon));
    } else if (methon == ConfigLiveMethon.livekickitofftheseat) {
      UtilsLiveAlert.showCenterGeneral(
        context,
        isLive: true,
        leftStr: S.current.Live_Cancel,
        rightStr: S.current.Live_Yes,
        rightVoidCallBack: () async {
          CommonUtils.showToast(S.current.Live_Operationsucceeded);
        },
        infoStr: S.current.Live_kickitofftheseat,
      );
    } else if (methon == ConfigLiveMethon.liveaddtofftheseat) {
    } else if (methon == ConfigLiveMethon.liveupdataOnlineNum) {
      if (data is int) {
        if (data != ProviderLiveOnline().onLineNum) {
          ProviderLiveOnline onlineProvider =
              Provider.of<ProviderLiveOnline>(context, listen: false);
          onlineProvider.onLineNum = data;
        }
      }
    } else if (methon == ConfigLiveMethon.liveupdatWait) {
      if (data is int) {
        if (data != ProviderLiveJoinPlace().applyNum) {
          ProviderLiveJoinPlace onlineProvider =
              Provider.of<ProviderLiveJoinPlace>(context, listen: false);
          onlineProvider.applyNum = data;
        }
      }
    } else if (methon == ConfigLiveMethon.liveOpenRechargPage) {
      widget.methonDelegate.openIMMessageListPage();
    }
  }

  Future initDataSource() async {
    DataResult result = await MainDao.livePostJoinRoom(roomId: widget.roomId);
    if (result.result && result.data != null) {
      _rtcToken = result.data['rtcToken'];
      if (result.data['roomUserId'] != null) {
        ProviderLiveUser.roomUserId = result.data['roomUserId'] is String
            ? int.tryParse(result.data['roomUserId'])
            : result.data['roomUserId'].toInt();
        ProviderLiveUser.roomId = widget.roomId;
        Future.delayed(const Duration(milliseconds: 500), () {
          updateBottomState(
              isLiving: ProviderLiveUser().isLiving,
              chat: result.data['chat'] is String
                  ? int.tryParse(result.data['chat'])
                  : result.data['chat'].toInt(),
              voice: result.data['voice'] is String
                  ? int.tryParse(result.data['voice'])
                  : result.data['voice'].toInt());
        });
      }

      if (infoEntity == null) {
        await _getRoomInfo(true);
        if (infoEntity?.chatroomId != null) {
          try {
            await EMClient.getInstance.chatRoomManager
                .joinChatRoom(infoEntity?.chatroomId ?? '');
            // EMClient.getInstance.addCustomListener(listener)
          } catch (e) {
            CommonUtils.showToast(S.current.strFailedpleaseAgain);
            DLog('joinChatRoomerror   $e');
            if (!kDebugMode) {
              Future.delayed(const Duration(seconds: 2), () {
                userExitRoom();
              });
            }
          }
        }
        _checkMounted();
        ProviderLiveOnline onlineProvider =
            Provider.of<ProviderLiveOnline>(context, listen: false);
        onlineProvider.onLineNum = (infoEntity?.onlineNums ?? 1);
        onlineProvider.payNum = 0;
        if ((infoEntity?.liveNotice ?? '').isNotEmpty) {
          ProviderLiveChatMessage messageProvider =
              Provider.of<ProviderLiveChatMessage>(context, listen: false);

          ModelRtmMessage message = ModelRtmMessage();
          message.content = infoEntity?.liveNotice;
          messageProvider.rtmAddMessage(message);
        }
        CommonUtils.dismiss();
        return;
      } else {
        if (Address.gui == false) {
          _isShowGui = true;
        }
        if (infoEntity?.chatroomId != null) {
          try {
            await EMClient.getInstance.chatRoomManager
                .joinChatRoom(infoEntity?.chatroomId ?? '');
          } catch (e) {
            DLog('joinChatRoomerror   $e');
            CommonUtils.showToast(S.current.strFailedpleaseAgain);
            if (!kDebugMode) {
              Future.delayed(const Duration(seconds: 2), () {
                userExitRoom();
              });
            }
          }
        }

        _checkMounted();
        ProviderLiveInfoEntity liveInfoEntity =
            Provider.of<ProviderLiveInfoEntity>(context, listen: false);
        liveInfoEntity.infoEntity = infoEntity!;

        ProviderLivePlaceListInfo placeProvider =
            Provider.of<ProviderLivePlaceListInfo>(context, listen: false);
        placeProvider.voiceList = infoEntity!.voicePlaceList ?? [];
        placeProvider.videoList = infoEntity!.videoPlaceList ?? [];

        ProviderLiveOnline onlineProvider =
            Provider.of<ProviderLiveOnline>(context, listen: false);
        onlineProvider.onLineNum = (infoEntity?.onlineNums ?? 1);
        onlineProvider.payNum = 0;
        // rtmConfig_refreshLiveInfo
        if ((infoEntity?.liveNotice ?? '').isNotEmpty) {
          ProviderLiveChatMessage messageProvider =
              Provider.of<ProviderLiveChatMessage>(context, listen: false);

          ModelRtmMessage message = ModelRtmMessage();
          message.content = infoEntity?.liveNotice;
          messageProvider.rtmAddMessage(message);
        }
        CommonUtils.dismiss();
        return;
      }
    } else {
      try {
        final baseEntity = result.data as BaseEntity;
        if (baseEntity.msg != null) {
          CommonUtils.showToast(baseEntity.msg ?? '');
        }
      } catch (e) {
        DLog(e);
      }

      await Future.delayed(const Duration(seconds: 2));
      Navigator.pop(context);
      CommonUtils.dismiss();
      return Future.error('error');
    }
  }

  // _showLivePricate() {
  //   RtcEngineManager.getInstance().getEngine()?.muteAllRemoteAudioStreams(true);
  //   RtcEngineManager.getInstance().getEngine()?.muteAllRemoteVideoStreams(true);
  //   _checkMounted();
  //   WidgetLivePricate.showVideoInfoView(context,
  //       clickCallBack: clickBtnWithMethon, infoEntity: infoEntity!);
  // }

  _checkMounted() {
    if (!mounted) {
      return;
    }
  }

  reConnectionIM() async {
    await _getRoomInfo(false);
    ModelLiveInfoPlaceList? placeList =
        UtilsLive.getOwenrPlaceInfo(infoEntity!);
    try {
      EMClient.getInstance.chatRoomManager
          .joinChatRoom(infoEntity?.chatroomId ?? '');
    } catch (e) {
      DLog(e);
    }
    if (placeList != null) {
      if (ProviderLiveUser().isLiving == false) {
        await userRtcJoinPlace(placeList);
        await Future.delayed(const Duration(microseconds: 300));
        await updateBottomState(
            chat: placeList.chat,
            isLiving: true,
            isApplyForMike: false,
            voice: placeList.voice,
            isSpeaker: true);
      }
    }
    if (mounted) {
      setState(() {});
    }
  }

  Future _getRoomInfo(bool isPop) async {
    if (!mounted) {
      return;
    }
    DataResult dataResult =
        await MainDao.livePostRoomInfo(roomId: widget.roomId);
    if (dataResult.result && dataResult.data != null) {
      infoEntity = ModelLiveInfoEntity().fromJson(dataResult.data);
      // infoEntity?.userId = 12;
      if (infoEntity?.userId == ProviderLiveUser().userInfo.uid) {
        infoEntity?.role = 0;
      } else {
        infoEntity?.role = 2;
      }
      _checkMounted();
      ProviderLiveInfoEntity liveInfoEntity =
          Provider.of<ProviderLiveInfoEntity>(context, listen: false);
      liveInfoEntity.infoEntity = infoEntity!;
      ProviderLivePlaceListInfo placeProvider =
          Provider.of<ProviderLivePlaceListInfo>(context, listen: false);
      placeProvider.voiceList = infoEntity!.voicePlaceList ?? [];
      placeProvider.videoList = infoEntity!.videoPlaceList ?? [];
      // if ((infoEntity?.price ?? 0) > 0 && infoEntity?.isUnlock == 0) {
      //   _showLivePricate();
      // }
      if (isPop && (infoEntity?.roomId ?? 0) > 0) {
        getRoomUserList();
      }
      // }

      return;
    } else {
      if (isPop) {
        widget.methonDelegate
            .updateMainUserMoney(ProviderLiveUser().userInfo.money.toString());
        _checkMounted();
        if (PageLiveRoot.popUntilName != null &&
            (PageLiveRoot.popUntilName ?? '').isEmpty) {
          Navigator.popUntil(
              context, ModalRoute.withName((PageLiveRoot.popUntilName ?? '')));
        } else {
          Navigator.of(context).popUntil((route) {
            DLog((route.settings.name ?? '').startsWith(PageLiveRoot.name));
            return (route.settings.name ?? '').startsWith(PageLiveRoot.name);
          });
          await Future.delayed(const Duration(milliseconds: 40)).then((value) {
            Navigator.pop(context);
          });
        }
        // Navigator.of(context).popUntil((route) {
        //   DLog(route.settings.name);
        //   return (route.settings.name ?? '').startsWith(PageLiveRoot.name);
        // });
        // Future.delayed(const Duration(milliseconds: 40)).then((value) {
        //   DLog("vadsvhasdkh");
        //   Navigator.pop(context);
        // });
      }

      return Future.error('error');
    }
  }

  //rtc回调事件
  _addAgoraRtCEventHandlers() {
    _rtcHandler = RtcEngineEventHandler(
        audioVolumeIndication: (List<AudioVolumeInfo> info, int count) {
          if (ProviderLiveUser().isLiving) {
            for (var element in info) {
              if (element.uid == 0) {
                element.uid = (ProviderLiveUser().userInfo.uid ?? 0);
              }
            }
          }

          if (infoEntity?.type == 0) {
            for (var element in info) {
              // DLog(element.volume);
              ConfigLiveGlobalkey.streamVoiceKey.currentState?.vioceHeaderMap
                  .forEach((key, value) {
                if (element.uid == key) {
                  value.currentState?.liveVolumeIndication(element);
                }
              });
            }
          } else {
            if ((infoEntity?.videoPlaceList ?? []).length > 1) {
              for (var element in info) {
                ConfigLiveGlobalkey.streamvideoKey.currentState?.videoVolumMap
                    .forEach((key, value) {
                  if (element.uid == key) {
                    value.currentState?.liveVolumeIndication(element);
                  }
                });
              }
            }
            if ((infoEntity?.voicePlaceList ?? []).length > 1) {
              for (var element in info) {
                // DLog(element.volume);
                ConfigLiveGlobalkey
                    .streamvideoVoiceKey.currentState?.vioceVolumMap
                    .forEach((key, value) {
                  if (element.uid == key) {
                    value.currentState?.liveVolumeIndication(element);
                  }
                });
              }
            }
          }
        },
        error: (code) async {
          final info = 'onError: $code';
          DLog(info);
          if (code == ErrorCode.JoinChannelRejected) {
          } else if (code == ErrorCode.LeaveChannelRejected) {
          } else {
            // await exituserRoom(false);
          }
          DLog("AgoraRtC" + code.toString());
        },
        tokenPrivilegeWillExpire: (token) async {
          String? rtctoken =
              await MainDao.getRtcToken(widget.roomId.toString()).then((res) {
            if (res.result) {
              return res.data;
            } else {
              return null;
            }
          });
          if ((rtctoken ?? '').isNotEmpty) {
            RtcEngineManager.getInstance().getEngine()?.renewToken(rtctoken!);
          }
        },
        remoteVideoStats: (stats) {
          DLog('remoteVideoStats   ${stats.toJson()}');
        },
        localVideoStats: (stats) {
          DLog('localVideoStats   ${stats.toJson()}');
        },
        rejoinChannelSuccess: (channel, uid, elapsed) async {
          final info = 'rejoinChannelSuccess: $channel, uid: $uid';
          DLog("AgoraRtC" + info);
        },
        joinChannelSuccess: (channel, uid, elapsed) {
          //声网加入房间成功

          final info = 'AgoraRtC onJoinChannel: $channel, uid: $uid';

          DLog(info);

          // DLog(info);
        },
        connectionStateChanged:
            (ConnectionStateType type, ConnectionChangedReason reason) {
          DLog('connectionStateChanged   $reason');
          if (type == ConnectionStateType.Failed) {
            userExitRoom();
          }
        },
        leaveChannel: (stats) {
          DLog('AgoraRtC onLeaveChannel');
          DLog(stats);
        },
        userJoined: (uid, elapsed) async {
          //用户加入

          final info = 'AgoraRtC  userJoined: $uid, uid: $elapsed';

          DLog(info);
        },
        userOffline: (uid, elapsed) {
          //用户下麦

          final info = 'AgoraRtC  userOffline: $uid';
          DLog(info);
          //连麦用户下麦  刷新本地坑位信息
          if (uid > 0) {
            ModelLiveInfoPlaceList? placeList;
            infoEntity?.voicePlaceList?.forEach((element) {
              if (uid == element.userId) {
                placeList = element;
              }
            });
            infoEntity?.videoPlaceList?.forEach((element) {
              if (uid == element.userId) {
                placeList = element;
              }
            });
            if (placeList != null) {
              updataExitRoomPlaceId([placeList?.roomPlaceId ?? 0]);
            }

            // updataExitRoomPlaceId
          }
        },
        firstRemoteVideoFrame: (uid, width, height, elapsed) {
          final info = 'AgoraRtC firstRemoteVideo: $uid ${width}x $height';
          DLog(info);
        },
        clientRoleChanged: (oldRole, newRole) {
          DLog(newRole == ClientRole.Broadcaster
              ? "newRole  Broadcaster"
              : "newRole  A");
          DLog(oldRole == ClientRole.Broadcaster
              ? "oldRole  Broadcaster"
              : "oldRole  A");
        },
        warning: (warnCode) {
          DLog("AgoraRtC warnCode $warnCode");
          if (warnCode == WarningCode.OpenChannelTimeout ||
              warnCode == WarningCode.NoAvailableChannel ||
              warnCode == WarningCode.OpenChannelRejected ||
              warnCode == WarningCode.LookupChannelTimeout ||
              warnCode == WarningCode.OpenChannelInvalidTicket ||
              warnCode == WarningCode.AdmGlitchState ||
              warnCode == WarningCode.SuperResolutionDeviceNotSupported) {
            // updateBottomState(isLiving: false, isApplyForMike: false);
            CommonUtils.showToast('Sorry, please try again later!');
            userRtcPostExitPlace();
          }
        },
        apiCallExecuted: (error, api, result) {
          DLog("apiCallExecuted $error  $api    $result");
        },
        streamMessageError: (uid, streamId, error, missed, cached) {
          DLog(
              "streamMessageError $uid  $streamId    $error   $missed   $cached");
        },
        userEnableVideo: (uid, enabled) {
          DLog('userEnableVideo $uid, $enabled ');
        },
        connectionLost: () async {
          DLog('connectionLost ');
          CommonUtils.showToast('Sorry, please try again later!');
          await userRtcPostExitPlace();
          await updateBottomState(isLiving: false);
          //网络连接丢失回调  RtcChannel.joinChannel 后，无论是否加入成功，只要 10 秒和服务器无法连接就会触发该回调。
          // if (ProviderLiveUser().isLiving) {
          // userRtcPostExitPlace
          // }
        },
        firstLocalVideoFramePublished: (int elapsed) {},
        firstLocalVideoFrame: (int width, int height, int elapsed) {
          //  美颜版本  有nana美颜库
          if (widget.infoEntity?.isSwitchCamera == true) {
            // FUManager.switchCamera();
            //   不带美颜
            RtcEngineManager.getInstance().getEngine()?.switchCamera();
            //
          }
        });
    RtcEngineManager.getInstance().getEngine()?.setEventHandler(_rtcHandler!);
  }

  _showSvga(ModelLiveGiftListGifts giftListGifts) {
    if (animationSvga.length > 1) {
      return;
    }
    _checkMounted();
    UtilsLiveAlert.showSvgaPlayerAnimation(context,
        resUrl: giftListGifts.gifUrl,
        assetsName: giftListGifts.name, voidCallBack: () {
      animationSvga.remove(giftListGifts);
      if (animationSvga.isNotEmpty) {
        _showSvga(animationSvga.first);
      }
    });
  }

  //rtm回调事件
  _addLiveSocketEventHandlers() {
// LiveSocketEventHandler
    // AgoraRtmManager.getInstance().
    LiveSocketEventHandler handler = LiveSocketEventHandler(
      // onUserExitLiveBla
      //用户加入直接间

      onUserJoinLiveBlack: (ModelRtmMessage message) {
        _checkMounted();
        ProviderLiveChatMessage messageProvider =
            Provider.of<ProviderLiveChatMessage>(context, listen: false);
        messageProvider.rtmAddMessage(message);
        DLog('+++++');
        int onlineNums = ProviderLiveOnline().onLineNum;
        onlineNums++;

        ProviderLiveOnline onlineProvider =
            Provider.of<ProviderLiveOnline>(context, listen: false);
        onlineProvider.onLineNum = onlineNums;
        ModelLiveUserListUsers users = ModelLiveUserListUsers();
        users.headImage = message.headImage;
        users.userId = int.parse(message.userId ?? '0');
        ProviderLiveHeaderUser userProvider =
            Provider.of<ProviderLiveHeaderUser>(context, listen: false);
        userProvider.roomJoinUser(users);
      },
      //用户退出直播间
      onUserExitLiveBlack: (ModelRtmMessage message) {
        DLog('------');
        _checkMounted();
        int onlineNums = ProviderLiveOnline().onLineNum;
        if (onlineNums > 1) {
          ProviderLiveOnline onlineProvider =
              Provider.of<ProviderLiveOnline>(context, listen: false);
          onlineNums--;
          onlineProvider.onLineNum = onlineNums;
        }
      },

      //接收到用户发送的群聊消息
      onUserSendTextBlack: (ModelRtmMessage message) {
        _checkMounted();
        ProviderLiveChatMessage messageProvider =
            Provider.of<ProviderLiveChatMessage>(context, listen: false);
        messageProvider.rtmAddMessage(message);
      },

      //收到管理员 邀请上麦消息
      onMasterInviteJoinPlaceBlack: (ModelRtmMessage message) {
        _checkMounted();
        if (ProviderLiveUser().isLiving == false) {
          if (_isShowInvite) {
            return;
          }
          _isShowInvite = true;
          UtilsLiveAlert.showCenterGeneral(
            context,
            barrierDismissible: false,
            isLive: true,
            leftStr: 'Refuse',
            rightStr: 'Agree',
            leftVoidCallBack: () {
              MainDao.livePostUserRefuseConnect(
                  roomId: infoEntity?.roomId ?? 0);
              // AgoraRtmManager.getInstance().sendLiveToPeerMessage(
              //     UtilsLive().rtmSendMessageMap(
              //         LiveSocketConfig.liveSocketConfig_RefusePlace, ''),
              //     infoEntity!.userId.toString());
              // infoEntity!.userId.toString()
            },
            rightVoidCallBack: () async {
              if (await UtilsLivePermission.checkPermission(
                  context, Permission.microphone)) {
                if (await UtilsLivePermission.checkPermission(
                    context, Permission.camera)) {
                  DataResult dataResult = await MainDao.livePostUserOnMike(
                      roomId: infoEntity?.roomId ?? 0,
                      placeType: 1,
                      type: message.content == null
                          ? 0
                          : int.parse(message.content ?? '0'));
                  if (dataResult.result && dataResult.data != null) {
                    ModelLiveInfoPlaceList placeList = ModelLiveInfoPlaceList()
                        .fromJson(dataResult.data['newPlace']);

                    if (placeList.roomPlaceId != null) {
                      await userRtcJoinPlace(placeList);
                      Future.delayed(const Duration(microseconds: 300),
                          () async {
                        await updateBottomState(
                            chat: placeList.chat,
                            isLiving: true,
                            isApplyForMike: false,
                            voice: placeList.voice,
                            isSpeaker: true);
                      });

                      // AgoraRtmManager.getInstance().sendLiveMessage(
                      //     UtilsLive()
                      //         .rtmSendJoinPlaceMap(placeList: placeList));

                    }
                  } else {
                    BaseEntity baseEntity = dataResult.data;
                    if (baseEntity.code == '7507') {
                      widget.methonDelegate.showRechargeblePage();
                    } else {
                      UtilsLiveAlert.showDioTips(context, dataResult);
                    }
                  }
                }
              }
            },
            infoStr: S.current.Live_invitesjointhe(
                message.name ?? '', message.content == '0' ? 'voice' : 'video'),
          ).then((value) => _isShowInvite = false);
        }
      },
      // onMasterOperationExitPlace: (ModelRtmMessage message) {
      //   updateBottomState(isLiving: false);
      //   userRtcPostExitPlace();
      // },
      //用户是否被拉黑  content 为1 是被拉黑
      onUserLiveBlackBlack: (ModelRtmMessage message) async {
        // if (message.content == "1") {

        // }

        if (message.content == "0") {
          updateBottomState(
              isLiving: false,
              isApplyForMike: false,
              voice: 0,
              chat: 0,
              isBlack: true);
          await userRtcPostExitPlace();
        } else {
          updateBottomState(voice: 1, chat: 1, isBlack: false);
        }

        // ProviderLiveUser liveUser =
        //     Provider.of<ProviderLiveUser>(context, listen: false);
        // liveUser.isBlack = message.content == "1";
        // liveUser.chat = message.content == "1" ? 0 : 1;
        // liveUser.voice = message.content == "1" ? 0 : 1;
      },
      //主播收到用户上麦申请
      onMasterApplyJoinPlaceBlack: (ModelRtmMessage message) {
        _checkMounted();
        ProviderLiveJoinPlace joinPlace =
            Provider.of<ProviderLiveJoinPlace>(context, listen: false);
        joinPlace.applyNum = (ProviderLiveJoinPlace().applyNum + 1);
        ConfigLiveGlobalkey.applyViewKey.currentState?.refreshController
            .requestRefresh();
      },
      //用户收到主播是否同意上麦
      onMasterIsAgreeJoibPlaceBlack: (
        ModelRtmMessage message,
      ) async {
        _checkMounted();
        Map map = Map<String, dynamic>.from(jsonDecode(message.content ?? ''));
        if (map.containsKey("isAgree") && map['isAgree'] == 1) {
          if (ProviderLiveUser().isLiving == false) {
            DataResult dataResult = await MainDao.livePostUserOnMike(
                roomId: infoEntity?.roomId ?? 0,
                placeType: 0,
                type: map['type']);
            if (dataResult.result && dataResult.data != null) {
              ModelLiveInfoPlaceList placeList = ModelLiveInfoPlaceList()
                  .fromJson(dataResult.data['newPlace']);
              if (placeList.roomPlaceId != null) {
                try {
                  await userRtcJoinPlace(placeList);
                  // ignore: empty_catches
                } catch (e) {}
                await Future.delayed(const Duration(microseconds: 300));
                updateBottomState(
                    voice: placeList.voice,
                    chat: placeList.chat,
                    isLiving: true);
              }
              Map map = dataResult.data;
              if (map.containsKey('coins')) {
                updataUserMoney(map['coins'].toString());
              }
            } else {
              UtilsLiveAlert.showDioTips(context, dataResult);
            }
            updateBottomState(isApplyForMike: false);
          }
        } else {
          updateBottomState(isApplyForMike: false);
          CommonUtils.showToast(S.current.Live_Thelivemanagerrefused);
        }
      },
      onUserIsBanMicrophoneBlack: (ModelRtmMessage message) {
        // if (roomId != ProviderLiveUser.roomId.toString()) {
        //   return;
        // }
        _checkMounted();
        //是否禁麦克风
        Map<String, dynamic> map = jsonDecode(message.content ?? '');
        if (map.containsKey('roomPlaceId')) {
          ModelLiveInfoPlaceList placeList =
              ModelLiveInfoPlaceList().fromJson(map);
          for (var element in (infoEntity?.voicePlaceList ?? [])) {
            if (element.roomPlaceId == placeList.roomPlaceId) {
              element.voice = placeList.voice;
              placeList = element;
            }
          }
          for (var element in (infoEntity?.videoPlaceList ?? [])) {
            if (element.roomPlaceId == placeList.roomPlaceId) {
              element.voice = placeList.voice;
              placeList = element;
            }
          }
          updataPlaceModel(placeList);
          if (placeList.userId == ProviderLiveUser().userInfo.uid) {
            DLog(placeList.voice != 1);
            RtcEngineManager.getInstance()
                .getEngine()
                ?.muteLocalAudioStream(placeList.voice != 1);
            ProviderLiveUser userProvider =
                Provider.of<ProviderLiveUser>(context, listen: false);
            userProvider.voice = placeList.voice ?? 1;
          }
        }
      },

      onUserIsBannedBlack: (ModelRtmMessage message) {
        //是否禁群聊
        _checkMounted();
        ProviderLiveUser userProvider =
            Provider.of<ProviderLiveUser>(context, listen: false);
        userProvider.chat = message.content == '1' ? 1 : 0;
      },
      onMasterCloseLiveBlack: (ModelRtmMessage message) {
        //主播关闭了直播间
        //下麦操作
        updateBottomState(isLiving: false, isApplyForMike: false);
        _checkMounted();
        // updataExitRoomPlaceId([], isAll: true);
        ProviderLivePlaceListInfo placeProvider =
            Provider.of<ProviderLivePlaceListInfo>(context, listen: false);
        placeProvider.voiceList = [];
        placeProvider.videoList = [];
        infoEntity?.videoPlaceList = [];
        infoEntity?.voicePlaceList = [];
        if (mounted) {
          setState(() {});
        }
      },
      //收到送礼信息
      onUserSendGiftBlack: (ModelRtmMessage message) {
        ConfigLiveGlobalkey.liveGiftShowKey.currentState
            ?.beginAnimation(message);
        _checkMounted();
        ProviderLiveChatMessage messageProvider =
            Provider.of<ProviderLiveChatMessage>(context, listen: false);
        messageProvider.rtmAddMessage(message);

        ModelLiveGiftListGifts giftListGifts = ModelLiveGiftListGifts()
            .fromJson(jsonDecode(message.content ?? ''));
        if (giftListGifts.id != null) {
          for (var i = 0; i < (infoEntity?.videoPlaceList ?? []).length; i++) {
            giftListGifts.giveGiftUserInfoList?.forEach((element) {
              if (element.userId == infoEntity?.videoPlaceList?[i].userId) {
                infoEntity?.videoPlaceList?[i].giftNum =
                    (infoEntity?.videoPlaceList?[i].giftNum ?? 0) +
                        int.parse(giftListGifts.num ?? '0');
              }
            });
          }
          for (var i = 0; i < (infoEntity?.voicePlaceList ?? []).length; i++) {
            giftListGifts.giveGiftUserInfoList?.forEach((element) {
              if (element.userId == infoEntity?.voicePlaceList?[i].userId) {
                infoEntity?.voicePlaceList?[i].giftNum =
                    (infoEntity?.voicePlaceList?[i].giftNum ?? 0) +
                        int.parse(giftListGifts.num ?? '0');
              }
            });
          }
          ProviderLivePlaceListInfo placeProvider =
              Provider.of<ProviderLivePlaceListInfo>(context, listen: false);
          placeProvider.videoList = infoEntity?.videoPlaceList ?? [];
          placeProvider.voiceList = infoEntity?.voicePlaceList ?? [];
        }
        // LiveSocketConfig.liveSocketConfig_sendGift
        // clickBtnWithMethon(LiveSocketConfig.liveSocketConfig_sendGift, message);
      },

      //收到用户上麦数据
      onUserJoinPlaceBlack: (ModelRtmMessage message) {
        Map<String, dynamic> map = jsonDecode(message.content ?? '');
        if (map.containsKey('roomPlaceId')) {
          ModelLiveInfoPlaceList placeList =
              ModelLiveInfoPlaceList().fromJson(map);
          updataPlaceModel(placeList);
        }
      },
      //用户退出连麦
      onUserExitPlaceBlack: (ModelRtmMessage message) {
        if (message.content != null) {
          Map<String, dynamic> map = jsonDecode(message.content ?? '');

          if (map.containsKey('roomPlaceId')) {
            ModelLiveInfoPlaceList placeList =
                ModelLiveInfoPlaceList().fromJson(map);
            for (var element in (infoEntity?.voicePlaceList ?? [])) {
              if (element.roomPlaceId == placeList.roomPlaceId) {
                placeList = element;
              }
            }
            for (var element in (infoEntity?.videoPlaceList ?? [])) {
              if (element.roomPlaceId == placeList.roomPlaceId) {
                placeList = element;
              }
            }
            if (placeList.userId == ProviderLiveUser().userInfo.uid) {
              updateBottomState(isLiving: false, isApplyForMike: false);
            }

            updataExitRoomPlaceId([
              placeList.roomPlaceId ?? 0
              // map['roomPlaceId'] is String
              //     ? int.parse(map['roomPlaceId'])
              //     : map['roomPlaceId'].toInt()
            ]);
          }
          // if (int.parse(message.content!) > 0) {
          // updataExitRoomPlaceId([int.parse(message.content!)]);
          // }
        }
      },
      //用户付费进入付费直播间
      onUserJoinPrivateBlack: (ModelRtmMessage message) {
        _checkMounted();
        int payNums = ProviderLiveOnline().payNum;
        payNums++;
        ProviderLiveOnline onlineProvider =
            Provider.of<ProviderLiveOnline>(context, listen: false);
        onlineProvider.payNum = payNums;
      },
      //收到房主改变直播通知
      onLiveNoticeBlack: (ModelRtmMessage message) {
        _checkMounted();
        if (message.content != null) {
          infoEntity?.liveNotice = message.content;
          ProviderLiveInfoEntity liveProvider =
              Provider.of<ProviderLiveInfoEntity>(context, listen: false);
          // messageProvider.rtmAddMessage(message);
          liveProvider.infoEntity = infoEntity!;
        }
      },
      onUserLiveInfoBlack: (ModelRtmMessage message) {
        _checkMounted();
        if (message.content != null) {
          Map<String, dynamic> map = jsonDecode(message.content ?? '');
          if (map.containsKey('price')) {
            ModelLiveInfoEntity infoRtmEntity =
                ModelLiveInfoEntity().fromJson(map);
            // if ((infoRtmEntity.price ?? 0) > 0 &&
            //     (infoRtmEntity.price ?? 0).toInt() !=
            //         (infoEntity?.price ?? 0).toInt()) {
            //   _showLivePricate();
            // }
            infoEntity?.language = infoRtmEntity.language ?? '01';
            infoEntity?.title = infoRtmEntity.title ?? '';
            infoEntity?.liveNotice = infoRtmEntity.liveNotice ?? '';
            infoEntity?.price = infoRtmEntity.price;
            infoEntity?.videoPrice = infoRtmEntity.videoPrice;
            infoEntity?.voicePrice = infoRtmEntity.voicePrice;
            ProviderLiveInfoEntity liveInfoEntity =
                Provider.of<ProviderLiveInfoEntity>(context, listen: false);
            liveInfoEntity.infoEntity = infoEntity!;
          }
        }
      },
      onUserRefreshLiveInfoBlack: (ModelRtmMessage message) async {
        await _getRoomInfo(false);

        if (mounted) {
          setState(() {});
        }
      },

      onMasterSetPriceBlack: (ModelRtmMessage message) async {
        if ((message.content ?? '').isNotEmpty) {
          CommonUtils.showToast(message.content ?? '');
        }
        updateBottomState(isApplyForMike: false);
      },
      onUserLiveCancelPlaceBlack: (ModelRtmMessage message) {
        _checkMounted();
        if (ProviderLiveJoinPlace().applyNum > 0) {
          ProviderLiveJoinPlace joinPlace =
              Provider.of<ProviderLiveJoinPlace>(context, listen: false);
          joinPlace.applyNum = (ProviderLiveJoinPlace().applyNum - 1);
        }
      },
      onUserLiveRefusePlaceBlack: (ModelRtmMessage message) {
        CommonUtils.showToast('Refuse Invitation');
        // updateBottomState(isApplyForMike: false);
      },
    );
    widget.methonDelegate.setImSocketMessageHandler(handler);

    widget.methonDelegate.setOnConnection(this);

    // IMSocketUtils.instance.setLiveSocketEventHandler(handler);
  }

  initCreateRtcManager() async {
    if (RtcEngineManager.getInstance().getEngine() == null) {
      await RtcEngineManager.getInstance()
          .creatEngine(ConfigLiveApp.agoraAppKey);
    }
    _addAgoraRtCEventHandlers();
    if ((_rtcToken ?? '').isEmpty) {
      _rtcToken =
          await MainDao.getRtcToken(widget.roomId.toString()).then((res) {
        if (res.result) {
          return res.data;
        } else {
          return null;
        }
      });
    }
    // RtcEngineManager.getInstance().getEngine()?.
    await RtcEngineManager.getInstance().getEngine()?.joinChannel(
        _rtcToken,
        (infoEntity?.roomId).toString(),
        null,
        ProviderLiveUser().userInfo.uid ?? 0);
    RtcEngineManager.getInstance()
        .getEngine()
        ?.enableAudioVolumeIndication(1000, 3, false);

    _addLiveSocketEventHandlers();

    if (ProviderLiveUser().isLiving &&
        infoEntity?.userId == ProviderLiveUser().userInfo.uid) {
      if (infoEntity?.type == 0) {
        await RtcEngineManager.getInstance()
            .openVoiceLive((infoEntity?.roomId).toString());
      } else {
        // RtcEngineManager.getInstance().getEngine().setEventHandler(handler);
        await RtcEngineManager.getInstance()
            .openVideoLive((infoEntity?.roomId).toString());
      }
    }
  }

  careFollowRoom(dynamic data) async {
    _checkMounted();
    DataResult dataResult = await MainDao.livePostCareRoom(
        isCareType: data, roomId: infoEntity?.roomId ?? 0);
    if (dataResult.result) {
      infoEntity?.follow = data ? 1 : 0;
      ProviderLiveInfoEntity liveInfoEntity =
          Provider.of<ProviderLiveInfoEntity>(context, listen: false);
      liveInfoEntity.infoEntity = infoEntity!;
      if (infoEntity?.follow == 1) {
        CommonUtils.showToast('Followed, Thanks!');
      }
    } else {
      UtilsLiveAlert.showDioTips(context, dataResult);
    }
  }

  // Future<void> initFaceUnity() async {
  //   // RtcEngineManager.getInstance().getEngine()?.destroy();
  //   return;
  // }

  ///用户退出直播间
  Future userExitRoom() async {
    CommonUtils.showLoading();
    try {
      if (infoEntity?.chatroomId != null) {
        EMConversation? conversation = await EMClient.getInstance.chatManager
            .getConversation(infoEntity?.chatroomId ?? '',
                EMConversationType.ChatRoom, false);
        conversation?.markAllMessagesAsRead();

        await EMClient.getInstance.chatRoomManager
            .leaveChatRoom(infoEntity?.chatroomId ?? '');
      }

      // EMClient.getInstance.chatRoomManager.removeChatRoomListener(this);
    } catch (e) {
      DLog(e);
    }

    await updateBottomState(
        chat: 1,
        voice: 1,
        isLiving: false,
        isSpeaker: true,
        isApplyForMike: false,
        isBlack: false);
    _checkMounted();
    widget.methonDelegate
        .updateMainUserMoney(ProviderLiveUser().userInfo.money.toString());
    try {
      await userRtcPostExitPlace();
      // await _liveRepository.apiLiveExitRoom(roomId: infoEntity?.roomId ?? 0);
      await MainDao.livePostExitRoom(roomId: infoEntity?.roomId ?? 0);
      await disposeAgoraExitRoom();
      // await FUManager.stopCapture();
      await RtcEngineManager.getInstance().resetRtCClient();
      // resetRtCClient
    } catch (e) {
      DLog(e);
    }

    if (PageLiveRoot.popUntilName != null &&
        (PageLiveRoot.popUntilName ?? '').isEmpty) {
      Navigator.popUntil(
          context, ModalRoute.withName((PageLiveRoot.popUntilName ?? '')));
    } else {
      Navigator.of(context).popUntil((route) {
        DLog((route.settings.name ?? '').startsWith(PageLiveRoot.name));
        return (route.settings.name ?? '').startsWith(PageLiveRoot.name);
      });
      await Future.delayed(const Duration(milliseconds: 40)).then((value) {
        Navigator.pop(context);
      });
    }

    CommonUtils.dismiss();
    return;
  }

//退出直播间 清理数据
  Future disposeAgoraExitRoom() async {
    ProviderLiveChatMessage().removeChatMessages();
    ProviderLiveOnline().restoreInitialization();
    ProviderLiveJoinPlace().applyNum = 0;
    ProviderLiveHeaderUser().removeRoomUsers();
    await RtcEngineManager.getInstance().getEngine()?.leaveChannel();
  }

//用户上麦 rtc操作
  Future<void> userRtcJoinPlace(ModelLiveInfoPlaceList placeList) async {
    if (placeList.type == 0) {
      await RtcEngineManager.getInstance()
          .openVoiceLive((infoEntity?.roomId).toString());
    } else {
      // if (await FUManager.startCapture()) {
      await RtcEngineManager.getInstance()
          .openVideoLive((infoEntity?.roomId).toString());
    }
    Future.delayed(const Duration(milliseconds: 300), () {
      updataPlaceModel(placeList);
    });
  }

//106895
  updataPlaceModel(ModelLiveInfoPlaceList placeList) {
    _checkMounted();
    for (var i = 0; i < (infoEntity?.voicePlaceList ?? []).length; i++) {
      ModelLiveInfoPlaceList placeModel = infoEntity!.voicePlaceList![i];
      if (placeModel.roomPlaceId?.toInt() == placeList.roomPlaceId?.toInt()) {
        infoEntity?.voicePlaceList?[i] = placeList;
      }
    }

    for (var i = 0; i < (infoEntity?.videoPlaceList ?? []).length; i++) {
      ModelLiveInfoPlaceList placeModel = infoEntity!.videoPlaceList![i];
      if (placeModel.roomPlaceId?.toInt() == placeList.roomPlaceId?.toInt()) {
        infoEntity?.videoPlaceList?[i] = placeList;
      }
    }

    ProviderLivePlaceListInfo placeProvider =
        Provider.of<ProviderLivePlaceListInfo>(context, listen: false);
    placeProvider.voiceList = infoEntity!.voicePlaceList ?? [];
    placeProvider.videoList = infoEntity!.videoPlaceList ?? [];
  }

  updataExitRoomPlaceId(List<int> roomPlaceIds, {bool? isAll = false}) {
    for (var i = 0; i < (infoEntity?.voicePlaceList ?? []).length; i++) {
      if (isAll == true) {
        infoEntity?.voicePlaceList?[i].userId = null;
        infoEntity?.voicePlaceList?[i].nickname = null;
        infoEntity?.voicePlaceList?[i].headImage = null;
        infoEntity?.voicePlaceList?[i].isHost = null;
        // infoEntity?.voicePlaceList?[i].roomPlaceId = null;
      } else {
        ModelLiveInfoPlaceList placeModel = infoEntity!.voicePlaceList![i];
        for (var element in roomPlaceIds) {
          if (placeModel.roomPlaceId?.toInt() == element) {
            infoEntity?.voicePlaceList?[i].userId = null;
            infoEntity?.voicePlaceList?[i].nickname = null;
            infoEntity?.voicePlaceList?[i].headImage = null;
            infoEntity?.voicePlaceList?[i].isHost = null;
            // infoEntity?.voicePlaceList?[i].roomPlaceId = null;
          }
        }
      }
    }

    for (var i = 0; i < (infoEntity?.videoPlaceList ?? []).length; i++) {
      if (isAll == true) {
        infoEntity?.videoPlaceList?[i].userId = null;
        infoEntity?.videoPlaceList?[i].nickname = null;
        infoEntity?.videoPlaceList?[i].headImage = null;
        infoEntity?.videoPlaceList?[i].isHost = null;
        // infoEntity?.videoPlaceList?[i].roomPlaceId = null;
      } else {
        ModelLiveInfoPlaceList placeModel = infoEntity!.videoPlaceList![i];
        for (var element in roomPlaceIds) {
          if (placeModel.roomPlaceId?.toInt() == element) {
            infoEntity?.videoPlaceList?[i].userId = null;
            infoEntity?.videoPlaceList?[i].isHost = null;
            infoEntity?.videoPlaceList?[i].nickname = null;
            infoEntity?.videoPlaceList?[i].headImage = null;
            // infoEntity?.videoPlaceList?[i].roomPlaceId = null;
          }
        }
      }
    }

    ProviderLivePlaceListInfo placeProvider =
        Provider.of<ProviderLivePlaceListInfo>(context, listen: false);
    placeProvider.voiceList = infoEntity!.voicePlaceList ?? [];
    placeProvider.videoList = infoEntity!.videoPlaceList ?? [];
  }

  //用户或者房主下麦  rtc操作 接口
  Future<void> userRtcPostExitPlace() async {
    ModelLiveInfoPlaceList? placeModel;
    infoEntity?.videoPlaceList?.forEach((element) {
      if (element.userId == ProviderLiveUser().userInfo.uid) {
        placeModel = element;
      }
    });
    infoEntity?.voicePlaceList?.forEach((element) {
      if (element.userId == ProviderLiveUser().userInfo.uid) {
        placeModel = element;
      }
    });
    if (placeModel != null) {
      if (infoEntity?.userId == ProviderLiveUser().userInfo.uid) {
        DataResult result = await MainDao.liveGetMasterDownMike(
            roomId: (infoEntity!.roomId ?? 0));
        if (result.result) {
          await updateBottomState(isLiving: false);
          await updataExitRoomPlaceId([placeModel!.roomPlaceId ?? 0]);
        } else {
          _checkMounted();
          UtilsLiveAlert.showDioTips(context, result);
        }
        return;
      } else {
        DataResult result = await MainDao.livePostUserDownMike(
            roomPlaceId: placeModel!.roomPlaceId!,
            roomId: placeModel?.roomId ?? 0);
        if (result.result && result.data != null) {
          await updateBottomState(isLiving: false);
          await updataExitRoomPlaceId([placeModel!.roomPlaceId ?? 0]);
        } else {
          _checkMounted();
          UtilsLiveAlert.showDioTips(context, result);
        }
        return;
      }
    }
    return;
  }

//ture 开启   //false关闭
  Future updateBottomState(
      {bool? isLiving,
      bool? isSpeaker,
      bool? isApplyForMike,
      int? voice,
      bool? isBlack,
      int? chat}) async {
    _checkMounted();
    ProviderLiveUser liveStatus =
        Provider.of<ProviderLiveUser>(context, listen: false);
    if (isLiving != null) {
      if (isLiving == false) {
        await RtcEngineManager.getInstance().stopConnectLive();
      }
      liveStatus.isLiving = isLiving;
    }
    if (isSpeaker != null) {
      DLog(isSpeaker ? "开启扬声器" : "关闭扬声器");
      RtcEngineManager.getInstance()
          .getEngine()
          ?.muteAllRemoteAudioStreams(!isSpeaker);
      if (ProviderLiveUser().isSpeaker != isSpeaker) {
        CommonUtils.showToast(
            isSpeaker ? S.current.Live_SoundOn : S.current.Live_SoundOff);
      }
      liveStatus.isSpeaker = isSpeaker;
    }
    if (isBlack != null && liveStatus.isBlack != isBlack) {
      liveStatus.isBlack = isBlack;
    }
    if (isApplyForMike != null && liveStatus.isApplyForMike != isApplyForMike) {
      liveStatus.isApplyForMike = isApplyForMike;
    }
    if (voice != null) {
      DLog(voice != 1);
      RtcEngineManager.getInstance()
          .getEngine()
          ?.muteLocalAudioStream(voice != 1);
      liveStatus.voice = voice;
    }
    if (chat != null && liveStatus.chat != chat) {
      liveStatus.chat = chat;
    }
  }

  updataImUnReadNum(int unRead) {
    _checkMounted();
    ProviderLiveImUnRead imUnRead =
        Provider.of<ProviderLiveImUnRead>(context, listen: false);
    imUnRead.unReadNum = unRead;
  }

  updataUserMoney(String money) {
    _checkMounted();
    if (money.isNotEmpty && int.parse(money) > 0) {
      ModelLiveUserInfo userInfo = ProviderLiveUser().userInfo;
      userInfo.money = int.parse(money);
      ProviderLiveUser userProvider =
          Provider.of<ProviderLiveUser>(context, listen: false);
      userProvider.userInfo = userInfo;
      widget.methonDelegate.updateMainUserMoney(money);
    }
  }

  getRoomUserList() async {
    final res = await MainDao.livePostRoomUserList(
        roomId: infoEntity?.roomId ?? 0, num: 1, size: 4);
    if (res.result && res.data != null) {
      ModelLiveUserListEntity entity =
          ModelLiveUserListEntity().fromJson(res.data);
      _checkMounted();
      ProviderLiveHeaderUser userProvider =
          Provider.of<ProviderLiveHeaderUser>(context, listen: false);
      if ((entity.users ?? []).length > 4) {
        (entity.users ?? []).removeRange(0, (entity.users ?? []).length - 4);
      }
      if (infoEntity?.userId == ProviderLiveUser().userInfo.uid &&
          (entity.applyNum ?? 0) > 0) {
        ProviderLiveJoinPlace joinPlace =
            Provider.of<ProviderLiveJoinPlace>(context, listen: false);
        joinPlace.applyNum = entity.applyNum ?? 0;
      }
      userProvider.usersList = entity.users ?? [];
    }
  }

  void onMessageLiveReceived(EMMessage message) {}

  @override
  void initState() {
    _future = initDataSource().then((value) async {
      // await initFaceUnity();
      // getRoomUserList();
      initCreateRtcManager();
    });

    // ProviderLiveUser.userInfoStatic
    DLog(ProviderLiveUser().userInfo.money);
    super.initState();
  }

  @override
  void dispose() {
    super.dispose();
  }

  @override
  void didUpdateWidget(PageLiveRTC oldWidget) {
    super.didUpdateWidget(oldWidget);
  }

  @override
  void didChangeDependencies() {
    super.didChangeDependencies();
  }

  @override
  void onConnectionStatusChange(bool connected) {
    if (connected) {
      reConnectionIM();
    }
  }
}

abstract class LiveMethonDelegate {
  ///显示举报页面
  void showLiveReportPage(String userId);

  ///打开聊天列表
  void openIMMessageListPage();

  ///显示充值页面
  void showRechargeblePage();

  ///打开im聊天页面
  void showLiveIMChatPage(String userId);

  ///拨打视频
  void showLiveCallVideoPage(String userId);

  ///回调到主app用户余额
  void updateMainUserMoney(String money);

  ///添加环信消息事件
  void setImSocketMessageHandler(LiveSocketEventHandler handler);

  ///添加环信链接状态
  void setOnConnection(OnImLivePluginDelegate delegate);

  // setImSocketMessageHandler
}
