import 'package:flutter/material.dart';
import 'package:flutter_keyboard_visibility/flutter_keyboard_visibility.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:lottie/lottie.dart';
import 'package:mmoo_live_room/Config/config_live_globalkey.dart';
import 'package:mmoo_live_room/Config/config_live_methon.dart';
import 'package:mmoo_live_room/Config/config_live_typedef.dart';
import 'package:mmoo_live_room/Provider/provider_live_user.dart';
import 'package:mmoo_live_room/Utils/utils_live_dlog.dart';
import 'package:mmoo_live_room/Utils/utils_live_image.dart';
import 'package:mmoo_live_room/Widget/widget_live_chat_messages.dart';
import 'package:mmoo_live_room/Widget/widget_live_gift_show.dart';
import 'package:mmoo_live_room/Widget/widget_live_input_white.dart';
import 'package:mmoo_live_room/Widget/widget_live_language.dart';
import 'package:mmoo_live_room/Widget/widget_live_liveheader.dart';

import 'package:mmoo_live_room/Widget/widget_live_stream_multi_video.dart';
import 'package:mmoo_live_room/Widget/widget_live_stream_single_video.dart';
import 'package:mmoo_live_room/Widget/widget_live_stream_voice_sounds.dart';
import 'package:mmoo_live_room/Widget/widget_live_stream_voice_video.dart';
import 'package:mmoo_live_room/Widget/widght_live_bottom_btn.dart';
import 'package:mmoo_live_room/Model/model_live_info_entity.dart';
import 'package:mmoo_live_room/Utils/utils_live_repeat_click.dart';

///直播间 页面  主要视频
class PageLiveStreamer extends StatefulWidget {
  final ClickCallBack clickCallBack;
  final ModelLiveInfoEntity infoEntity;
  final bool isShowGui;
  PageLiveStreamer(
      {required this.clickCallBack,
      required this.infoEntity,
      this.isShowGui = false})
      : super(key: ConfigLiveGlobalkey.streamerViewKey);
  @override
  PageLiveStreamerState createState() => PageLiveStreamerState();
}

class PageLiveStreamerState extends State<PageLiveStreamer>
    with AutomaticKeepAliveClientMixin, TickerProviderStateMixin {
  static const double _spaceBetween = 10.0;
  //header离top的距离]
  static final double _headerTop = ScreenUtil().statusBarHeight + 5;
  //header的高度
  static const double _headerHeight = 40;
//语言高度
  static const double _languageHeight = 22;
  //多人视频直播 视频位离top的距离
  static final double _multiTop =
      _headerTop + _headerHeight + _languageHeight + _spaceBetween * 2;
  //多人视频直播 语音位离top的距离
  static final double _voiceVideoTop =
      _multiTop + 1.sw + _spaceBetween; //1.sw为多人视频的高度 10.w为视频位上下间距
  //多人视频直播 语音位height
  static const double _voiceVideoHeight = 84;
  //多人视频直播 聊天消息页面top距离
  // static double _chatMessaheTop = _voiceVideoTop + _voiceVideoHeight + 10.w; //10为间距
  static const double _bottomBtnHeight = 40;
//语音直播 坑位高度
  static final double _soundsHeight = 380.w;
  bool _showInput = false;
  bool _isInit = true;
  var keyboardVisibilityController = KeyboardVisibilityController();
  // final FocusNode _editFocusNode = FocusNode();
  final double _bottomBarHeight = ScreenUtil().bottomBarHeight;
  late AnimationController _controller;
  // bool isUnlock = false;
  // ClickCallBack? _inputCallBack;
  // String? _methon;
  // dynamic _data;
// List vioceHeaderList = [];

  //多人视频直播 聊天消息页面 高度
  // static double _chatMessaheHeight = 1.sh - _chatMessaheTop - _bottomBtnHeight - 10.w - ScreenUtil().bottomBarHeight;
  @override
  Widget build(BuildContext context) {
    // DLog( ScreenUtil().bottomBarHeight);
    // DLog( ScreenUtil().statusBarHeight);
    return SizedBox(
        height: 1.sh,
        width: 1.sw,
        child: Stack(
          children: [
            buildStreamer(),
            Positioned(
                top: _voiceVideoTop,
                left: 0,
                right: 0,
                child: Visibility(
                    visible: widget.infoEntity.type == 1 &&
                        (widget.infoEntity.voicePlaceList?.length ?? 0) > 0,
                    child: Container(
                      child: WidgetLiveStreamVoiceVideo(
                        _voiceVideoHeight,
                        clickCallBack: widget.clickCallBack,
                      ),
                      margin: const EdgeInsets.only(bottom: _spaceBetween),
                    ))),
            Positioned(
                top: (_voiceVideoTop +
                    ((widget.infoEntity.type == 1 &&
                            (widget.infoEntity.voicePlaceList?.length ?? 0) > 0)
                        ? (_voiceVideoHeight + _spaceBetween)
                        : 0)),
                left: 0,
                right: 0,
                child: SizedBox(
                  height: 1.sh -
                      (_voiceVideoTop +
                          ((widget.infoEntity.type == 1 &&
                                  (widget.infoEntity.voicePlaceList?.length ??
                                          0) >
                                      0)
                              ? (_voiceVideoHeight + _spaceBetween)
                              : 0) +
                          _spaceBetween * 2 +
                          (ScreenUtil().bottomBarHeight == 0.0
                              ? _spaceBetween * 3
                              : ScreenUtil().bottomBarHeight) +
                          _bottomBtnHeight),
                  child: WidgetLiveChatMessages(
                    clickCallBack: widget.clickCallBack,
                  ),
                )),

            Visibility(
              visible: _showInput == false,
              child: Positioned(
                  left: 0,
                  right: 0,
                  bottom: (_bottomBarHeight + _spaceBetween),
                  child: WidghtLiveBottomBtn(
                    _bottomBtnHeight,
                    infoEntity: widget.infoEntity,
                    clickCallBack: (methon, data) {
                      clickCallBack(methon, data);
                    },
                  )
                  // : WidgetLiveInputWhite(
                  //     clickCallBack: widget.clickCallBack,
                  //   ),
                  ),
            ),
            Visibility(
              visible: _showInput == true,
              child: Positioned(
                left: 0,
                right: 0,
                bottom: 0,
                child: WidgetLiveInputWhite(
                  clickCallBack: widget.clickCallBack,
                ),
              ),
            ),
            Positioned(
              child: Column(
                children: [
                  Container(
                    margin: EdgeInsets.only(
                        top: _headerTop,
                        left: _spaceBetween,
                        right: _spaceBetween),
                    child: Row(
                      mainAxisAlignment: MainAxisAlignment.spaceBetween,
                      // crossAxisAlignment: CrossAxisAlignment.start,
                      children: [
                        WidgetLiveHeader(
                          height: _headerHeight,
                          clickCallBack: widget.clickCallBack,
                        ),
                        GestureDetector(
                          onTap: () {
                            // Navigator.pop(context);
                            widget.clickCallBack(
                                ConfigLiveMethon.liveClickLeaveRoom, '');
                          },
                          child: SizedBox(
                            child: UtilsLiveImage.getIconByPath(
                              widget.infoEntity.userId ==
                                      ProviderLiveUser().userInfo.uid
                                  ? 'icon_live_operation'
                                  : 'icon_live_close',
                            ),
                          ),
                        ),
                      ],
                    ),
                  ),
                  Container(
                    // margin: EdgeInsets.only(
                    // top: _headerTop, left: 10.w, right: 10.w),
                    margin:
                        const EdgeInsets.symmetric(horizontal: _spaceBetween),
                    child: WidgetLiveLanguagePeople(
                      height: _languageHeight,
                      clickCallBack: widget.clickCallBack,
                    ),
                  )
                ],
              ),
            ),
            Positioned(top: 1.sh * 0.5, left: 0, child: WidgetLiveGiftShow()),
            // Positioned(
            //   bottom: 0,
            //   child: WidgetLiveMore(clickCallBack: widget.clickCallBack),)
            Visibility(
                visible: _isInit && widget.isShowGui,
                child: Positioned.fill(
                    child: Lottie.asset('lib/assets/json/live_gui.json',
                        package: 'mmoo_live_room',
                        fit: BoxFit.cover,
                        controller: _controller, onLoaded: (composition) {
                  _controller
                    ..duration = composition.duration
                    ..forward().whenComplete(() {
                      if (mounted) {
                        setState(() {
                          _isInit = false;
                        });
                      }
                    });
                })))
          ],
        ));
  }

  Widget buildStreamer() {
    if ((widget.infoEntity.videoPlaceList ?? []).isEmpty &&
        (widget.infoEntity.voicePlaceList ?? []).isEmpty) {
      return closeRoomLive();
    } else {
      if (widget.infoEntity.type == 0) {
        return Positioned(
            top: _multiTop,
            left: 0,
            right: 0,
            child: WidgetLiveStreamVoiceSounds(
              _soundsHeight,
              clickCallBack: widget.clickCallBack,
            ));
      } else {
        if (widget.infoEntity.videoPlaceList?.length == 4) {
          return Positioned(
              top: _multiTop,
              left: 0,
              right: 0,
              child: WidgetLiveStreamMultiVideo(
                clickCallBack: widget.clickCallBack,
              ));
        } else {
          return Positioned(
            left: 0,
            right: 0,
            child: WidgetLiveStreamSingleVideo(
              clickCallBack: widget.clickCallBack,
            ),
          );
        }
      }
    }
  }

  Widget closeRoomLive() {
    return Center(
      child: Container(
        // padding: EdgeInsets.only(top: 10.w,bottom: 25.w),
        height: 180.w,
        width: 255.w,
        decoration: BoxDecoration(
            borderRadius: BorderRadius.circular(20),
            color: const Color(0xFFDFDFDF).withAlpha(51)),
        child: Column(
          children: [
            Container(
              decoration: BoxDecoration(
                  borderRadius: const BorderRadius.only(
                      topLeft: Radius.circular(20),
                      topRight: Radius.circular(20)),
                  color: const Color(0xFFFFFFFF).withAlpha(51)),
              height: 45.w,
              child: Center(
                child: Text(
                  'Kind Reminder',
                  style: TextStyle(
                      color: Colors.white.withAlpha(127), fontSize: 18),
                ),
              ),
            ),
            Expanded(
                child: Center(
              child: Text(
                'No Sreaming',
                textAlign: TextAlign.center,
                style:
                    TextStyle(color: Colors.white.withAlpha(75), fontSize: 14),
              ),
            )),
            GestureDetector(
              onTap: UtilsLiveRepeatClick.debounce(() {
                widget.clickCallBack(ConfigLiveMethon.liveRefreshInfo, '');
              }),
              child: Container(
                margin: EdgeInsets.only(bottom: 25.w),
                width: 144.w,
                height: 35.w,
                decoration: BoxDecoration(
                    borderRadius: BorderRadius.circular(17.5.w),
                    gradient: const LinearGradient(
                        colors: [Color(0xFFFB5C9A), Color(0xFFF775F2)])),
                child: const Center(
                  child: Text(
                    'Refresh',
                    style: TextStyle(color: Colors.white, fontSize: 14),
                  ),
                ),
              ),
            )
          ],
        ),
      ),
    );
  }

  clickCallBack(String methon, dynamic data) {
    if (methon == ConfigLiveMethon.liveBottomGroupChat) {
      if (!mounted) {
        return;
      }
      if (mounted) {
        setState(() {
          _showInput = true;
        });
      }
      Future.delayed(const Duration(milliseconds: 100), () {
        ConfigLiveGlobalkey.inputWhiteViewKey.currentState?.openKeyboard();
      });

      // _editFocusNode.requestFocus();
      // FocusScope.of(context).requestFocus(_editFocusNode);
    } else {
      widget.clickCallBack(methon, data);
    }
  }

  @override
  void initState() {
    super.initState();
    _controller = AnimationController(vsync: this);
    keyboardVisibilityController.onChange.listen((bool visible) {
      if (mounted) {
        setState(() {
          _showInput = visible;
        });
      }
    });
  }

  @override
  void dispose() {
    _controller.dispose();
    super.dispose();
    // keyboardVisibilityController.
  }

  @override
  void didUpdateWidget(PageLiveStreamer oldWidget) {
    super.didUpdateWidget(oldWidget);
  }

  @override
  void didChangeDependencies() {
    super.didChangeDependencies();
  }

  @override
  bool get wantKeepAlive => true;
}
