

//  美颜版本  有nana美颜库
// import 'package:agora_rtc/FUManager/FUManager.dart';
// import 'package:agora_rtc/rtc_engine.dart';
// 不带美颜版本
import 'package:agora_rtc_engine/rtc_engine.dart';
//

class RtcEngineManager {
  RtcEngine? _engine;
  static RtcEngineManager? _instance;

  static RtcEngineManager getInstance() {
    _instance ??= RtcEngineManager();
    return _instance!;
  }

  RtcEngineManager();
/* 创建rtc engine */
  Future creatEngine(String appID) async {
    if (appID.isEmpty) {
      throw 'rtc appid null';
    }
    _engine = await RtcEngine.create(appID);
     
    // _engine?.setLogFilter(LogFilter.Debug);
    await _engine?.startPreview();
    await _engine?.enableAudio();
    await _engine?.enableVideo();
    await _engine?.setChannelProfile(ChannelProfile.LiveBroadcasting);
    // await _engine?.setClientRole(ClientRole.Audience);
    VideoEncoderConfiguration configuration = VideoEncoderConfiguration();
    configuration.orientationMode = VideoOutputOrientationMode.FixedPortrait;
    await _engine?.setVideoEncoderConfiguration(configuration);
    return;
  }

/* 开始视频直播 */
  Future openVideoLive(
    String roomId,
  ) async {
    if (_engine == null) {
      throw 'place create rtcengine';
    }
    
    await _engine?.setChannelProfile(ChannelProfile.LiveBroadcasting);
    await _engine?.setClientRole(ClientRole.Broadcaster);
    await _engine?.muteLocalVideoStream(false);
    await _engine?.enableLocalVideo(true);
    return;
  }

  /* 开始语音直播 */
  Future openVoiceLive(String roomId) async {
    if (_engine == null) {
      throw 'place create rtcengine';
    }
    await _engine?.setClientRole(ClientRole.Broadcaster);
    await _engine?.enableAudio();
    // await _engine?.disableVideo();
    await _engine?.muteLocalVideoStream(true);
    return;
    // await _engine?.joinChannel('', roomId, null, optionalUid);
  }

  Future stopConnectLive() async {
    
    await _engine?.setClientRole(ClientRole.Audience);
    await _engine?.stopPreview();
    //  美颜版本  有nana美颜库
    // FUManager.stopCapture();
    //

    return;
  }

  RtcEngine? getEngine() {
    if (_engine == null) {
      return null;
    }
    return _engine!;
  }

  Future resetRtCClient() async {
    if (_engine != null) {
      await _engine?.destroy();
    }
    _engine = null;
  }
}
