

//ignore_for_file: constant_identifier_names

import 'package:flutter/material.dart';

class UtilsLiveColor {
  static Color hexToColor(String s) {
    try {
      // 如果传入的十六进制颜色值不符合要求，返回默认值
      if ( s.length != 7 ||
          int.tryParse(s.substring(1, 7), radix: 16) == null) {
        s = '#999999';
      }
      return Color(int.parse(s.substring(1, 7), radix: 16) + 0xFF000000);
    } catch (exc) {
      return Colors.transparent;
    }
  }



  static const int color_rose = 0xFFFF298D;
  static const int color_rose_right = 0xFFFF666A;
  static const int color_blue = 0xFF565FD6;
  static const int color_blue_left = 0xFF155EFD;
  static const int color_blue_right = 0xFF2DA3FE;
  static const int color_green = 0xFF5CDF5C;
  static const int color_green_right = 0xFF00D9A8;
  static const int color_purple = 0xFF9525FF;
  static const int color_bg = 0xFF1A0835;
  static const int color_info_bg = 0xFF200C3C;
  static const int color_text_bg = 0xFF251142;
  static const int color_text_hint = 0xFF685385;
  static const int color_white10 = 0xFF10FFFFFF;
  static const int color_white20 = 0xFF20FFFFFF;
  static const int color_white60 = 0xFF60FFFFFF;
  static const int color_white80 = 0xFF80FFFFFF;
  static const int color_white90 = 0xFF90FFFFFF;
  static const int color_white95 = 0xFF95FFFFFF;
  static const int color_tran30 = 0xFF30000000;
  static const int color_tab_un = 0xFF40285C;
  static const int color_btn_un = 0xFF362056;
  static const int color_online = 0xFF35F7AC;
  static const int color_offline = 0xFFF5F5F5;
  static const int color_busy = 0xFFFF4B4B;
  static const int color_card = 0xFFFF8684;
  static const int color_card_right = 0xFFFF46D2;
  static const int color_load_bg = 0xFF40285C;
  static const int color_shadow = 0xFFf607ff;
  static const int color_chat_left = 0xFFC470FF;
  static const int color_chat_right = 0xFF7F2AFF;
  static const int color_chat_shadow = 0xFF7417FF;
  static const int color_recharge_shadow = 0xFFEA1EA9;
  static const int color_chat_tip = 0xFF1F0C3B;
  static const int color_match_bg = 0xFF1B0836;
  static const int color_match_progress = 0xFF29FFE3;
  static const int color_video_down = 0xFF6F00C9;
  static const int color_video_match = 0xFF240083;
  static const int color_video_pick = 0xFFFF25AF;
  static const int color_text_down = 0xFFFFE72E;
  static const int color_daily_bg = 0xFF5602A4;
  static const int color_daily_day = 0xFF360078;
  static const int color_daily_day_left = 0xFF40360078;
  static const int color_daily_day_right = 0xFF8800E5;
  static const int color_daily_day_top = 0xFFEF00DC;
  static const int color_daily_day_bottom = 0xFF7E03BD;
  static const int color_send_coins = 0xFFFFE600;
  static const int color_pop_bg = 0xFF;
  static const int color_call = 0xFFFFA60A;
  static const int color_pop_tip = 0xFF4C3D62;
  static const int color_blue_match = 0xFF6347F1;

  ///充值列表颜色
  static const int color_storeLineBg = 0xFFFF298E;
  static const int color_storeLineRightBg = 0xFFCB47FE;
  static const int color_storeLineGrayBg = 0xFF422F5E;
  static const int color_storeBg = 0xFF311E35;
  static const int color_storeGrayBg = 0xFF271344;
  static const int color_storeGrayBg2 = 0xFF4A3569;
  static const int color_storeTipBg = 0xFFFF298E;
  static const int color_storeTipRightBg = 0xFFFFA231;
  static const int color_storeTipRightBg2 = 0xFFAF32FF;
  static const int color_storeText = 0xFFFFE71B;
  static const int color_storeVip = 0xFFFFE71B;
  static const int color_storeVipBg1 = 0xFFCB7815;
  static const int color_storeVipBg2 = 0xFFBC510F;
  static const int color_storeVipLine1 = 0xFFFDAE25;
  static const int color_storeVipLine2 = 0xFFFFE891;
  static const int color_storeVipLine3 = 0xFFFDAC1D;

  ///列表
  static const int color_girl = 0xFFFF8D76;
  static const int color_girl_right = 0xFFFF009D;
  static const int color_boy = 0xFF1388FF;
  static const int color_boy_right = 0xFF0E20FF;

  ///vip
  static const int color_plus1 = 0xFFFF8D07;
  static const int color_plus1_right = 0xFFFFB745;
  static const int color_plus2 = 0xFF00D56E;
  static const int color_plus2_right = 0xFF8AF44A;
  static const int color_plus3 = 0xFFBF0BF3;
  static const int color_plus3_right = 0xFFF53DD4;
  static const int color_plus4 = 0xFFFF255D;
  static const int color_plus4_right = 0xFFFD7C5E;
  static const int color_plus5 = 0xFF1F15EF;
  static const int color_plus5_right = 0xFF438EFF;
  static const int color_plus6 = 0xFF7E00E8;
  static const int color_plus6_right = 0xFFB350FF;
  static const int color_plus7 = 0xFFE9AA00;
  static const int color_plus7_right = 0xFFFFEC50;
  static const int color_plus8 = 0xFF8002CF;
  static const int color_plus8_right = 0xFFAE00C8;
  static const int color_plus9 = 0xFF971EE4;
  static const int color_plus9_right = 0xFFC46CE9;
  static const int color_plus10 = 0xFFDA6626;
  static const int color_plus10_right = 0xFFE6AD3F;
  static const int color_plus11 = 0xFF3B1EE9;
  static const int color_plus11_right = 0xFF8046E9;
  static const int color_plus_vip1 = 0xFFFFAE00;
  static const int color_plus_vip1_right = 0xFFEBD82E;
  static const int color_plus_vip2 = 0xFF5F7EC4;
  static const int color_plus_vip2_right = 0xFF98CEE0;
  static const int color_plus_vip3 = 0xFFC85D2D;
  static const int color_plus_vip3_right = 0xFFEDA96E;

  static const int color_lucky = 0xFFFFFC17;
  static const int color_lucky_right = 0xFFFFC12D;
  static const int color_main_lucky = 0xFF240060;
  static const int color_main_lucky_right = 0xFF510095;
  static const int color_lucky_text = 0xFFFEFFC8;
  static const int color_lucky_text_right = 0xFFFFED21;
  static const int color_lucky_text_right2 = 0xFFDEB8FF;
  static const int color_lucky_text_shadow = 0xFF012469;
  static const int color_lucky_text_bg = 0xFF0B0E47;
  static const int color_lucky_text_max = 0xFF3D02D0;
  static const int color_lucky_text_spin = 0xFF8D3C13;
  static const int color_lucky_text_auto = 0xFF62280A;
  static const int color_lucky_text_auto2 = 0xFFFFEA73;
  static const int color_lucky_top = 0xFF8E14FF;
  static const int color_lucky_top_text = 0xFFFFE4B0;
  static const int color_lucky_top_text_bg = 0xFF642403;
  static const int color_lucky_big_win = 0xFFFFE371;

  static const int primaryValue = 0xFF1A0835;
  static const int primaryLightValue = 0xFF1A0835;
  static const int primaryDarkValue = 0xFF1A0835;
  static const List randomColor = [
    0xFFFF00EF,
    0xFFFB5D5D,
    0xFFF35DFB,
    0xFF975DFB,
    0xFFFF287F,
    0xFF5DFBA5,
    0xFFFB5D9D,
    0xFF5D90FB
  ];

  static const MaterialColor primarySwatch =
      MaterialColor(0xFFFFFFFF, <int, Color>{
    50: Colors.white,
    100: Colors.white,
    200: Colors.white,
    300: Colors.white,
    400: Colors.white,
    500: Colors.white,
    600: Colors.white,
    700: Colors.white,
    800: Colors.white,
    900: Colors.white,
  });

  static const startColors = [Color(0xFFFB5C9A), Color(0xFFF775F2)];
  static const privateColors = [Color(0xFF8C009D), Color(0xFF2A0084)];
  static const privateListColors = [Color(0xFFE440F7), Color(0xFF5F53F3)];

  static const int color_back = 0xFF000000;
  static const int color_white = 0xFFFFFFFF;
  static const int color_C5BCFF = 0xFFC5BCFF;
  static const int color_FB6CD8 = 0xFFFB6CD8;
  static const int color_CCCCCC = 0xFFCCCCCC;
  static const int color_B91E9B = 0xFFB91E9B;
  static const int color_FF64CE = 0xFFFF64CE;
}
