

import 'package:flutter/material.dart';
import 'package:mmoo_live_room/Utils/utils_live_dlog.dart';

class UtilsLiveOverLay {
  static OverlayEntry? _holder;

  static Widget? view;

  static void removeHidden() {
    
    if (_holder != null) {
      _holder?.remove();
      _holder = null;
    }
      
  }

  static void show({required BuildContext context, required Widget view}) {
    UtilsLiveOverLay.view = view;

    removeHidden();
    OverlayEntry overlayEntry = OverlayEntry(builder: (context) {
      return Positioned(
          top: MediaQuery.of(context).size.height * 0.7,
          child: _buildDraggable(context));
    });
    Overlay.of(context)?.insert(overlayEntry);
    _holder = overlayEntry;
  }

  static _buildDraggable(context) {
    return  Draggable(
      child: view!,
      feedback: view!,
      onDragStarted: (){
        // print(3);
        DLog('onDragStarted:');
      },
      onDragEnd: (detail) {
        DLog('onDragEnd:${detail.offset}');
        createDragTarget(offset: detail.offset, context: context);
      },
      childWhenDragging: Container(),
    );
  }

  static void refresh() {
    _holder?.markNeedsBuild();
  }

  static void createDragTarget({required Offset offset,required BuildContext context}) {

      _holder?.remove();
    

    _holder =  OverlayEntry(builder: (context) {
      bool isLeft = true;
      if (offset.dx + 100 > MediaQuery.of(context).size.width / 2) {
        isLeft = false;
      }

      double maxY = MediaQuery.of(context).size.height - 100;

      return  Positioned(
          top: offset.dy < 50 ? 50 : offset.dy < maxY ? offset.dy : maxY,
          left: isLeft ? 0 : null,
          right: isLeft ? null : 0,
          child: DragTarget(
            onWillAccept: (data) {
              DLog('onWillAccept: $data');
              return true;
            },
            onAccept: (data) {
              DLog('onAccept: $data');
              // refresh();
            },
            onLeave: (data) {
              DLog('onLeave');
            },
            builder: (BuildContext context, List incoming, List rejected) {
              return _buildDraggable(context);
            },
          ));
    });
    Overlay.of(context)?.insert(_holder!);
  }
}


