import 'package:flutter/material.dart';
import 'package:mmoo_live_room/Utils/utils_live_alert.dart';
import 'package:mmoo_live_room/generated/l10n.dart';
import 'package:permission_handler/permission_handler.dart';

class UtilsLivePermission {
  static Future<bool> checkPermission(
      BuildContext context, Permission type) async {
    if (type == Permission.camera) {
      if (await Permission.camera.isGranted) {
        return true;
      } else if (await Permission.camera.isDenied) {
        await Permission.camera.request();
        return await Permission.camera.isGranted;
      } else {
        UtilsLiveAlert.showCenterGeneral(context,
            infoStr:
                S.current.Live_Settingspermissions,
            leftStr: S.current.Live_Cancel,
            rightStr: S.current.Live_Sure, rightVoidCallBack: () {
          openAppSettings();
        });

        return false;
      }
    } else if (type == Permission.microphone) {
      if (await Permission.microphone.isGranted) {
        return true;
      } else if (await Permission.microphone.isDenied) {
        await Permission.microphone.request();
        return await Permission.microphone.isGranted;
      } else {
        UtilsLiveAlert.showCenterGeneral(context,
            infoStr:
                S.current.Live_Settingspermissions,
            leftStr: S.current.Live_Cancel,
            rightStr: S.current.Live_Sure, rightVoidCallBack: () {
          openAppSettings();
        });
        return false;
      }
    } else if (type == Permission.photos) {
      if (await Permission.photos.isGranted ||
          await Permission.photos.isLimited) {
        return true;
      } else if (await Permission.photos.isDenied) {
        await Permission.photos.request();
        return await Permission.photos.isGranted;
      } else {
        UtilsLiveAlert.showCenterGeneral(context,
            infoStr:
                S.current.Live_Settingspermissions,
            leftStr: S.current.Live_Cancel,
            rightStr: S.current.Live_Sure, rightVoidCallBack: () {
          openAppSettings();
        });
        return false;
      }
    } else if (type == Permission.notification) {
      if (await Permission.notification.isGranted) {
        return true;
      } else if (await Permission.notification.isDenied) {
        await Permission.notification.request();
        return await Permission.notification.isGranted;
      } else {
        UtilsLiveAlert.showCenterGeneral(context,
            infoStr:
                S.current.Live_Settingspermissions,
            leftStr: S.current.Live_Cancel,
            rightStr: S.current.Live_Sure, rightVoidCallBack: () {
          openAppSettings();
        });
        return false;
      }
    } else {
      return false;
    }
  }
}
