
import 'package:flutter/material.dart';
import 'package:svgaplayer_flutter/parser.dart';
import 'package:svgaplayer_flutter/player.dart';

class UtilsLiveSvgaWidget extends StatefulWidget {
  const UtilsLiveSvgaWidget({Key? key,this.resUrl, this.assetsName}) : super(key: key);
final String? resUrl;
  final String? assetsName;

  @override
  UtilsLiveSvgaWidgetState createState() => UtilsLiveSvgaWidgetState();
}

class UtilsLiveSvgaWidgetState extends State<UtilsLiveSvgaWidget> with SingleTickerProviderStateMixin {
  SVGAAnimationController? animationController;
  @override
  Widget build(BuildContext context) {
    return SVGAImage(animationController!, fit: BoxFit.cover);
  }
  initDataSource() async {
    if (!mounted) return;
    animationController = SVGAAnimationController(vsync: this);
    // File('',)
    Future? decode;
    if (widget.assetsName != null) {
      decode =
          SVGAParser.shared.decodeFromAssets('packages/mmoo_live_room/lib/assets/' + widget.assetsName!);
    }
    if (widget.resUrl != null && decode == null) {
      decode = SVGAParser.shared.decodeFromURL(widget.resUrl!);
    }
    if (decode != null) {
      decode.then((videoItem) {
        if (mounted) {
          animationController
            ?..videoItem = videoItem
            ..forward().whenComplete(() {
              if (!mounted) return;
              animationController?.clear();
              animationController?.videoItem = null;
              Navigator.pop(context);
            });
        }
      });
    }
  }
  @override
  void initState() {
initDataSource();
    super.initState();
  }
  
  @override
  void dispose() {

    super.dispose();
    animationController?.videoItem = null;
    animationController?.dispose();
  }
  
  @override
  void didUpdateWidget(UtilsLiveSvgaWidget oldWidget) {

    super.didUpdateWidget(oldWidget);
  }
  
  @override
  void didChangeDependencies() {

    super.didChangeDependencies();
  }
}