import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:mmoo_live_room/Config/config_live_typedef.dart';
import 'package:mmoo_live_room/Utils/utils_live_colors.dart';
import 'package:mmoo_live_room/Utils/utils_live_image.dart';
import 'package:mmoo_live_room/Utils/utils_live_textStyle.dart';
import 'package:mmoo_live_room/generated/l10n.dart';

/// 开播共有展示页面
class WidgetBeginLiveFace extends StatefulWidget {
  final ClickCallBack? clickCallBack;
  final bool isShowVideo;
  WidgetBeginLiveFace({this.clickCallBack, this.isShowVideo = true});
  @override
  WidgetBeginLiveFaceState createState() => WidgetBeginLiveFaceState();
}

class WidgetBeginLiveFaceState extends State<WidgetBeginLiveFace> {
  @override
  Widget build(BuildContext context) {
    return Container(
      padding: EdgeInsets.symmetric(horizontal: 15.w),
      child: Column(
        children: [
          SizedBox(
            height: 80.w,
            // width: 1.sw,
            child: Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: [
                Visibility(
                  //取消美颜
                  visible: false,
                  // 美颜  有nana
                    // visible: widget.isShowVideo  ,//
                    child: GestureDetector(
                      child: Container(
                        child: UtilsLiveImage.getIconByPath(
                          'live_open_beauty',
                        ),
                      ),
                      onTap: () {
                        if (widget.clickCallBack != null) {
                          widget.clickCallBack!('Beautify', '');
                        }
                      },
                    )),
                GestureDetector(
                  child: Container(
                    width: 235.w,
                    height: 50.w,
                    // margin: EdgeInsets.only(top: 10),
                    decoration: BoxDecoration(
                      borderRadius: BorderRadius.circular(25.w),
                      gradient: const LinearGradient(
                          colors: UtilsLiveColor.startColors,
                          begin: Alignment.centerLeft,
                          end: Alignment.centerRight),
                    ),
                    child: Center(
                      child: Text(
                        S.current.Live_Begin_GoLIVE,
                        style: UtilsLiveTextStyle.pt20WhiteSemiBold,
                      ),
                    ),
                  ),
                  onTap: () {
                    if (widget.clickCallBack != null) {
                      widget.clickCallBack!('startlive', '');
                    }
                  },
                ),
                Visibility(
                    visible: widget.isShowVideo,
                    child: GestureDetector(
                      child: Container(
                        child: UtilsLiveImage.getIconByPath(
                          'live_open_Camera_switch',
                        ),
                      ),
                      onTap: () {
                        if (widget.clickCallBack != null) {
                          widget.clickCallBack!('Flip camera', '');
                        }
                      },
                    )),
              ],
            ),
          ),
        ],
      ),
    );
  }

  @override
  void initState() {
    // TODO: implement initState
    super.initState();
  }

  @override
  void dispose() {
    // TODO: implement dispose
    super.dispose();
  }

  @override
  void didUpdateWidget(WidgetBeginLiveFace oldWidget) {
    // TODO: implement didUpdateWidget
    super.didUpdateWidget(oldWidget);
  }

  @override
  void didChangeDependencies() {
    // TODO: implement didChangeDependencies
    super.didChangeDependencies();
  }
}
