// ignore_for_file: provide_deprecation_message

import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:mmoo_base/dao/dao_result.dart';
import 'package:mmoo_base/dao/main_dao.dart';
import 'package:mmoo_live_room/Config/config_live_globalkey.dart';
import 'package:mmoo_live_room/Config/config_live_typedef.dart';
import 'package:mmoo_live_room/Utils/utils_live_alert.dart';
import 'package:mmoo_live_room/Utils/utils_live_colors.dart';
import 'package:mmoo_live_room/Model/model_live_info_entity.dart';
import 'package:mmoo_live_room/Model/model_live_apply_list_entity.dart';
import 'package:mmoo_live_room/Utils/utils_live_textStyle.dart';
import 'package:mmoo_live_room/Utils/utils_live_image.dart';
import 'package:mmoo_live_room/generated/l10n.dart';
import 'package:pull_to_refresh/pull_to_refresh.dart';

/// 麦序列表页  暂时废弃
class WidgetLiveApplylist {
  @deprecated
  static showLiveUserList(BuildContext context,
      {required ClickCallBack clickCallBack,
      required ModelLiveInfoEntity infoEntity}) async {
    await showModalBottomSheet(
        isScrollControlled: true,
        backgroundColor: Colors.transparent,
        // barrierColor: Colors.transparent,
        context: context,
        builder: (ctx) {
          return WidgetLiveApplylistView(
              infoEntity: infoEntity, clickCallBack: clickCallBack);
        });
  }
}

class WidgetLiveApplylistView extends StatefulWidget {
  final ClickCallBack clickCallBack;
  final ModelLiveInfoEntity infoEntity;
  WidgetLiveApplylistView(
      {required this.infoEntity, required this.clickCallBack})
      : super(key: ConfigLiveGlobalkey.applyViewKey);

  @override
  WidgetLiveApplylistViewState createState() => WidgetLiveApplylistViewState();
}

class WidgetLiveApplylistViewState extends State<WidgetLiveApplylistView> {
  RefreshController refreshController = RefreshController(initialRefresh: true);
  ModelLiveApplyListEntity _applyListEntity = ModelLiveApplyListEntity();
  @override
  Widget build(BuildContext context) {
    return Container(
      height: 612.w,
      decoration: const BoxDecoration(
          color: Colors.white,
          borderRadius: BorderRadius.only(
              topLeft: Radius.circular(20), topRight: Radius.circular(20))),
      child: Column(
        children: [
          SizedBox(
            height: 60,
            child: Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: [
                GestureDetector(
                  child: SizedBox(
                    width: 40,
                    height: 40,
                    child: UtilsLiveImage.getIconByPath(
                      'liebiao_icon_shuaxin',
                    ),
                  ),
                  onTap: () {
                    refreshController.requestRefresh();
                  },
                ),
                Text(
                  S.current.Live_Apply,
                  style: UtilsLiveTextStyle.pt22Black333333Bold,
                ),
                GestureDetector(
                  child: SizedBox(
                    width: 40,
                    height: 40,
                    child: UtilsLiveImage.getIconByPath(
                      'tanchuang_btn_guanbi',
                    ),
                  ),
                  onTap: () {
                    Navigator.pop(context);
                  },
                )
              ],
            ),
          ),
          Container(
            height: 1,
            color: UtilsLiveColor.hexToColor('#EEEEEE'),
          ),
          Expanded(
              child: SmartRefresher(
                  controller: refreshController,
                  enablePullDown: true,
                  enablePullUp: true,
                  onRefresh: _onRefresh,
                  onLoading: _onLoading,
                  child: ListView.builder(
                    itemCount: _applyListEntity.userList?.length,
                    itemExtent: 80,
                    itemBuilder: (BuildContext context, int index) {
                      return buildApplyListView(
                          _applyListEntity.userList![index]);
                      // return buildApplyListView(_applyListEntity.rows![index]);
                    },
                  ))),
        ],
      ),
    );
  }

  Widget buildApplyListView(ModelLiveApplyListRows listRows) {
    return Container(
      padding: const EdgeInsets.symmetric(horizontal: 15, vertical: 12.5),
      child: Row(
        mainAxisAlignment: MainAxisAlignment.spaceBetween,
        children: [
          SizedBox(
            child: Row(
              children: [
                Container(
                  margin: const EdgeInsets.only(right: 15),
                  child: UtilsLiveImage.getIconByPath(
                    listRows.type == 0
                        ? 'shangmaishenhe_icon_yuyin'
                        : 'shangmaishenhe_icon_shipin',
                  ),
                ),
                SizedBox(
                  width: 55,
                  height: 55,
                  child: Stack(
                    children: [
                      SizedBox(
                        width: 55,
                        height: 55,
                        // color: Colors.amberAccent,
                        child: ClipRRect(
                          borderRadius: BorderRadius.circular(27.5),
                          child:
                              UtilsLiveImage.getLoadWidget(listRows.headImage),
                        ),
                      ),
                      Positioned(
                          bottom: 0,
                          left: 2.5,
                          child: Visibility(
                              visible: listRows.isAnchor == 1,
                              child: Container(
                                height: 14,
                                width: 50,
                                decoration: BoxDecoration(
                                    color: UtilsLiveColor.hexToColor('#FD7D7D'),
                                    borderRadius: BorderRadius.circular(7)),
                                child: Center(
                                  child: Text(
                                    S.current.Live_Anchor,
                                    style: UtilsLiveTextStyle.pt12WhiteSemiBold,
                                  ),
                                ),
                              )))
                    ],
                  ),
                ),
                Column(
                  mainAxisAlignment: MainAxisAlignment.center,
                  crossAxisAlignment: CrossAxisAlignment.start,
                  children: [
                    Row(
                      children: [
                        Container(
                          constraints: BoxConstraints(maxWidth: 130.w),
                          padding: const EdgeInsets.symmetric(horizontal: 10),
                          child: Text(
                            listRows.nickname ?? '',
                            style: UtilsLiveTextStyle.pt18BlackSemiBold,
                            overflow: TextOverflow.ellipsis,
                          ),
                        ),
                        UtilsLiveImage.getIconByPath(
                          listRows.gender == 0
                              ? 'heimingdan_icon_nanren'
                              : 'heimingdan_icon_nvren',
                        )
                      ],
                    ),
                  ],
                ),
              ],
            ),
          ),
          Row(
            children: [
              GestureDetector(
                child: SizedBox(
                  width: 40,
                  height: 40,
                  child: UtilsLiveImage.getIconByPath(
                    'maixu_btn_fou',
                  ),
                ),
                onTap: () {
                  clickApplyOrRefuse(listRows, false);
                },
              ),
              const SizedBox(
                width: 10,
              ),
              GestureDetector(
                  child: SizedBox(
                    width: 40,
                    height: 40,
                    child: UtilsLiveImage.getIconByPath(
                      'maixu_btn_queding',
                    ),
                  ),
                  onTap: () {
                    clickApplyOrRefuse(listRows, true);
                  }),
            ],
          ),
        ],
      ),
    );
  }

  clickApplyOrRefuse(ModelLiveApplyListRows listRows, bool isApply) async {
    DataResult dataResult = await MainDao.livePostAgreeForMike(
        roomId: widget.infoEntity.roomId ?? 0,
        type: isApply ? 1 : 0,
        userId: listRows.userId ?? 0);

    if (dataResult.result && dataResult.data != null) {
      if (mounted) {
        setState(() {
          _applyListEntity.userList!.remove(listRows);
        });
      }
    } else {
      refreshController.requestRefresh();
      UtilsLiveAlert.showDioTips(context, dataResult);
    }
  }

  _onRefresh() async {
    _applyListEntity.num = 1;

    _refreshDataSource();
  }

  _refreshDataSource() async {
    DataResult dataResult = await MainDao.livePostApplyList(
        roomId: widget.infoEntity.roomId ?? 0,
        num: _applyListEntity.num ?? 1,
        size: 20);
    refreshController.refreshCompleted();
    if (dataResult.result && dataResult.data != null) {
      ModelLiveApplyListEntity listEntity =
          ModelLiveApplyListEntity().fromJson(dataResult.data);
      if ((listEntity.userList?.length ?? 0) < 20) {
        refreshController.loadNoData();
      } else {
        refreshController.loadComplete();
      }
      if (listEntity.num == 1) {
        _applyListEntity = ModelLiveApplyListEntity().fromJson(dataResult.data);
      } else {
        _applyListEntity.userList?.addAll(listEntity.userList ?? []);
      }
      if (mounted) {
        setState(() {});
      }
    } else {
      refreshController.loadFailed();
    }
  }

  _onLoading() async {
    _applyListEntity.num = (_applyListEntity.num ?? 1) + 1;
    _refreshDataSource();
  }

  @override
  void initState() {
    _applyListEntity.num = 1;
    _applyListEntity.userList = [];

    super.initState();
  }

  @override
  void dispose() {
    super.dispose();
    refreshController.dispose();
  }

  @override
  void didUpdateWidget(WidgetLiveApplylistView oldWidget) {
    super.didUpdateWidget(oldWidget);
  }

  @override
  void didChangeDependencies() {
    super.didChangeDependencies();
  }
}
