


// ignore_for_file: prefer_const_constructors_in_immutables

import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:mmoo_live_room/Utils/utils_live_image.dart';
import 'package:mmoo_live_room/Widget/widget_action_btns.dart';
import 'package:mmoo_live_room/generated/l10n.dart';
import 'package:mmoo_live_room/Utils/utils_live_colors.dart';
import 'package:mmoo_live_room/Utils/utils_live_textStyle.dart';
import 'package:mmoo_live_room/Utils/utils_live_repeat_click.dart';

/// 点击开播按钮  用户上次房间还没有关闭的提示页面
class WidgetLiveBeginJoin extends StatefulWidget {
  final VoidCallBack rightVoidCallBack;
WidgetLiveBeginJoin({Key? key, required this.rightVoidCallBack}) : super(key: key);
  @override
  WidgetLiveBeginJoinState createState() => WidgetLiveBeginJoinState();
}

class WidgetLiveBeginJoinState extends State<WidgetLiveBeginJoin> {
  @override
  Widget build(BuildContext context) {
    return Container(
      padding:
          EdgeInsets.only(left: 15.w, right: 15.w, top: 30.w, bottom: 20.w),
      width: 325.w ,
      decoration: BoxDecoration(
        color:const  Color(0xff2B1248) ,
        borderRadius: BorderRadius.circular(30),
      ),
      child: Column(
        children: [
          UtilsLiveImage.getIconByPath('icon_live_begin_joinlive',),
          Container(
            margin: EdgeInsets.only(top: 10.w),
            constraints: BoxConstraints(maxWidth: 280.w),
            child: Text(S.current.Live_Yourroomisinlive,
                style: const TextStyle(
                    fontSize: 18,
                    color: Colors.white ,
                    fontWeight: FontWeight.bold,
                    decoration: TextDecoration.none)),
          ),
          SizedBox(
            height: 20.w,
          ),
           Row(
                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                  children: [
                    GestureDetector(
                        onTap: UtilsLiveRepeatClick.debounce(() {
                         
                          Future.delayed(const Duration(milliseconds: 100))
                              .then((value) {
                            Navigator.pop(context);
                          });
                        }),
                        child: Container(
                          width: 140.w,
                          alignment: Alignment.center,
                          height: 50.w,
                          decoration: BoxDecoration(
                              borderRadius: BorderRadius.circular(25.w),
                              border: Border.all(
                                  width: 2, color:const  Color(0xffFB5C9A))),
                          child: Text(
                            S.current.Live_Cancel,
                            style:const  TextStyle(
                                fontSize: 20,
                                color: Color(0xffFB5C9A),
                                fontWeight: FontWeight.w600,
                                decoration: TextDecoration.none),
                          ),
                        )),
                    GestureDetector(
                        onTap: UtilsLiveRepeatClick.debounce(() {
                          widget.
                            rightVoidCallBack();
                          
                          Future.delayed(const Duration(milliseconds: 100))
                              .then((value) {
                            Navigator.pop(context);
                          });
                        }),
                        child: Container(
                          height: 50.w,
                          width: 140.w,
                          alignment: Alignment.center,
                          decoration: const ShapeDecoration(
                              shape: StadiumBorder(),
                              gradient: LinearGradient(
                                  colors: UtilsLiveColor.startColors)),
                          child: Text(
                            S.current.Live_Yes,
                            textAlign: TextAlign.center,
                            style: UtilsLiveTextStyle.pt20WhiteSemiBold,
                          ),
                        ))
                  ],
                )
        ],
      ),
    );
  }
  @override
  void initState() {

    super.initState();
  }
  
  @override
  void dispose() {

    super.dispose();
  }
  
  @override
  void didUpdateWidget(WidgetLiveBeginJoin oldWidget) {

    super.didUpdateWidget(oldWidget);
  }
  
  @override
  void didChangeDependencies() {
    super.didChangeDependencies();
  }
}

