import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:flutter_keyboard_visibility/flutter_keyboard_visibility.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:mmoo_live_room/Config/config_live_methon.dart';
import 'package:mmoo_live_room/Config/config_live_typedef.dart';
import 'package:mmoo_live_room/Config/config_live_socket.dart';
import 'package:mmoo_live_room/Model/model_rtm_message.dart';
import 'package:mmoo_live_room/Provider/provider_live_chat_messages.dart';
import 'package:mmoo_live_room/Provider/provider_live_user.dart';
import 'package:mmoo_live_room/generated/l10n.dart';
import 'package:mmoo_live_room/Model/model_live_gift_list_entity.dart';
import 'package:mmoo_live_room/Utils/utils_live_colors.dart';
import 'package:mmoo_live_room/Utils/utils_live_textStyle.dart';
import 'package:mmoo_live_room/Utils/utils_live_image.dart';
import 'package:provider/provider.dart';
/// 第一版设计 消息列表
@deprecated
class WidgetLiveChatList extends StatefulWidget {
  final ClickCallBack clickCallBack;
  // ignore: use_key_in_widget_constructors
  const WidgetLiveChatList({required this.clickCallBack});
  @override
  WidgetLiveChatListState createState() => WidgetLiveChatListState();
}

class WidgetLiveChatListState extends State<WidgetLiveChatList> {
  final ScrollController _scrollController = ScrollController();
  // bool _showInput = false;

  // List messageList = ['1', '1', '1'];
  @override
  Widget build(BuildContext context) {
    // MediaQuery.of(context).viewInsets.bottom
    return getChatListWidget();
  }

  Widget getChatListWidget() {
    return Consumer<ProviderLiveChatMessage>(
        builder: (context, chatMessageProvider, child) {
      // _buildSuggestions(userProvider);
      // return getChatListWidget(userProvider);
      scrollAnimation();
      return ListView.builder(
          controller: _scrollController,
          itemCount: chatMessageProvider.rtmMessages.length,
          itemBuilder: (BuildContext context, int index) {
            return Container(
                padding: EdgeInsets.only(
                    top: 10.w, bottom: 10.w, left: 15.w, right: 15.w),
                child: getMessageType(chatMessageProvider.rtmMessages[index]));
          });
    });
  }

  Widget getMessageType(ModelRtmMessage rtmMessage) {
    if (rtmMessage.typeMethod == ConfigLiveSocket.liveSocketConfig_joinRoom) {
      return getTipMessage(rtmMessage);
    } else if (rtmMessage.typeMethod ==
            ConfigLiveSocket.liveSocketConfig_sendText ||
        rtmMessage.typeMethod == ConfigLiveSocket.liveSocketConfig_sendGift) {
      if (rtmMessage.userId == ProviderLiveUser().userInfo.uid.toString()) {
        return getChatRightMessage(rtmMessage);
      } else {
        return getChatMessage(rtmMessage);
      }
    }
    return Container();
  }

  Widget getTipMessage(ModelRtmMessage rtmMessage) {
    // String content = rtmMessage.content ?? '';
    // if (model.typeMothen == AppConfig.sysEnterRoom) {
    //   content = content + " " + S.of(context).Live_JoinRoom;
    // } else {
    //   content = content + " " + S.of(context).Live_Hadbeenguest;
    // }

    return Column(
      mainAxisAlignment: MainAxisAlignment.center,
      children: [
        Container(
          padding: const EdgeInsets.symmetric(horizontal: 10, vertical: 4),
          constraints: BoxConstraints(
            maxWidth: 300.w,
          ),
          decoration: BoxDecoration(
            borderRadius: BorderRadius.circular(11),
            color: const Color(UtilsLiveColor.color_white).withAlpha(25),
          ),
          child: Text(
            (rtmMessage.name ?? '') + " " + S.current.Live_JoinRoom,
            style: UtilsLiveTextStyle.smallTextWithCCCCCC,
            maxLines: null,
          ),
        )
      ],
    );
  }

  Widget getChatRightMessage(ModelRtmMessage rtmMessage) {
    String textStr;
    // Color textColor;
    if (rtmMessage.typeMethod == ConfigLiveSocket.liveSocketConfig_sendGift) {
      ModelLiveGiftListGifts giftModel = ModelLiveGiftListGifts()
          .fromJson(jsonDecode(rtmMessage.content ?? ''));
      String nameStr = '';
      giftModel.giveGiftUserInfoList?.forEach((element) {
        nameStr = nameStr + (element.nickname ?? '') + '、';
      });
      textStr =  S.current.Live_give +' ${giftModel.num ?? ''} \'${giftModel.name}\' to $nameStr';
    } else {
      textStr = rtmMessage.content ?? '';
    }
    return Row(
      mainAxisAlignment: MainAxisAlignment.end,
      crossAxisAlignment: CrossAxisAlignment.start,
      children: [
        Container(
          // margin: EdgeInsets.only(top: 0, bottom: 0, left: 45.w),
          padding: const EdgeInsets.all(12),
          constraints:
              BoxConstraints(maxWidth: 240.w, minHeight: 35.w, minWidth: 25.w),
          decoration: const BoxDecoration(
              // borderRadius: BorderRadius.circular(5),
              // color: Color(UtilsLiveColor.color_B91E9B),
              image: DecorationImage(
                  centerSlice: Rect.fromLTWH(15, 20, 1, 1),
                  image: AssetImage(
                      'zhibo_duorenliaotian_zijifayan_bj',
                      ),
                  fit: BoxFit.fill)),
          child: Text(
            textStr,
            style: UtilsLiveTextStyle.smallTextWhite,
            textAlign: TextAlign.start,
            maxLines: null,
          ),
        ),
        SizedBox(
          width: 20.w,
        ),
        GestureDetector(
          child: ClipRRect(
            borderRadius: BorderRadius.circular(20.w),
            child: SizedBox(
                child: UtilsLiveImage.getLoadWidget(
                    ProviderLiveUser().userInfo.headImage),
                // url: UserProvider().userModel.headImage,
                width: 40.w,
                height: 40.w),
          ),
          onTap: () {
            widget.clickCallBack(ConfigLiveMethon.liveClickUserInfo,
                int.parse(rtmMessage.userId ?? ''));
          },
        )
      ],
    );
  }

  Widget getChatMessage(ModelRtmMessage rtmMessage) {
    String nameStr = '';
    ModelLiveGiftListGifts giftListGifts = ModelLiveGiftListGifts();
    if (rtmMessage.typeMethod == ConfigLiveSocket.liveSocketConfig_sendGift) {
      giftListGifts = ModelLiveGiftListGifts()
          .fromJson(jsonDecode(rtmMessage.content ?? ''));
    }
    giftListGifts.giveGiftUserInfoList?.forEach((element) {
      nameStr = (element.nickname ?? '') + ',';
    });
    return Container(
        margin: EdgeInsets.only(top: 20.w, bottom: 0),
        child: Column(
          // mainAxisAlignment: MainAxisAlignment.end,
          children: [
            Row(
              mainAxisAlignment: MainAxisAlignment.start,
              crossAxisAlignment: CrossAxisAlignment.start,
              children: [
                GestureDetector(
                  child: ClipRRect(
                      borderRadius: BorderRadius.circular(20.w),
                      child: SizedBox(
                          // color: Colors.white,
                          child: UtilsLiveImage.getLoadWidget(
                              rtmMessage.headImage),
                          // url: UserProvider().userModel.headImage,
                          width: 40.w,
                          height: 40.w)),
                  onTap: () {
                    widget.clickCallBack(ConfigLiveMethon.liveClickUserInfo,
                        int.parse(rtmMessage.userId ?? ''));
                  },
                ),
                const SizedBox(
                  width: 5,
                ),
                Column(
                  mainAxisAlignment: MainAxisAlignment.start,
                  crossAxisAlignment: CrossAxisAlignment.start,
                  children: [
                    Row(
                      children: [
                        // Visibility(
                        //   visible: int.parse(model.vipLevel) > 0,
                        //   child: Container(
                        //     height: 12,
                        //     width: 34,
                        //     margin: EdgeInsets.only(right: 10.w),
                        //     padding: EdgeInsets.symmetric(horizontal: 10),
                        //     decoration: BoxDecoration(
                        //         gradient: LinearGradient(
                        //             colors: FBKColor.PremiumColors[
                        //                 int.parse(model.vipLevel)]),
                        //         borderRadius: BorderRadius.circular(6)),
                        //     child: Center(
                        //       child: Text(
                        //         S.of(context).Centre_Pre + model.vipLevel,
                        //         style: const TextStyle(
                        //             fontSize: 11, color: FBKColor.white),
                        //         textAlign: TextAlign.center,
                        //       ),
                        //     )),),
                        Text(rtmMessage.name ?? '',
                            style: UtilsLiveTextStyle.middleTextBoldWhite),
                      ],
                    ),
                    const SizedBox(
                      height: 10,
                    ),
                    Container(
                      padding: const EdgeInsets.only(
                          left: 16, top: 10, right: 10, bottom: 10),
                      constraints: BoxConstraints(
                          maxWidth: 223.w,
                          // minHeight: 40.w,
                          minHeight: 38.w,
                          minWidth: 30.w),
                      // decoration: BoxDecoration(
                      //   borderRadius: BorderRadius.circular(5),
                      //   color: Color(0xFF2A0D47),
                      // ),
                      // padding: EdgeInsets.all(12),
                      decoration: BoxDecoration(
                          borderRadius: BorderRadius.circular(5),
                          // color: Color(UtilsLiveColor.color_B91E9B),
                          image: const DecorationImage(
                              //mimo_live_ui/zhibo_duorenliaotian_bieyan_bj
                              centerSlice: Rect.fromLTWH(15, 20, 1, 1),
                              image: AssetImage(
                                  'zhibo_duorenliaotian_bieyan_bj',
                                 ),
                              fit: BoxFit.fill)),
                      child: rtmMessage.typeMethod ==
                              ConfigLiveSocket.liveSocketConfig_sendGift
                          ? RichText(
                              text: TextSpan(
                                  style: DefaultTextStyle.of(context).style,
                                  children: [
                                    TextSpan(
                                        text: S.current.Live_give +
                                            (giftListGifts.num ?? '') +
                                            ' ’',
                                        style: const TextStyle(
                                            color: Color(
                                                UtilsLiveColor.color_white),
                                            fontSize: 14)),
                                    TextSpan(
                                        text: giftListGifts.name,
                                        style: const TextStyle(
                                            color: Color(
                                                UtilsLiveColor.color_FF64CE),
                                            fontSize: 14)),
                                    TextSpan(
                                        text: '‘ ' +
                                            S.current.Live_to +
                                            ' ' +
                                            nameStr,
                                        style: const TextStyle(
                                            color: Color(
                                                UtilsLiveColor.color_white),
                                            fontSize: 14)),
                                  ]),
                            )
                          : Text(
                              rtmMessage.content ?? '',
                              style: UtilsLiveTextStyle.smallTextWhite,
                              maxLines: null,
                            ),
                    )
                  ],
                )
              ],
            ),
          ],
        ));
  }

  scrollAnimation() {
    if (_scrollController.hasClients) {
      Future.delayed(const Duration(milliseconds: 50)).then((value) {
        _scrollController.animateTo(_scrollController.position.maxScrollExtent,
            duration: const Duration(milliseconds: 100), curve: Curves.easeIn);
      });
    }
  }

  @override
  void initState() {
    KeyboardVisibilityController().onChange.listen((bool visible) {
      if (visible && _scrollController.hasClients) {
        Future.delayed(const Duration(milliseconds: 200)).then((value) {
          scrollAnimation();
        });
      }
    });
    super.initState();
  }

  @override
  void dispose() {
    super.dispose();
    _scrollController.dispose();
  }

  @override
  void didUpdateWidget(WidgetLiveChatList oldWidget) {
    super.didUpdateWidget(oldWidget);
  }

  @override
  void didChangeDependencies() {
    super.didChangeDependencies();
  }
}
