import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:mmoo_live_room/Config/config_live_typedef.dart';
import 'package:mmoo_live_room/Utils/utils_live_image.dart';
import 'package:mmoo_live_room/generated/l10n.dart';

///邀请上麦  选择邀请类型  语音  视频
class WidgetLiveInvitePlaceList extends StatelessWidget {
  final ClickCallBack clickCallBack;

  WidgetLiveInvitePlaceList({ required this.clickCallBack});
  @override
  Widget build(BuildContext context) {
    return Container(
      height: 160.w + ScreenUtil().bottomBarHeight,
      padding: EdgeInsets.only(left: 80.w, right: 80.w, top: 40.w),
      decoration: const BoxDecoration(
          color: Color(0xff2B1248),
          borderRadius: BorderRadius.only(
              topLeft: Radius.circular(30), topRight: Radius.circular(30))),
      child: Row(
        mainAxisAlignment: MainAxisAlignment.spaceBetween,
        children: [
          GestureDetector(
            behavior: HitTestBehavior.opaque,
            onTap: () {
              Navigator.pop(context);
              clickCallBack('',0);
            },
            child: SizedBox(
              width: 60,
              child: Column(
                children: [
                  UtilsLiveImage.getIconByPath(
                    'icon_live_invite_voice_60',
                    
                  ),
                  SizedBox(
                    height: 10.w,
                  ),
                  SizedBox(
                    child: Text(
                      S.current.Live_Video,
                      style: TextStyle(
                          color: Colors.white.withOpacity(0.8),
                          fontWeight: FontWeight.bold,
                          fontSize: 18),
                    ),
                  )
                ],
              ),
            ),
          ),
          GestureDetector(
            behavior: HitTestBehavior.opaque,
            onTap: () {
              Navigator.pop(context);
              clickCallBack('',1);
            },
            child: SizedBox(
              width: 60,
              child: Column(
                children: [
                  UtilsLiveImage.getIconByPath(
                    'icon_live_invite_video_60',
                    
                  ),
                  SizedBox(
                    height: 10.w,
                  ),
                  SizedBox(
                    child: Text(
                      S.current.Live_Video,
                      style: TextStyle(
                          color: Colors.white.withOpacity(0.8),
                          fontWeight: FontWeight.bold,
                          fontSize: 18),
                    ),
                  )
                ],
              ),
            ),
          )
        ],
      ),
    );
  }
}
