import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:mmoo_base/entity/language_entity.dart';
import 'package:mmoo_live_room/Config/config_live_app.dart';
import 'package:mmoo_live_room/Config/config_live_methon.dart';
import 'package:mmoo_live_room/Config/config_live_typedef.dart';
import 'package:mmoo_live_room/Provider/provider_live_header_user.dart';
import 'package:mmoo_live_room/Provider/provider_live_info_entity.dart';
import 'package:mmoo_live_room/Provider/provider_live_online.dart';
import 'package:mmoo_live_room/Utils/utils_live_colors.dart';

import 'package:mmoo_live_room/Utils/utils_live_textStyle.dart';
import 'package:mmoo_live_room/Utils/utils_live_image.dart';
import 'package:provider/provider.dart';
///直播间  语言 人数view
class WidgetLiveLanguagePeople extends StatefulWidget {
  final double height;
  // final ModelLiveInfoEntity infoEntity;
  final ClickCallBack clickCallBack;
  // WidgetLiveStreamSingleVideo({required this.infoEntity});
  // ignore: use_key_in_widget_constructors
  const WidgetLiveLanguagePeople(
      {this.height = 22,
      // required this.infoEntity,
      required this.clickCallBack});
  @override
  WidgetLiveLanguagePeopleState createState() =>
      WidgetLiveLanguagePeopleState();
}

class WidgetLiveLanguagePeopleState extends State<WidgetLiveLanguagePeople> {
  @override
  Widget build(BuildContext context) {
    return Consumer<ProviderLiveInfoEntity>(
        builder: (context, infoEntityProvider, child) {
      LanguageLists? language;
      for (var element in ConfigLiveApp.langList) {
        if (element.code == infoEntityProvider.infoEntity.language) {
          language = element;
        }
      }

      return SizedBox(
        height: widget.height + 20.w,
        child: Row(
          mainAxisAlignment: MainAxisAlignment.spaceBetween,
          children: [
            Container(
              decoration: ShapeDecoration(
                shape: const StadiumBorder(),
                color: const Color(UtilsLiveColor.color_back).withOpacity(0.2),
              ),
              height: widget.height,
              padding: const EdgeInsets.symmetric(horizontal: 4),
              child: Row(
                children: [
                  UtilsLiveImage.getIconByPath(
                    'icon_live_lanuage',
                    
                  ),
                  const SizedBox(
                    width: 4,
                  ),
                  Text(
                    language?.value ?? '',
                    style: UtilsLiveTextStyle.pt12White,
                  )
                ],
              ),
            ),
            GestureDetector(
              onTap: () {
                widget.clickCallBack(ConfigLiveMethon.liveRoomUserList, null);
              },
              behavior: HitTestBehavior.opaque,
              child: Row(
                children: [
                  Consumer<ProviderLiveHeaderUser>(
                      builder: (context, headerUserProvider, child) {
                    return Wrap(
                      spacing: 5,
                      children: headerUserProvider.usersList.map((e) {
                        return SizedBox(
                          width: 22,
                          height: 22,
                          child: ClipRRect(
                            borderRadius: BorderRadius.circular(11),
                            child: UtilsLiveImage.getLoadWidget(e.headImage),
                          ),
                        );
                      }).toList(),
                    );
                  }),
                  const SizedBox(
                    width: 5,
                  ),
                  Container(
                    decoration: ShapeDecoration(
                      shape: const StadiumBorder(),
                      color:
                          const Color(UtilsLiveColor.color_back).withOpacity(0.2),
                    ),
                    height: widget.height,
                    alignment: Alignment.center,
                    padding: const EdgeInsets.symmetric(horizontal: 7),
                    child: Consumer<ProviderLiveOnline>(
                        builder: (context, onlineProvider, child) {
                      return Text(
                        (infoEntityProvider.infoEntity.price ?? 0) > 0
                            ? onlineProvider.payNum.toString()
                            : onlineProvider.onLineNum.toString(),
                        style: UtilsLiveTextStyle.pt12White,
                      );
                    }),
                  )
                ],
              ),
            )
          ],
        ),
      );
    });
  }

  @override
  void initState() {

    super.initState();
  }

  @override
  void dispose() {

    super.dispose();
  }

  @override
  void didUpdateWidget(WidgetLiveLanguagePeople oldWidget) {

    super.didUpdateWidget(oldWidget);
  }

  @override
  void didChangeDependencies() {
    super.didChangeDependencies();
  }
}
