
import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:mmoo_live_room/Config/config_live_methon.dart';
import 'package:mmoo_live_room/Config/config_live_typedef.dart';
import 'package:mmoo_live_room/Utils/utils_live_colors.dart';
import 'package:mmoo_live_room/Utils/utils_live_image.dart';
import 'package:mmoo_live_room/Widget/widget_action_btns.dart';
import 'package:mmoo_live_room/generated/l10n.dart';
import 'package:mmoo_live_room/Utils/utils_live_textStyle.dart';
///直播间  主播控制面板
class WidgetLiveMasterOperation {
  static showMasterOperation(BuildContext context,
      {ActionRowsSelect? actionRowsSelect,
      AnimationComplete? animatComplete}) async {
    await showDialog(
      context: context,
      builder: (ctx) {
        return Column(
          children: [
            Expanded(child: Container()),
            WidgetLiveMasterOperationView(
              actionRowsSelect: actionRowsSelect,
            ),
            Expanded(child: Container()),
          ],
        );
      },
    ).then((value) {
      if (animatComplete != null) {
        animatComplete();
      }
    });
  }
}

class WidgetLiveMasterOperationView extends StatefulWidget {
  final ActionRowsSelect? actionRowsSelect;
  // ignore: use_key_in_widget_constructors
  const WidgetLiveMasterOperationView({this.actionRowsSelect});
  @override
  WidgetLiveMasterOperationViewState createState() =>
      WidgetLiveMasterOperationViewState();
}

class WidgetLiveMasterOperationViewState
    extends State<WidgetLiveMasterOperationView> {
  List<String> rows = [
    S.current.Live_operation1,
    S.current.Live_operation2,
    S.current.Live_operation3,
    // S.current.Live_keep,
    S.current.Live_Exit,
  ];
  @override
  Widget build(BuildContext context) {
    return Container(
      margin: EdgeInsets.symmetric(horizontal: 20.w),
      padding: const EdgeInsets.all(15),
      decoration: BoxDecoration(
          borderRadius: BorderRadius.circular(20), color: Colors.white),
      child: Column(
        children: [
          Row(
            mainAxisAlignment: MainAxisAlignment.end,
            children: [
              GestureDetector(
                child: Container(
                  width: 40,
                  height: 40,
                  color: Colors.transparent,
                  child: UtilsLiveImage.getIconByPath(
                    'tanchuang_btn_guanbi',
                  ),
                ),
                onTap: () {
                  Navigator.pop(context);
                },
              ),
            ],
          ),
          Column(
            children: [
              for (var i = 0; i < rows.length; i++)
                GestureDetector(
                  onTap: () {
                    if (widget.actionRowsSelect != null) {
                      widget.actionRowsSelect!(i, rows[i]);
                    }
                    Navigator.pop(context);
                  },
                  child: Container(
                    color: Colors.transparent,
                    height: 60.w,
                    child: Column(
                      children: [
                        Expanded(
                          child: rows[i] == S.current.Live_Exit
                              ? Row(
                                  mainAxisAlignment: MainAxisAlignment.center,
                                  children: [
                                    UtilsLiveImage.getIconByPath(
                                      'tanchuang_btn_tuichu',
                                    ),
                                    Container(
                                      padding: EdgeInsets.only(left: 15.w),
                                      child: Text(
                                        rows[i],
                                        style: UtilsLiveTextStyle
                                            .big2TextBlackBold,
                                      ),
                                    )
                                  ],
                                )
                              : Center(
                                  child: Text(
                                    rows[i],
                                    style: UtilsLiveTextStyle.big2TextBlackBold,
                                  ),
                                ),
                        ),
                        Container(
                          color: UtilsLiveColor.hexToColor('#EEEEEE'),
                          height: rows.length == (i + 1) ? 0 : 1,
                        )
                      ],
                    ),
                  ),
                ),
              GestureDetector(
                child: UtilsLiveImage.getIconByPath(
                  'tanchuang_icon_guanbo',
                ),
                onTap: () {
                  if (widget.actionRowsSelect != null) {
                    widget.actionRowsSelect!(
                        rows.length, ConfigLiveMethon.liveCloseLive);
                  }
                  Navigator.pop(context);
                },
              )
            ],
          )
        ],
      ),
    );
  }

  @override
  void initState() {
    super.initState();
  }

  @override
  void dispose() {
    super.dispose();
  }

  @override
  void didUpdateWidget(WidgetLiveMasterOperationView oldWidget) {
    super.didUpdateWidget(oldWidget);
  }

  @override
  void didChangeDependencies() {
    super.didChangeDependencies();
  }
}
