import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:mmoo_live_room/Config/config_live_methon.dart';
import 'package:mmoo_live_room/Config/config_live_typedef.dart';
import 'package:mmoo_live_room/Provider/provider_live_placelist_info.dart';
import 'package:mmoo_live_room/Provider/provider_live_user.dart';
import 'package:mmoo_live_room/Utils/utils_live_image.dart';
import 'package:mmoo_live_room/generated/l10n.dart';
import 'package:mmoo_live_room/Model/model_live_info_entity.dart';
import 'package:mmoo_live_room/Utils/utils_live_dlog.dart';

// class WidgetLiveMore extends StatelessWidget {
///直播间底部 控制面板  美颜 旋转摄像头  麦克风等
class WidgetLiveMore extends StatefulWidget {
  final ClickCallBack clickCallBack;
  WidgetLiveMore({required this.clickCallBack});
  @override
  WidgetLiveMoreState createState() => WidgetLiveMoreState();
}

class WidgetLiveMoreState extends State<WidgetLiveMore> {
  @override
  Widget build(BuildContext context) {
    ModelLiveInfoPlaceList placeList = ModelLiveInfoPlaceList();
    DLog(ProviderLivePlaceListInfo().videoList.length);
    ProviderLivePlaceListInfo().videoList.forEach((e) {
      if (e.userId == ProviderLiveUser().userInfo.uid) {
        placeList = e;
      }
    });
    DLog(ProviderLivePlaceListInfo().voiceList.length);
    ProviderLivePlaceListInfo().voiceList.forEach((e) {
      if (e.userId == ProviderLiveUser().userInfo.uid) {
        placeList = e;
      }
    });
    List rows = [];
    if (placeList.userId != null) {
      rows.addAll(placeList.type == 0
          ? [
              {
                'im': ProviderLiveUser().voice == 1
                    ? "icon_live_mic_open_user"
                    : 'icon_live_mic_close_user',
                'tit': S.current.Live_mic
              },
              {
                'im': ProviderLiveUser().isSpeaker
                    ? "icon_live_sound_open"
                    : 'icon_live_sound_close',
                'tit': S.current.Live_Sound
              },
            ]
          : [
              {
                'im': ProviderLiveUser().voice == 1
                    ? "icon_live_mic_open_user"
                    : 'icon_live_mic_close_user',
                'tit': S.current.Live_mic
              },
              {
                'im': ProviderLiveUser().isSpeaker
                    ? "icon_live_sound_open"
                    : 'icon_live_sound_close',
                'tit': S.current.Live_Sound
              },
              {'im': "icon_live_Flip", 'tit': S.current.Live_Flip},
              //  美颜版本  有nana美颜库
              // {'im': "icon_live_beauty", 'tit': S.current.Live_Beauty},
              //
            ]);
    } else {
      rows.add({
        'im': ProviderLiveUser().isSpeaker
            ? "icon_live_sound_open"
            : 'icon_live_sound_close',
        'tit': S.current.Live_Sound
      });
    }
    return Container(
      // height: 300,
      width: 1.sw,
      padding: EdgeInsets.only(
          bottom: ScreenUtil().bottomBarHeight + 10.w, top: 20.w),
      decoration: const BoxDecoration(
          borderRadius: BorderRadius.only(
            topLeft: Radius.circular(30),
            topRight: Radius.circular(30),
          ),
          color: Color(0xff2B1248)),
// child: Consumer<ProviderLiveBottomState>(
//         builder: (context, unreadProvider, child) {
//           return Container(
//             child: Text(
//               Provider.of<ProviderLiveBottomState>(context).isMic.t
//             ),
//           );
//         })
      child: Wrap(
        alignment: WrapAlignment.center,
        runAlignment: WrapAlignment.center,
        spacing: 32.w,
        children: rows.map((e) => buildBtns(e)).toList(),
      ),
    );
  }

  Widget buildBtns(Map map) {
    return GestureDetector(
      onTap: () {
        // liveBottomRank liveBottomMic liveBottomlLoudSpeaker
        if (map['tit'] == S.current.Live_mic) {
          widget.clickCallBack(
              ConfigLiveMethon.liveBottomMic, null);
        } else if (map['tit'] == S.current.Live_Sound) {
          widget.clickCallBack(ConfigLiveMethon.liveBottomlLoudSpeaker,
              null);
        } else if (map['tit'] == S.current.Live_Flip) {
          widget.clickCallBack(ConfigLiveMethon.liveBottomFilp, null);
        } else if (map['tit'] == S.current.Live_Beauty) {
          widget.clickCallBack(ConfigLiveMethon.liveBottomBeauty, null);
        }
        
        Navigator.pop(context);
        //  if (ConfigLiveMethon.liveBottomMic == map['tit']) {
        //       widget.clickCallBack(map['tit'], !ProviderLiveBottomState().isMic);
        //     } else if (ConfigLiveMethon.liveBottomlLoudSpeaker == map['tit']) {
        //       widget.clickCallBack(map['tit'], !ProviderLiveBottomState().isSpeaker);
        //     } else {
        //     widget.clickCallBack(map['tit'], null);
        //     }
      },
      child: Column(
          children: [
            UtilsLiveImage.getIconByPath(
               map['im'] 
            ),
            Container(
              margin: EdgeInsets.only(top: 10.w),
              child: Text(
                map['tit'],
                style: TextStyle(color: Colors.white, fontSize: 16),
              ),
            )
          ],
        ),
      
    );
  }

  @override
  void initState() {
    // TODO: implement initState
    super.initState();
  }

  @override
  void dispose() {
    // TODO: implement dispose
    super.dispose();
  }

  @override
  void didUpdateWidget(WidgetLiveMore oldWidget) {
    // TODO: implement didUpdateWidget
    super.didUpdateWidget(oldWidget);
  }

  @override
  void didChangeDependencies() {
    // TODO: implement didChangeDependencies
    super.didChangeDependencies();
  }
}
