// ignore_for_file: use_key_in_widget_constructors

import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:mmoo_live_room/Utils/utils_live_image.dart';
import 'package:mmoo_live_room/Utils/utils_live_textStyle.dart';
import 'package:mmoo_live_room/Utils/utils_live_repeat_click.dart';


typedef ChooseCallback = Function(int index);

class WidgetLiveMoreChoose extends StatelessWidget {
  final List rows;
  final String titStr;
  final ChooseCallback chooseCallback;
  const WidgetLiveMoreChoose(
      {required this.titStr, required this.rows, required this.chooseCallback});
  @override
  Widget build(BuildContext context) {
    return Container(
      constraints: BoxConstraints(
        maxHeight: 350.w + ScreenUtil().bottomBarHeight,
      ),
      height: 50.w * rows.length + 60.w + ScreenUtil().bottomBarHeight,
      
      child: Column(
        children: [
          Container(
            height: 60.w,
            margin: EdgeInsets.symmetric(horizontal: 15.w),
            child: Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: [
                const SizedBox(width: 40,
                    height: 40,),
                Text(
                  titStr,
                  style: UtilsLiveTextStyle.pt20WhiteSemiBold,
                ),
                GestureDetector(
                  behavior: HitTestBehavior.opaque,
                  onTap: UtilsLiveRepeatClick.debounce(() {
                    Navigator.pop(context);
                  }),
                  child: UtilsLiveImage.getIconByPath(
                    'live_open_close',
                    width: 40,
                    height: 40,
                  ),
                )
              ],
            ),
          ),
         MediaQuery.removePadding(
           removeTop: true,
           removeBottom: true,
           context: context, child:  Expanded(
              child: ListView.separated(
                  padding:
                      EdgeInsets.only(bottom: ScreenUtil().bottomBarHeight),
                  itemBuilder: (BuildContext context, int index) {
                    return GestureDetector(
                      behavior: HitTestBehavior.opaque,
                      onTap: UtilsLiveRepeatClick.debounce(() {
                        chooseCallback(index);
                        Navigator.pop(context);
                      }),
                      child: Container(
                        height: 50.w,
                        alignment: Alignment.center,
                        child: Text(
                          rows[index],
                          style: UtilsLiveTextStyle.pt16White,
                        ),
                      ),
                    );
                  },
                  separatorBuilder: (BuildContext context, int index) {
                    return Container(
                      margin: EdgeInsets.symmetric(horizontal: 15.w),
                      color: Colors.white.withOpacity(0.1),
                      height: 1,
                    );
                  },
                  itemCount: rows.length)))
        ],
      ),
    );
  }
}
