



//  美颜版本  有nana美颜库
// import 'package:agora_rtc/rtc_engine.dart';
// 不带美颜版本
import 'package:agora_rtc_engine/rtc_engine.dart';


import 'package:flutter/material.dart';
import 'package:lottie/lottie.dart';

///播放语音音量动画
class WidgetLivePlaceVolume extends StatefulWidget {
  final Widget child;
  final double width;
  final double height;
  @override
  // ignore: overridden_fields
  final Key key;
  final int type;
  // final int uid;
  const WidgetLivePlaceVolume(
      {required this.child, required this.width, required this.height,required this.key,this.type = 0})
      : super(key: key);
  @override
  WidgetLivePlaceVolumeState createState() => WidgetLivePlaceVolumeState();
}

class WidgetLivePlaceVolumeState extends State<WidgetLivePlaceVolume>
    with TickerProviderStateMixin {
  late final AnimationController _controller;
  bool isPlayLottie = false;
  @override
  Widget build(BuildContext context) {
    return SizedBox(
      width: widget.width,
      height: widget.height,
      child: Stack(
        children: [
          Positioned.fill(
              child: Lottie.asset(
                   AssetLottie(widget.type == 0?  "lib/assets/json/voice_mic.json" : 'lib/assets/json/live_mic.json').assetName,
                   package: 'mmoo_live_room',
                   onLoaded: (composition) {
            _controller
              .duration = composition.duration;
              // ..forward();
          },
                  // animate: isPlayLottie,
                  // width: 50.w,
                  // height: 50.w
                  controller: _controller)),
          Positioned.fill(
              child: Center(
            child: widget.child,
          ))
        ],
      ),
    );
  }

  void liveVolumeIndication(AudioVolumeInfo volumeInfo) {
    bool isChange = volumeInfo.volume > 20 ;
    if (isChange != isPlayLottie) {
      isPlayLottie = isChange;
      if (isPlayLottie) {
        _controller.value = 0;
        _controller.forward();
      } 
    }
  }

  @override
  void initState() {
    _controller = AnimationController(
      vsync: this,
    );
    _controller.addStatusListener((status) {
      if (status == AnimationStatus.completed) {
        if (isPlayLottie) {
          _controller.value = 0;
          _controller.forward();
        }
      }
    });
    super.initState();
  }

  @override
  void dispose() {
    _controller.dispose();
    super.dispose();
  }

  @override
  void didUpdateWidget(  WidgetLivePlaceVolume oldWidget) {
    super.didUpdateWidget(oldWidget);
  }

  @override
  void didChangeDependencies() {
    super.didChangeDependencies();
  }
}
