import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:mmoo_live_room/Config/config_live_app.dart';
import 'package:mmoo_live_room/Config/config_live_methon.dart';
import 'package:mmoo_live_room/Config/config_live_typedef.dart';
import 'package:mmoo_live_room/Provider/provider_live_user.dart';
import 'package:mmoo_live_room/Utils/utils_live_colors.dart';
import 'package:mmoo_live_room/generated/l10n.dart';
import 'package:mmoo_live_room/Model/model_live_info_entity.dart';
import 'package:mmoo_live_room/Utils/utils_live_image.dart';
///直接间  详情页面  展示主播  及房间信息
class WidgetLiveRoomInfo extends StatefulWidget {
  final ClickCallBack clickCallBack;
  final ModelLiveInfoEntity infoEntity;
  // ignore: use_key_in_widget_constructors
  const WidgetLiveRoomInfo(
      {required this.infoEntity, required this.clickCallBack});
  @override
  WidgetLiveRoomInfoState createState() => WidgetLiveRoomInfoState();
}

class WidgetLiveRoomInfoState extends State<WidgetLiveRoomInfo> {
  @override
  Widget build(BuildContext context) {
    return Container(
        // height: 400.w + ScreenUtil().bottomBarHeight,
        padding: EdgeInsets.symmetric(horizontal: 15.w),
        decoration: const BoxDecoration(
            color: Color(0xff2B1248),
            borderRadius: BorderRadius.only(
                topLeft: Radius.circular(30), topRight: Radius.circular(30))),
        child: Column(children: [
          SizedBox(
            height: 60,
            child: Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: [
                const SizedBox(
                  width: 40,
                  height: 40,
                ),
                Text(
                  S.current.Live_RoomInformation,
                  style: const TextStyle(
                      color: Colors.white,
                      fontSize: 20,
                      fontWeight: FontWeight.bold),
                ),
                GestureDetector(
                  child: SizedBox(
                    width: 40,
                    height: 40,
                    child: UtilsLiveImage.getIconByPath('live_open_close'),
                  ),
                  onTap: () {
                    Navigator.pop(context);
                  },
                )
              ],
            ),
          ),
          SizedBox(
            height: 80.w,
            child: Row(
              children: [
                ClipRRect(
                  borderRadius: BorderRadius.circular(10),
                  child: UtilsLiveImage.getLoadWidget(widget.infoEntity.cover),
                ),
                Container(
                  margin: EdgeInsets.only(left: 10.w),
                  padding: const EdgeInsets.symmetric(vertical: 5),
                  constraints: BoxConstraints(maxWidth: 248.w),
                  child: Column(
                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                    crossAxisAlignment: CrossAxisAlignment.start,
                    children: [
                      Text(
                        widget.infoEntity.title ?? '',
                        maxLines: 1,
                        overflow: TextOverflow.ellipsis,
                        style: const TextStyle(
                            color: Colors.white,
                            fontSize: 20,
                            fontWeight: FontWeight.bold),
                      ),
                      Text(
                        S.current.Live_FollowersRoom(widget.infoEntity.subNums ?? '')
                        ,
                        maxLines: 1,
                        overflow: TextOverflow.ellipsis,
                        style: TextStyle(
                            color: Colors.white.withOpacity(0.8),
                            fontSize: 16,
                            fontWeight: FontWeight.bold),
                      ),
                      Text(
                         S.current.Live_RoomID( widget.infoEntity.roomId.toString()),
                        maxLines: 1,
                        overflow: TextOverflow.ellipsis,
                        style: TextStyle(
                            color: Colors.white.withOpacity(0.8),
                            fontSize: 16,
                            fontWeight: FontWeight.bold),
                      ),
                    ],
                  ),
                )
              ],
            ),
          ),
          Container(
            margin: EdgeInsets.only(top: 20.w),
            alignment: Alignment.topLeft,
            child:  Text(
S.current.Live_Roomannouncement
              ,
              // 'Room announcement:',
              maxLines: 1,
              overflow: TextOverflow.ellipsis,
              style: const TextStyle(
                  color: Colors.white,
                  fontSize: 18,
                  fontWeight: FontWeight.bold),
            ),
          ),
          Container(
            margin: EdgeInsets.only(
              top: 5.w,
            ),
            alignment: Alignment.topLeft,
            child: Text(
              (widget.infoEntity.liveNotice ?? '').isNotEmpty
                  ? (widget.infoEntity.liveNotice ?? '')
                  : S.current.Live_WelcometotheRoom,
              maxLines: 1,
              overflow: TextOverflow.ellipsis,
              style: TextStyle(
                  color: Colors.white.withOpacity(0.6),
                  fontSize: 16,
                  fontWeight: FontWeight.normal),
            ),
          ),
          Container(
            margin: EdgeInsets.only(top: 20.w),
            alignment: Alignment.topLeft,
            child:  Text(
              S.current.Live_Owners,
              maxLines: 1,
              overflow: TextOverflow.ellipsis,
              style: const TextStyle(
                  color: Colors.white,
                  fontSize: 18,
                  fontWeight: FontWeight.bold),
            ),
          ),
          buildMemberList(),
          SizedBox(
            height: ScreenUtil().bottomBarHeight,
          )
        ]));
  }

  Widget buildMemberList() {
    return SizedBox(
      height: 70,
      // margin: EdgeInsets.symmetric(horizontal: 15.w, vertical: 13.w),
      child: Row(
        mainAxisAlignment: MainAxisAlignment.spaceBetween,
        children: [
          Row(
            children: [
              GestureDetector(
                  onTap: () {
                    Navigator.pop(context);
                    widget.clickCallBack(ConfigLiveMethon.liveClickUserInfo,
                        int.parse((widget.infoEntity.userId.toString())));
                  },
                  child: ClipRRect(
                    borderRadius: BorderRadius.circular(25.w),
                    child: SizedBox(
                      width: 50.w,
                      height: 50.w,
                      child: UtilsLiveImage.getLoadWidget(
                          widget.infoEntity.headImage),
                    ),
                  )),
              Column(
                mainAxisAlignment: MainAxisAlignment.center,
                crossAxisAlignment: CrossAxisAlignment.start,
                children: [
                  Row(
                    children: [
                      Container(
                        padding: const EdgeInsets.symmetric(horizontal: 10),
                        constraints: BoxConstraints(maxWidth: 180.w),
                        child: Text(
                          widget.infoEntity.nickname ?? '',
                          maxLines: 1,
                          overflow: TextOverflow.ellipsis,
                          style: TextStyle(
                              fontSize: 18,
                              color: UtilsLiveColor.hexToColor("#FFFFFF"),
                              fontWeight: FontWeight.bold,
                              wordSpacing: -1,
                              decoration: TextDecoration.none),
                        ),
                      ),
                    ],
                  ),
                  const SizedBox(
                    height: 3,
                  ),
                  Container(
                    height: 20,
                    margin: const EdgeInsets.only(left: 10),
                    padding: const EdgeInsets.symmetric(horizontal: 7),
                    decoration: BoxDecoration(
                        borderRadius: BorderRadius.circular(10),
                        color: UtilsLiveColor.hexToColor('#EB6B00')),
                    child: Row(
                      children:  [
                        Text(
                          S.current.Live_Owners,
                          style: const TextStyle(
                              color: Colors.white,
                              fontSize: 12,
                              fontWeight: FontWeight.normal,
                              decoration: TextDecoration.none),
                        )
                      ],
                    ),
                  )
                ],
              ),
            ],
          ),
          Visibility(
              visible:
                  ProviderLiveUser().userInfo.uid != widget.infoEntity.userId &&
                      ProviderLiveUser().userInfo.isHost != '1',
              child: Row(
                children: [
                  buildMessageBtn(),
                  SizedBox(
                    width: 10.w,
                  ),
                  Visibility(
                    visible: ConfigLiveApp.gui,
                    child: 
                  buildVideoBtn())
                ],
              ))
        ],
      ),
    );
  }

  Widget buildVideoBtn() {
    return GestureDetector(
      behavior: HitTestBehavior.opaque,
      onTap: () async {
        widget.clickCallBack(ConfigLiveMethon.liveUserCallVideo,
            widget.infoEntity.userId.toString());
        // if (await UtilsLive().checkOtherPartyIsOnRoom(
        //     listModel.userId ?? 0, widget.infoEntity.roomId ?? 0)) {
        //   await AgoraRtmManager.getInstance().sendLiveToPeerMessage(
        //       UtilsLive().rtmSendInviteJoinPlaceMap(1),
        //       (listModel.userId ?? 0).toString());
        //        listModel.invitedCOunt = 5;
        //   if (mounted) {
        //     setState(() {});
        //   }
        // }
      },
      child: UtilsLiveImage.getIconByPath(
        'icon_live_room_videocall',
      ),
    );
  }

  Widget buildMessageBtn() {
    return GestureDetector(
      behavior: HitTestBehavior.opaque,
      onTap: () async {
        widget.clickCallBack(
            ConfigLiveMethon.liveUserIMChat, widget.infoEntity.userId.toString());
      },
      child: UtilsLiveImage.getIconByPath(
        'icon_live_room_messagecall',
      ),
    );
  }

  @override
  void initState() {
    super.initState();
  }

  @override
  void dispose() {
    super.dispose();
  }

  @override
  void didUpdateWidget(WidgetLiveRoomInfo oldWidget) {
    super.didUpdateWidget(oldWidget);
  }

  @override
  void didChangeDependencies() {
    super.didChangeDependencies();
  }
}
