import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:mmoo_live_room/Config/config_live_methon.dart';
import 'package:mmoo_live_room/Config/config_live_typedef.dart';
import 'package:mmoo_live_room/Utils/utils_live_image.dart';
import 'package:mmoo_live_room/generated/l10n.dart';
import 'package:mmoo_live_room/Utils/utils_live_repeat_click.dart';
///主播间  主播设置界面
class WidgetLiveSetting extends StatelessWidget {
  final ClickCallBack clickCallBack;
  WidgetLiveSetting({required this.clickCallBack});
  @override
  Widget build(BuildContext context) {
    List rows = [
      S.current.Live_operation1,
      S.current.Live_operation2,
      S.current.Live_operation3
    ];
    return Container(
      decoration: const BoxDecoration(
          color: Color(0xff2B1248),
          borderRadius: BorderRadius.only(
              topLeft: Radius.circular(30), topRight: Radius.circular(30))),
      child: Column(
        children: [
          Container(
            margin: EdgeInsets.symmetric(horizontal: 10.w),
            height: 60.w,
            child: Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: [
                Container(
                  width: 40,
                ),
                 Text(
                  S.current.Live_Setting,
                  style: const TextStyle(
                      fontSize: 20,
                      color: Colors.white,
                      fontWeight: FontWeight.bold,
                      decoration: TextDecoration.none),
                ),
                GestureDetector(
                  onTap: UtilsLiveRepeatClick.debounce(() {
                    Navigator.pop(context);
                  }),
                  child: UtilsLiveImage.getIconByPath(
                    'live_open_close',
                    
                    width: 40,
                    height: 40,
                  ),
                )
              ],
            ),
          ),
          SizedBox(
            height: rows.length * 50.w,
            child: ListView.separated(
                physics: const NeverScrollableScrollPhysics(),
                itemBuilder: (co, index) {
                  return GestureDetector(
                    onTap: () {
                      clickCallBack(rows[index], '');
                      Navigator.pop(context);
                    },
                    behavior: HitTestBehavior.opaque,
                    child: Container(
                      height: 50.w,
                      margin: EdgeInsets.symmetric(horizontal: 15.w),
                      child: Row(
                        mainAxisAlignment: MainAxisAlignment.spaceBetween,
                        children: [
                          Text(
                            rows[index],
                            style:const  TextStyle(
                                fontSize: 18,
                                color: Colors.white,
                                fontWeight: FontWeight.bold,
                                decoration: TextDecoration.none),
                          ),
                          UtilsLiveImage.getIconByPath(
                            'icon_live_go',
                            
                          )
                        ],
                      ),
                    ),
                  );
                },
                separatorBuilder: (co, index) {
                  return Container(
                    margin: EdgeInsets.only(left: 15.w),
                    height: 1,
                    color: Colors.white.withOpacity(0.1),
                  );
                },
                itemCount: rows.length),
          ),
          Container(
            margin: EdgeInsets.only(
                top: 20.w, bottom: ScreenUtil().bottomBarHeight + 10.w),
            child: Row(
              mainAxisAlignment: MainAxisAlignment.center,
              children: [
                GestureDetector(
                    onTap: () {
                      clickCallBack(ConfigLiveMethon.liveExitRoom, '');
                      // Navigator.pop(context);
                    },
                    behavior: HitTestBehavior.opaque,
                    child: Container(
                      width: 165.w,
                      height: 50.w,
                      alignment: Alignment.center,
                      decoration: BoxDecoration(
                          borderRadius: BorderRadius.circular(25.w),
                          border:
                              Border.all(color: const Color(0xffFB5C9A), width: 2)),
                      child: Row(
                        mainAxisAlignment: MainAxisAlignment.center,
                        children: [
                          UtilsLiveImage.getIconByPath(
                            'icon_live_Exit',
                            
                          ),
                          SizedBox(
                            width: 5.w,
                          ),
                          Text(
                            S.current.Live_Exit,
                            style:const  TextStyle(
                              fontSize: 18,
                              fontWeight: FontWeight.bold,
                              color: Color(0xffFB5C9A),
                            ),
                          )
                        ],
                      ),
                    )),
                SizedBox(
                  width: 15.w,
                ),
                GestureDetector(
                    onTap: () {
                      clickCallBack(ConfigLiveMethon.liveCloseLive, '');
                      // Navigator.pop(context);
                    },
                    behavior: HitTestBehavior.opaque,
                    child: Container(
                      width: 165.w,
                      height: 50.w,
                      alignment: Alignment.center,
                      decoration: BoxDecoration(
                          borderRadius: BorderRadius.circular(25.w),
                          color: const Color(0xffF53838)),
                      child: Row(
                        mainAxisAlignment: MainAxisAlignment.center,
                        children: [
                          UtilsLiveImage.getIconByPath(
                            'icon_live_setting_close',
                            
                          ),
                          SizedBox(
                            width: 5.w,
                          ),
                          Text(
                            S.current.Live_Close,
                            style:const  TextStyle(
                              fontSize: 18,
                              fontWeight: FontWeight.bold,
                              color: Colors.white,
                            ),
                          )
                        ],
                      ),
                    ))
              ],
            ),
          )
        ],
      ),
    );
  }
}
