import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';


//  美颜版本  有nana美颜库
// import 'package:agora_rtc/rtc_local_view.dart' as RtcLocalView;
// import 'package:agora_rtc/rtc_remote_view.dart' as RtcRemoteView;
// 不带美颜版本
import 'package:agora_rtc_engine/rtc_local_view.dart' as RtcLocalView;
import 'package:agora_rtc_engine/rtc_remote_view.dart' as RtcRemoteView;



import 'package:mmoo_country_pickers/mmoo_country_pickers.dart';
import 'package:mmoo_live_room/Config/config_live_globalkey.dart';
import 'package:mmoo_live_room/Config/config_live_methon.dart';
import 'package:mmoo_live_room/Config/config_live_typedef.dart';
import 'package:mmoo_live_room/Provider/provider_live_placelist_info.dart';
import 'package:mmoo_live_room/Provider/provider_live_user.dart';
import 'package:mmoo_live_room/Utils/utils_live_image.dart';
import 'package:mmoo_live_room/Widget/widget_live_place_volume.dart';
import 'package:mmoo_live_room/Utils/utils_live_textStyle.dart';
import 'package:mmoo_live_room/generated/l10n.dart';
import 'package:provider/provider.dart';

//多人视频直播 视频位
class WidgetLiveStreamMultiVideo extends StatefulWidget {
  final ClickCallBack clickCallBack;

  WidgetLiveStreamMultiVideo({required this.clickCallBack})
      : super(key: ConfigLiveGlobalkey.streamvideoKey);
  @override
  WidgetLiveStreamMultiVideoState createState() =>
      WidgetLiveStreamMultiVideoState();
}

class WidgetLiveStreamMultiVideoState
    extends State<WidgetLiveStreamMultiVideo> {
  // List streamLists = ['', '', '', ''];

  Map<int, GlobalKey<WidgetLivePlaceVolumeState>> videoVolumMap = {};
  @override
  Widget build(BuildContext context) {
    return Consumer<ProviderLivePlaceListInfo>(
        builder: (context, palceProvider, child) {
      videoVolumMap.clear();
      for (var element in palceProvider.videoList) {
        if (element.userId != null && (element.userId ?? 0) > 0) {
          // vioceHeaderList.add({element.userId,GlobalKey<>);
          videoVolumMap[element.userId!] =
              GlobalKey<WidgetLivePlaceVolumeState>();
        }
      }
      return Column(
        children: [
          Wrap(
            // spacing: 4.8.w,
            // runSpacing: 4.8.w,
            alignment: WrapAlignment.center,
            runAlignment: WrapAlignment.center,
            children: palceProvider.videoList.map((e) {
              return GestureDetector(
                onTap: () {
                  // print("object");
                  widget.clickCallBack(ConfigLiveMethon.liveClickPlcaeInfo, e);
                },
                onLongPress: () {},
                child: SizedBox(
                    width: 1.sw * 0.5,
                    height: 1.sw * 0.5,
                    // color: UtilsLiveColor.hexToColor('#1A0834'),
                    child:
                        //  (e.userId == null)
                        //     ? buildVideoGuest()
                        //     :
                        Stack(
                      children: [
                        (e.userId == null || e.userId == 0)
                            ? Container(
                                decoration: BoxDecoration(
                                    color: Colors.white.withOpacity(0.1)
                                    // borderRadius: BorderRadius.circular(20),
                                    ),
                                alignment: Alignment.center,
                                child: UtilsLiveImage.getIconByPath(
                                  'icon_live_video_seat',
                                ),
                              )
                            : e.userId == ProviderLiveUser().userInfo.uid
                                ? RtcLocalView.SurfaceView()
                                : RtcRemoteView.SurfaceView(
                                    uid: e.userId ?? 0,
                                  ),
                        Positioned.fill(
                          child: Column(
                            mainAxisAlignment: MainAxisAlignment.spaceBetween,
                            children: [
                              Row(
                                mainAxisAlignment:
                                    MainAxisAlignment.spaceBetween,
                                children: [
                                  Container(
                                    height: 18,
                                    alignment: Alignment.center,
                                    padding: const EdgeInsets.symmetric(
                                        horizontal: 5),
                                    decoration: BoxDecoration(
                                      borderRadius: const BorderRadius.only(
                                          bottomRight: Radius.circular(5)),
                                      color: (e.userId == null)
                                          ? Colors.transparent
                                          : const Color(0xFF000000)
                                              .withOpacity(0.4),
                                    ),
                                    child: Text(
                                      (e.streamSeq ?? '').toString() +
                                          ' ' +
                                          ((e.userId == null)
                                              ? ""
                                              : e.role == 0
                                                  ? S.current.Live_Owners
                                                  : e.isHost == 1
                                                      ? S.current.Live_Anchor
                                                      : S.current.Live_GuestInfo),
                                      style: TextStyle(
                                          color: e.role == 0
                                              ? const Color(0xffFB5C9A)
                                              : e.isHost == 1
                                                  ? const Color(0xffEB6B00)
                                                  : (e.userId == null)
                                                      ? Colors.white
                                                          .withOpacity(0.6)
                                                      : Colors.white
                                                          .withOpacity(0.8),
                                          fontSize: 12,
                                          fontWeight: FontWeight.bold),
                                    ),
                                  ),
                                  Visibility(
                                      visible: e.userId != null,
                                      child: Container(
                                        // color: Colors.red,
                                        alignment: Alignment.center,
                                        padding: const EdgeInsets.symmetric(
                                            horizontal: 5),
                                        height: 18,
                                        child: Row(
                                          children: [
                                            UtilsLiveImage.getIconByPath(
                                              'icon_live_gift',
                                            ),
                                            const SizedBox(
                                              width: 3,
                                            ),
                                            Text(
                                              e.giftNum.toString(),
                                              style: const TextStyle(
                                                  color: Colors.white,
                                                  fontSize: 12,
                                                  fontWeight: FontWeight.bold),
                                            ),
                                          ],
                                        ),
                                      ))
                                ],
                              ),
                              Visibility(
                                  visible: e.userId != null,
                                  child: Container(
                                    margin: const EdgeInsets.all(5),
                                    height: 24,
                                    child: Row(
                                      mainAxisAlignment:
                                          MainAxisAlignment.spaceBetween,
                                      crossAxisAlignment:
                                          CrossAxisAlignment.end,
                                      children: [
                                        Container(
                                          padding: const EdgeInsets.symmetric(
                                              horizontal: 3.5),
                                          // decoration: BoxDecoration(
                                          //   borderRadius:
                                          //       BorderRadius.circular(7.5),
                                          //   color: Color(0xFFFD7D7D),
                                          // ),
                                          child: Row(
                                            children: [
                                              e.userId == null
                                                  ? Container()
                                                  : WidgetLivePlaceVolume(
                                                      child: UtilsLiveImage
                                                          .getIconByPath(
                                                        e.voice == 2
                                                            ? 'icon_live_mic_close'
                                                            : e.voice == 0
                                                                ? 'icon_live_mic_ban'
                                                                : 'icon_live_mic_open',
                                                      ),
                                                      width: 26.w,
                                                      height: 26.w,
                                                      key: videoVolumMap[
                                                          e.userId!]!),
                                              Container(
                                                margin: EdgeInsets.symmetric(
                                                    horizontal: 5.w),
                                                constraints: BoxConstraints(
                                                  maxWidth:
                                                      (e.isHost ?? '') == '1'
                                                          ? 120.w
                                                          : 30.w,
                                                ),
                                                child: Text(
                                                  e.nickname ?? '',
                                                  maxLines: 1,
                                                  overflow:
                                                      TextOverflow.ellipsis,
                                                  style: const TextStyle(
                                                      color: Colors.white,
                                                      fontSize: 12,
                                                      fontWeight:
                                                          FontWeight.bold),
                                                ),
                                              ),
                                              UtilsLiveImage.getIconByPath(
                                                AssetImage(CountryPickerUtils
                                                        .getFlagImageAssetPath(
                                                            CountryPickerUtils
                                                                    .getCountryByPhoneCode(
                                                                        e.country ??
                                                                            '1')
                                                                ?.isoCode))
                                                    .assetName,
                                                fit: BoxFit.cover,
                                                height: 10,
                                                package: "mmoo_country_pickers",
                                              ),
                                            ],
                                          ),
                                        ),
                                        Container()
                                        // Visibility(
                                        //     visible: e.isHost == 1 &&
                                        //         ProviderLiveUser()
                                        //                 .userInfo
                                        //                 .uid !=
                                        //             e.userId,
                                        //     child: GestureDetector(
                                        //       onTap: () {
                                        //         widget.clickCallBack(
                                        //             ConfigLiveMethon
                                        //                 .liveUserCallVideo,
                                        //             e.userId.toString());
                                        //       },
                                        //       child: Container(
                                        //         height: 24,
                                        //         padding: EdgeInsets.symmetric(
                                        //             horizontal: 5.w),
                                        //         decoration: ShapeDecoration(
                                        //             shape:
                                        //                 const StadiumBorder(),
                                        //             gradient:
                                        //                 LinearGradient(colors: [
                                        //               const Color(0xFFFB5C9A)
                                        //                   .withOpacity(0.8),
                                        //               const Color(0xFFF775F2)
                                        //                   .withOpacity(0.8)
                                        //             ])),
                                        //         child: Row(
                                        //           children: [
                                        //             UtilsLiveImage
                                        //                 .getIconByPath(
                                        //               'icon_live_Video Call',
                                        //             ),
                                        //             SizedBox(
                                        //               width: 5.w,
                                        //             ),
                                        //             const Text(
                                        //               "Take me",
                                        //               maxLines: 1,
                                        //               overflow:
                                        //                   TextOverflow.ellipsis,
                                        //               style: TextStyle(
                                        //                   color: Colors.white,
                                        //                   fontSize: 12,
                                        //                   fontWeight:
                                        //                       FontWeight.bold),
                                        //             ),
                                        //           ],
                                        //         ),
                                        //       ),
                                        //     ))
                                      ],
                                    ),
                                  ))
                            ],
                          ),
                        )
                      ],
                    )),
              );
            }).toList(),
          )
        ],
      );
    });
  }

  Widget buildVideoGuest() {
    return Container(
      decoration: BoxDecoration(color: Colors.white.withOpacity(0.1)
          // borderRadius: BorderRadius.circular(20),
          ),
      child: Column(
        mainAxisAlignment: MainAxisAlignment.center,
        children: [
          Container(
            padding: EdgeInsets.only(bottom: 8.w),
            child: UtilsLiveImage.getIconByPath(
              'yuyin_zhuyuyinxi_icon_xuweiyidai',
            ),
          ),
           Text(
            S.current.Live_VideoGuest,
            style: UtilsLiveTextStyle.pt14A39CADSemiBold,
          )
        ],
      ),
    );
  }

  @override
  void initState() {
    super.initState();
  }

  @override
  void dispose() {
    super.dispose();
  }

  @override
  void didUpdateWidget(WidgetLiveStreamMultiVideo oldWidget) {
    super.didUpdateWidget(oldWidget);
  }

  @override
  void didChangeDependencies() {
    super.didChangeDependencies();
  }
}
