// ignore_for_file: library_prefixes

import 'package:flutter/material.dart';


//  美颜版本  有nana美颜库
// import 'package:agora_rtc/rtc_local_view.dart' as RtcLocalView;
// import 'package:agora_rtc/rtc_remote_view.dart' as RtcRemoteView;
// 不带美颜版本
import 'package:agora_rtc_engine/rtc_local_view.dart' as RtcLocalView;
import 'package:agora_rtc_engine/rtc_remote_view.dart' as RtcRemoteView;

import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:mmoo_live_room/Config/config_live_methon.dart';
import 'package:mmoo_live_room/Config/config_live_typedef.dart';
import 'package:mmoo_live_room/Provider/provider_live_placelist_info.dart';
import 'package:mmoo_live_room/Provider/provider_live_user.dart';
import 'package:mmoo_live_room/Utils/utils_live_image.dart';
import 'package:mmoo_live_room/Utils/utils_live_textStyle.dart';
import 'package:mmoo_live_room/Utils/utils_live_repeat_click.dart';
import 'package:mmoo_live_room/generated/l10n.dart';
import 'package:provider/provider.dart';

//单人视频直播 视频位
class WidgetLiveStreamSingleVideo extends StatefulWidget {
  final ClickCallBack clickCallBack;
  // final ModelLiveInfoEntity infoEntity;
  // ignore: use_key_in_widget_constructors
  const WidgetLiveStreamSingleVideo({required this.clickCallBack});

  @override
  WidgetLiveStreamSingleVideoState createState() =>
      WidgetLiveStreamSingleVideoState();
}

class WidgetLiveStreamSingleVideoState
    extends State<WidgetLiveStreamSingleVideo> {
  @override
  Widget build(BuildContext context) {
    return Consumer<ProviderLivePlaceListInfo>(
        builder: (context, palceProvider, child) {
      return GestureDetector(
        child: SizedBox(
          width: 1.sw,
          height: 1.sh,
          // child: buildNetStreamer(),
          child: palceProvider.videoList.isEmpty
              ? buildNetStreamer()
              : (palceProvider.videoList.first.userId ?? 0) > 0
                  ? palceProvider.videoList.first.userId ==
                          ProviderLiveUser().userInfo.uid
                      ? RtcLocalView.SurfaceView()
                      : RtcRemoteView.SurfaceView(
                          uid: palceProvider.videoList.first.userId ?? 0)
                  : noSreaingView(),
        ),
        onTap: () {
          widget.clickCallBack(
              ConfigLiveMethon.liveClickPlcaeInfo, palceProvider.videoList.first);
        },
      );
    });
  }

  Widget buildNetStreamer() {
    return Center(
      child: Container(
        // padding: EdgeInsets.only(top: 10.w,bottom: 25.w),
        height: 180.w,
        width: 255.w,
        decoration: BoxDecoration(
            borderRadius: BorderRadius.circular(20),
            color:const  Color(0xFFDFDFDF).withAlpha(51)),
        child: Column(
          children: [
            Container(
              decoration: BoxDecoration(
                  borderRadius: const BorderRadius.only(
                      topLeft: Radius.circular(20),
                      topRight: Radius.circular(20)),
                  color: const Color(0xFFFFFFFF).withAlpha(51)),
              height: 45.w,
              child: Center(
                child: Text(
                  S.current.Live_KindReminder,
                  style: TextStyle(
                      color: Colors.white.withAlpha(127), fontSize: 18),
                ),
              ),
            ),
            Expanded(
                child: Center(
              child: Text(
                S.current.Live_NoSreaming,
                textAlign: TextAlign.center,
                style:
                    TextStyle(color: Colors.white.withAlpha(75), fontSize: 14),
              ),
            )),
            GestureDetector(
              onTap: UtilsLiveRepeatClick.debounce(() {
                widget.clickCallBack(ConfigLiveMethon.liveRefreshInfo, '');
              }),
              child: Container(
                margin: EdgeInsets.only(bottom: 25.w),
                width: 144.w,
                height: 35.w,
                decoration: BoxDecoration(
                    borderRadius: BorderRadius.circular(17.5.w),
                    gradient: const LinearGradient(
                        colors: [Color(0xFFFB5C9A), Color(0xFFF775F2)])),
                child:  Center(
                  child: Text(
                    S.current.Live_Refresh,
                    style:const TextStyle(color: Colors.white, fontSize: 14),
                  ),
                ),
              ),
            )
          ],
        ),
      ),
    );
  }

  Widget noSreaingView() {
    return Center(
      child: Column(
        mainAxisAlignment: MainAxisAlignment.center,
        children: [
          Container(
            padding: EdgeInsets.only(bottom: 8.w),
            child: UtilsLiveImage.getIconByPath(
              'yuyin_zhuyuyinxi_icon_xuweiyidai',
              
            ),
          ),
           Text(
            S.current.Live_VideoGuest,
            style: UtilsLiveTextStyle.pt14A39CADSemiBold,
          )
        ],
      ),
    );
  }

  @override
  void initState() {
    super.initState();
  }

  @override
  void dispose() {
    super.dispose();
  }

  @override
  void didUpdateWidget(WidgetLiveStreamSingleVideo oldWidget) {
    super.didUpdateWidget(oldWidget);
  }

  @override
  void didChangeDependencies() {
    super.didChangeDependencies();
  }
}
