
import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:mmoo_country_pickers/mmoo_country_pickers.dart';
import 'package:mmoo_live_room/Config/config_live_globalkey.dart';
import 'package:mmoo_live_room/Config/config_live_methon.dart';
import 'package:mmoo_live_room/Config/config_live_typedef.dart';
import 'package:mmoo_live_room/Provider/provider_live_placelist_info.dart';
import 'package:mmoo_live_room/Utils/utils_live_colors.dart';
import 'package:mmoo_live_room/Widget/widget_live_place_volume.dart';
import 'package:mmoo_live_room/Model/model_live_info_entity.dart';
import 'package:mmoo_live_room/Utils/utils_live_image.dart';
import 'package:provider/provider.dart';

//语音直播  语音位
class WidgetLiveStreamVoiceSounds extends StatefulWidget {
  final double height;
  final ClickCallBack clickCallBack;
  WidgetLiveStreamVoiceSounds(this.height, {required this.clickCallBack})
      : super(key: ConfigLiveGlobalkey.streamVoiceKey);
  @override
  WidgetLiveStreamVoiceSoundsState createState() =>
      WidgetLiveStreamVoiceSoundsState();
}

class WidgetLiveStreamVoiceSoundsState
    extends State<WidgetLiveStreamVoiceSounds> {
  Map<int, GlobalKey<WidgetLivePlaceVolumeState>> vioceHeaderMap = {};
  @override
  Widget build(BuildContext context) {
    return Column(
      children: [
        MediaQuery.removePadding(
            context: context,
            removeBottom: true,
            removeTop: true,
            child: Container(
                width: 1.sw,
                margin: const EdgeInsets.symmetric(horizontal: 15),
                height: widget.height,
                // color: Colors.orange,
                child: Consumer<ProviderLivePlaceListInfo>(
                    builder: (context, placeProvider, child) {
                  return createGridView(placeProvider.voiceList);
                })))
      ],
    );
  }

  Widget createGridView(List<ModelLiveInfoPlaceList> voiceList) {
    vioceHeaderMap.clear();
    for (var element in voiceList) {
      if (element.userId != null && (element.userId ?? 0) > 0) {
        // vioceHeaderList.add({element.userId,GlobalKey<>);
        vioceHeaderMap[element.userId!] =
            GlobalKey<WidgetLivePlaceVolumeState>();
      }
    }
    return GridView.builder(
        physics: const NeverScrollableScrollPhysics(),
        gridDelegate: const SliverGridDelegateWithFixedCrossAxisCount(
            crossAxisCount: 3, childAspectRatio: 121/ 132),
        itemCount: voiceList.length,
        itemBuilder: (BuildContext context, int index) {
          ModelLiveInfoPlaceList placeList = voiceList[index];
          return GestureDetector(
              onTap: () {
                widget.clickCallBack(
                    ConfigLiveMethon.liveClickPlcaeInfo, placeList);
              },
              child: (placeList.userId != null && (placeList.userId ?? 0) > 0)
                  ? Stack(
                      children: [
                        Positioned(
                          child: Row(
                            mainAxisAlignment: MainAxisAlignment.spaceBetween,
                            children: [
                              placeList.role == 0
                                  ? Container(
                                      margin: EdgeInsets.only(
                                        left: 15.w,
                                        top: 5.w,
                                      ),
                                      child: UtilsLiveImage.getIconByPath(
                                        'yuyin_zhuyuyinxi_icon_fangzhu',
                                        width: 12,
                                        height: 12,
                                      ),
                                    )
                                  : Container(
                                      width: 16,
                                      height: 16,
                                      margin: EdgeInsets.only(
                                        left: 15.w,
                                        top: 5.w,
                                      ),
                                      decoration: BoxDecoration(
                                          color: placeList.gender == 0
                                              ? UtilsLiveColor.hexToColor(
                                                  '#25ABE6')
                                              : UtilsLiveColor.hexToColor(
                                                  '#FF5C8E'),
                                          borderRadius:
                                              BorderRadius.circular(8)),
                                      child: Center(
                                        child: Text(
                                          placeList.telSeq.toString(),
                                          style: const TextStyle(
                                              fontSize: 12,
                                              fontWeight: FontWeight.bold,
                                              color: Colors.white,
                                              decoration: TextDecoration.none),
                                        ),
                                      )),
                              Container(
                                  width: 12,
                                  height: 12,
                                  margin:
                                      EdgeInsets.only(top: 5.w, right: 15.w),
                                  child: ClipOval(
                                    
                                    child: UtilsLiveImage.getIconByPath(
                                      AssetImage(CountryPickerUtils
                                              .getFlagImageAssetPath(
                                                  CountryPickerUtils
                                                          .getCountryByPhoneCode(
                                                              placeList
                                                                      .country ??
                                                                  '1')
                                                      ?.isoCode))
                                          .assetName,
                                      fit: BoxFit.cover,
                                      package: "mmoo_country_pickers",
                                    ),
                                  ))
                            ],
                          ),
                        ),
                        Positioned(
                          child: Column(
                            children: [
                              WidgetLivePlaceVolume(
                                  key: vioceHeaderMap[placeList.userId!]!,
                                  child: SizedBox(
                                    width: 75.w,
                                    height: 75.w,
                                    child: Stack(
                                      children: [
                                        Positioned.fill(
                                          child: ClipOval(
                                            child: UtilsLiveImage.getLoadWidget(
                                              placeList.headImage,
                                            ),
                                          ),
                                        ),
                                        Positioned.fill(
                                            child: Visibility(
                                                visible: placeList.voice != 1,
                                                child: Container(
                                                  alignment: Alignment.center,
                                                    decoration: BoxDecoration(
                                                        color: Colors.black
                                                            .withOpacity(0.4),
                                                        borderRadius:
                                                            BorderRadius
                                                                .circular(36.w),
                                                        border: Border.all(
                                                            width: 1.5,
                                                            color: UtilsLiveColor
                                                                    .hexToColor(
                                                                        '#FFFFFF')
                                                                .withAlpha(
                                                                    128))),
                                                    child: UtilsLiveImage
                                                        .getIconByPath(
                                                      placeList.voice == 2
                                                          ? 'icon_live_video_Mic_close'
                                                          : 'icon_live_video_Mic_ban',
                                                          width: 30,
                                                          height: 30
                                                    ))))
                                      ],
                                    ),
                                  ),
                                  width: 88.w,
                                  height: 88.w),
                              Container(
                                constraints: BoxConstraints(maxWidth: 80.w),
                                margin: const EdgeInsets.symmetric(vertical: 3),
                                child: Text(
                                  placeList.nickname ?? '',
                                  maxLines: 1,
                                  style: TextStyle(
                                      fontSize: 14,
                                      color:
                                          UtilsLiveColor.hexToColor("#FFFFFF"),
                                      fontWeight: FontWeight.bold,
                                      decoration: TextDecoration.none),
                                  overflow: TextOverflow.ellipsis,
                                ),
                              ),
                              Row(
                                mainAxisAlignment: MainAxisAlignment.center,
                                children: [
                                  UtilsLiveImage.getIconByPath(
                                    'icon_live_gift',
                                  ),
                                  Container(
                                    child: Text(
                                      (placeList.giftNum ?? 0).toString(),
                                      style: const TextStyle(
                                          fontSize: 12,
                                          color: Colors.white,
                                          // fontWeight: FontWeight.w600,
                                          decoration: TextDecoration.none),
                                    ),
                                    margin: const EdgeInsets.symmetric(
                                        horizontal: 5),
                                  )
                                ],
                              )
                            ],
                          ),
                        )
                      ],
                    )
                  : Stack(
                      children: [
                        Positioned(
                          child: Row(
                            mainAxisAlignment: MainAxisAlignment.spaceBetween,
                            children: [
                              Container(
                                  width: 16,
                                  height: 16,
                                  alignment: Alignment.center,
                                  margin: EdgeInsets.only(
                                    left: 15.w,
                                    top: 5.w,
                                  ),
                                  decoration: BoxDecoration(
                                      color:
                                          UtilsLiveColor.hexToColor('#000000')
                                              .withAlpha(25),
                                      borderRadius: BorderRadius.circular(8)),
                                  child: Center(
                                    child: Text(
                                      placeList.telSeq.toString(),
                                      style: const TextStyle(
                                          fontSize: 12,
                                          color: Colors.white,
                                          fontWeight: FontWeight.bold,
                                          decoration: TextDecoration.none),
                                    ),
                                  )),
                            ],
                          ),
                        ),
                        Positioned(
                          child: Column(
                            children: [
                              SizedBox(
                                  width: 80.w,
                                  height: 80.w,
                                  child: Center(
                                      child: UtilsLiveImage.getIconByPath(
                                    'icon_live_mic_seat',
                                  ))),
                              SizedBox(
                                height: 6.w,
                              ),
                              Row()
                            ],
                          ),
                        )
                      ],
                    ));
        });
  }

  @override
  void initState() {
    super.initState();
  }

  @override
  void dispose() {
    super.dispose();
  }

  @override
  void didUpdateWidget(WidgetLiveStreamVoiceSounds oldWidget) {
    super.didUpdateWidget(oldWidget);
  }

  @override
  void didChangeDependencies() {
    super.didChangeDependencies();
  }
}
