//视频直播间 语音位

import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:mmoo_live_room/Config/config_live_globalkey.dart';
import 'package:mmoo_live_room/Config/config_live_methon.dart';
import 'package:mmoo_live_room/Config/config_live_typedef.dart';
import 'package:mmoo_live_room/Provider/provider_live_placelist_info.dart';
import 'package:mmoo_live_room/Widget/widget_live_place_volume.dart';
import 'package:mmoo_live_room/Model/model_live_info_entity.dart';
import 'package:mmoo_live_room/Utils/utils_live_image.dart';
import 'package:provider/provider.dart';

//视频直播  语音位
class WidgetLiveStreamVoiceVideo extends StatefulWidget {
  final double height;
  final ClickCallBack clickCallBack;
  // WidgetLiveStreamMultiVideo({required this.infoEntity});
  WidgetLiveStreamVoiceVideo(this.height, {required this.clickCallBack})
      : super(key: ConfigLiveGlobalkey.streamvideoVoiceKey);
  @override
  WidgetLiveStreamVoiceVideoState createState() =>
      WidgetLiveStreamVoiceVideoState();
}

class WidgetLiveStreamVoiceVideoState
    extends State<WidgetLiveStreamVoiceVideo> {
  // ModelLiveInfoEntity infoEntity;
  // WidgetLiveStreamVoiceVideoState({required this.infoEntity});
  Map<int, GlobalKey<WidgetLivePlaceVolumeState>> vioceVolumMap = {};
  @override
  Widget build(BuildContext context) {
    return MediaQuery.removePadding(
        context: context,
        removeBottom: true,
        removeTop: true,
        child: Container(
            width: 1.sw,
            margin: EdgeInsets.symmetric(horizontal: 24.w),
            height: widget.height,
            // color: Colors.orange,
            child: Consumer<ProviderLivePlaceListInfo>(
                builder: (context, placeProvider, child) {
              vioceVolumMap.clear();
              for (var element in placeProvider.voiceList) {
                if (element.userId != null && (element.userId ?? 0) > 0) {
                  // vioceHeaderList.add({element.userId,GlobalKey<>);
                  vioceVolumMap[element.userId!] =
                      GlobalKey<WidgetLivePlaceVolumeState>();
                }
              }
              return GridView.builder(
                  physics: const NeverScrollableScrollPhysics(),
                  gridDelegate: SliverGridDelegateWithFixedCrossAxisCount(
                      crossAxisCount: 4,
                      childAspectRatio: (60.0) / widget.height),
                  itemCount: placeProvider.voiceList.length,
                  itemBuilder: (BuildContext context, int index) {
                    ModelLiveInfoPlaceList placeList =
                        placeProvider.voiceList[index];

                    return GestureDetector(
                      child: Column(
                        // mainAxisAlignment: MainAxisAlignment.spaceBetween,
                        children: [
                          SizedBox(
                              width: 60,
                              height: 65,
                              child: Stack(
                                children: [
                                  Positioned(
                                    top: 0,
                                    left: 0,
                                    right: 0,
                                    // bottom: 0,
                                    child: placeList.userId != null
                                        ? ClipOval(
                                            child: UtilsLiveImage.getLoadWidget(
                                              placeList.headImage,
                                              width: 60,
                                              height: 60,
                                            ),
                                          )
                                        : UtilsLiveImage.getIconByPath(
                                            'icon_live_mic_seat',
                                            
                                          ),
                                  ),
                                  Positioned(
                                      bottom: 2,
                                      left: 0,
                                      right: 0,
                                      child: Row(
                                        mainAxisAlignment:
                                            placeList.userId == null
                                                ? MainAxisAlignment.center
                                                : MainAxisAlignment.end,
                                        children: [
                                          Container(
                                            height: 20,
                                            width: 50,
                                            padding: placeList.userId == null
                                                ? const EdgeInsets.only(
                                                    right: 7, left: 7)
                                                : const EdgeInsets.only(
                                                    right: 7),
                                            decoration: BoxDecoration(
                                                color: Colors.black
                                                    .withOpacity(0.4),
                                                borderRadius:
                                                    BorderRadius.circular(10)),
                                            alignment: placeList.userId == null
                                                ? Alignment.center
                                                : Alignment.centerRight,
                                            child: Text(
                                              ' NO.${placeList.telSeq}',
                                              style: const TextStyle(
                                                  color: Colors.white,
                                                  fontSize: 12),
                                            ),
                                          )
                                        ],
                                      )),
                                  Positioned(
                                    bottom: 0,
                                    left: 0,
                                    child: Visibility(
                                      visible: placeList.userId != null,
                                      child: placeList.userId == null
                                          ? Container()
                                          : WidgetLivePlaceVolume(
                                              child: UtilsLiveImage.getIconByPath(
                                                placeList.voice == 0
                                                    ? 'icon_live_mic_ban'
                                                    : placeList.voice == 2
                                                        ? 'icon_live_mic_close'
                                                        : 'icon_live_mic_open',
                                              ),
                                              width: 26,
                                              height: 26,
                                              key: vioceVolumMap[
                                                  placeList.userId!]!),
                                    ),
                                  )
//  placeList.userId != null
                                  // ?
                                ],
                              )),
                          const SizedBox(
                            height: 3,
                          ),
                          Container(
                            constraints: const BoxConstraints(maxWidth: 60),
                            child: Text(
                              placeList.nickname ?? '',
                              style: const TextStyle(
                                  color: Colors.white, fontSize: 12),
                            ),
                          )
                        ],
                      ),
                      onTap: () {
                        widget.clickCallBack(
                            ConfigLiveMethon.liveClickPlcaeInfo, placeList);
                      },
                    );
                  });
            })));
  }

  @override
  void initState() {
    super.initState();
  }

  @override
  void dispose() {
    super.dispose();
  }

  @override
  void didUpdateWidget(WidgetLiveStreamVoiceVideo oldWidget) {
    super.didUpdateWidget(oldWidget);
  }

  @override
  void didChangeDependencies() {
    super.didChangeDependencies();
  }
}
