import 'package:mmoo_live_room/Model/model_lastLive_entity.dart';

modelLastLiveEntityFromJson(ModelLastLiveEntity data, Map<String, dynamic> json) {
	if (json['roomId'] != null) {
		data.roomId = json['roomId'] is String
				? int.tryParse(json['roomId'])
				: json['roomId'].toInt();
	}
	if (json['type'] != null) {
		data.type = json['type'] is String
				? int.tryParse(json['type'])
				: json['type'].toInt();
	}
	if (json['cover'] != null) {
		data.cover = json['cover'].toString();
	}
	if (json['title'] != null) {
		data.title = json['title'].toString();
	}
	if (json['language'] != null) {
		data.language = json['language'].toString();
	}
	if (json['liveNotice'] != null) {
		data.liveNotice = json['liveNotice'].toString();
	}
	if (json['voicePrice'] != null) {
		data.voicePrice = (json['voicePrice'] as List).map((v) => v is String
				? int.tryParse(v)
				: v.toInt()).toList().cast<int>();
	}
	if (json['videoPrice'] != null) {
		data.videoPrice = (json['videoPrice'] as List).map((v) => v is String
				? int.tryParse(v)
				: v.toInt()).toList().cast<int>();
	}
	if (json['chooseVoicePrice'] != null) {
		data.chooseVoicePrice = json['chooseVoicePrice'].toString();
	}
	if (json['chooseVideoPrice'] != null) {
		data.chooseVideoPrice = json['chooseVideoPrice'].toString();
	}
	if (json['micSeat'] != null) {
		data.micSeat = json['micSeat'].toString();
	}
	if (json['videoSeat'] != null) {
		data.videoSeat = json['videoSeat'].toString();
	}
	if (json['pricatePrice'] != null) {
		data.pricatePrice = json['pricatePrice'].toString();
	}
	return data;
}

Map<String, dynamic> modelLastLiveEntityToJson(ModelLastLiveEntity entity) {
	final Map<String, dynamic> data = new Map<String, dynamic>();
	data['roomId'] = entity.roomId;
	data['type'] = entity.type;
	data['cover'] = entity.cover;
	data['title'] = entity.title;
	data['language'] = entity.language;
	data['liveNotice'] = entity.liveNotice;
	data['voicePrice'] = entity.voicePrice;
	data['videoPrice'] = entity.videoPrice;
	data['chooseVoicePrice'] = entity.chooseVoicePrice;
	data['chooseVideoPrice'] = entity.chooseVideoPrice;
	data['micSeat'] = entity.micSeat;
	data['videoSeat'] = entity.videoSeat;
	data['pricatePrice'] = entity.pricatePrice;
	return data;
}