import 'package:mmoo_live_room/Model/model_live_info_entity.dart';

modelLiveInfoEntityFromJson(ModelLiveInfoEntity data, Map<String, dynamic> json) {
	if (json['roomId'] != null) {
		data.roomId = json['roomId'] is String
				? int.tryParse(json['roomId'])
				: json['roomId'].toInt();
	}
	if (json['liveId'] != null) {
		data.liveId = json['liveId'] is String
				? int.tryParse(json['liveId'])
				: json['liveId'].toInt();
	}
	if (json['userId'] != null) {
		data.userId = json['userId'] is String
				? int.tryParse(json['userId'])
				: json['userId'].toInt();
	}
	if (json['type'] != null) {
		data.type = json['type'] is String
				? int.tryParse(json['type'])
				: json['type'].toInt();
	}
	if (json['cover'] != null) {
		data.cover = json['cover'].toString();
	}
	if (json['headImage'] != null) {
		data.headImage = json['headImage'].toString();
	}
	if (json['title'] != null) {
		data.title = json['title'].toString();
	}
	if (json['nickname'] != null) {
		data.nickname = json['nickname'].toString();
	}
	if (json['language'] != null) {
		data.language = json['language'].toString();
	}
	if (json['liveNotice'] != null) {
		data.liveNotice = json['liveNotice'].toString();
	}
	if (json['chatroomId'] != null) {
		data.chatroomId = json['chatroomId'].toString();
	}
	if (json['onlineNums'] != null) {
		data.onlineNums = json['onlineNums'] is String
				? int.tryParse(json['onlineNums'])
				: json['onlineNums'].toInt();
	}
	if (json['subNums'] != null) {
		data.subNums = json['subNums'] is String
				? int.tryParse(json['subNums'])
				: json['subNums'].toInt();
	}
	if (json['voicePlaceList'] != null) {
		data.voicePlaceList = (json['voicePlaceList'] as List).map((v) => ModelLiveInfoPlaceList().fromJson(v)).toList();
	}
	if (json['videoPlaceList'] != null) {
		data.videoPlaceList = (json['videoPlaceList'] as List).map((v) => ModelLiveInfoPlaceList().fromJson(v)).toList();
	}
	if (json['price'] != null) {
		data.price = json['price'] is String
				? int.tryParse(json['price'])
				: json['price'].toInt();
	}
	if (json['isUnlock'] != null) {
		data.isUnlock = json['isUnlock'] is String
				? int.tryParse(json['isUnlock'])
				: json['isUnlock'].toInt();
	}
	if (json['follow'] != null) {
		data.follow = json['follow'] is String
				? int.tryParse(json['follow'])
				: json['follow'].toInt();
	}
	if (json['voicePrice'] != null) {
		data.voicePrice = json['voicePrice'] is String
				? int.tryParse(json['voicePrice'])
				: json['voicePrice'].toInt();
	}
	if (json['videoPrice'] != null) {
		data.videoPrice = json['videoPrice'] is String
				? int.tryParse(json['videoPrice'])
				: json['videoPrice'].toInt();
	}
	if (json['isSwitchCamera'] != null) {
		data.isSwitchCamera = json['isSwitchCamera'];
	}
	if (json['role'] != null) {
		data.role = json['role'] is String
				? int.tryParse(json['role'])
				: json['role'].toInt();
	}
	return data;
}

Map<String, dynamic> modelLiveInfoEntityToJson(ModelLiveInfoEntity entity) {
	final Map<String, dynamic> data = new Map<String, dynamic>();
	data['roomId'] = entity.roomId;
	data['liveId'] = entity.liveId;
	data['userId'] = entity.userId;
	data['type'] = entity.type;
	data['cover'] = entity.cover;
	data['headImage'] = entity.headImage;
	data['title'] = entity.title;
	data['nickname'] = entity.nickname;
	data['language'] = entity.language;
	data['liveNotice'] = entity.liveNotice;
	data['chatroomId'] = entity.chatroomId;
	data['onlineNums'] = entity.onlineNums;
	data['subNums'] = entity.subNums;
	data['voicePlaceList'] =  entity.voicePlaceList?.map((v) => v.toJson())?.toList();
	data['videoPlaceList'] =  entity.videoPlaceList?.map((v) => v.toJson())?.toList();
	data['price'] = entity.price;
	data['isUnlock'] = entity.isUnlock;
	data['follow'] = entity.follow;
	data['voicePrice'] = entity.voicePrice;
	data['videoPrice'] = entity.videoPrice;
	data['isSwitchCamera'] = entity.isSwitchCamera;
	data['role'] = entity.role;
	return data;
}

modelLiveInfoPlaceListFromJson(ModelLiveInfoPlaceList data, Map<String, dynamic> json) {
	if (json['roomPlaceId'] != null) {
		data.roomPlaceId = json['roomPlaceId'] is String
				? int.tryParse(json['roomPlaceId'])
				: json['roomPlaceId'].toInt();
	}
	if (json['liveId'] != null) {
		data.liveId = json['liveId'] is String
				? int.tryParse(json['liveId'])
				: json['liveId'].toInt();
	}
	if (json['roomId'] != null) {
		data.roomId = json['roomId'] is String
				? int.tryParse(json['roomId'])
				: json['roomId'].toInt();
	}
	if (json['type'] != null) {
		data.type = json['type'] is String
				? int.tryParse(json['type'])
				: json['type'].toInt();
	}
	if (json['streamSeq'] != null) {
		data.streamSeq = json['streamSeq'] is String
				? int.tryParse(json['streamSeq'])
				: json['streamSeq'].toInt();
	}
	if (json['telSeq'] != null) {
		data.telSeq = json['telSeq'] is String
				? int.tryParse(json['telSeq'])
				: json['telSeq'].toInt();
	}
	if (json['userId'] != null) {
		data.userId = json['userId'] is String
				? int.tryParse(json['userId'])
				: json['userId'].toInt();
	}
	if (json['isHost'] != null) {
		data.isHost = json['isHost'] is String
				? int.tryParse(json['isHost'])
				: json['isHost'].toInt();
	}
	if (json['headImage'] != null) {
		data.headImage = json['headImage'].toString();
	}
	if (json['nickname'] != null) {
		data.nickname = json['nickname'].toString();
	}
	if (json['country'] != null) {
		data.country = json['country'].toString();
	}
	if (json['roomUserId'] != null) {
		data.roomUserId = json['roomUserId'] is String
				? int.tryParse(json['roomUserId'])
				: json['roomUserId'].toInt();
	}
	if (json['role'] != null) {
		data.role = json['role'] is String
				? int.tryParse(json['role'])
				: json['role'].toInt();
	}
	if (json['roomUserStatus'] != null) {
		data.roomUserStatus = json['roomUserStatus'] is String
				? int.tryParse(json['roomUserStatus'])
				: json['roomUserStatus'].toInt();
	}
	if (json['chat'] != null) {
		data.chat = json['chat'] is String
				? int.tryParse(json['chat'])
				: json['chat'].toInt();
	}
	if (json['voice'] != null) {
		data.voice = json['voice'] is String
				? int.tryParse(json['voice'])
				: json['voice'].toInt();
	}
	if (json['follow'] != null) {
		data.follow = json['follow'] is String
				? int.tryParse(json['follow'])
				: json['follow'].toInt();
	}
	if (json['giftNum'] != null) {
		data.giftNum = json['giftNum'] is String
				? int.tryParse(json['giftNum'])
				: json['giftNum'].toInt();
	}
	if (json['gender'] != null) {
		data.gender = json['gender'] is String
				? int.tryParse(json['gender'])
				: json['gender'].toInt();
	}
	if (json['chooseGift'] != null) {
		data.chooseGift = json['chooseGift'] is String
				? int.tryParse(json['chooseGift'])
				: json['chooseGift'].toInt();
	}
	return data;
}

Map<String, dynamic> modelLiveInfoPlaceListToJson(ModelLiveInfoPlaceList entity) {
	final Map<String, dynamic> data = new Map<String, dynamic>();
	data['roomPlaceId'] = entity.roomPlaceId;
	data['liveId'] = entity.liveId;
	data['roomId'] = entity.roomId;
	data['type'] = entity.type;
	data['streamSeq'] = entity.streamSeq;
	data['telSeq'] = entity.telSeq;
	data['userId'] = entity.userId;
	data['isHost'] = entity.isHost;
	data['headImage'] = entity.headImage;
	data['nickname'] = entity.nickname;
	data['country'] = entity.country;
	data['roomUserId'] = entity.roomUserId;
	data['role'] = entity.role;
	data['roomUserStatus'] = entity.roomUserStatus;
	data['chat'] = entity.chat;
	data['voice'] = entity.voice;
	data['follow'] = entity.follow;
	data['giftNum'] = entity.giftNum;
	data['gender'] = entity.gender;
	data['chooseGift'] = entity.chooseGift;
	return data;
}