import 'package:mmoo_live_room/Model/model_live_list_info_entity.dart';

modelLiveListInfoEntityFromJson(ModelLiveListInfoEntity data, Map<String, dynamic> json) {
	if (json['size'] != null) {
		data.size = json['size'] is String
				? int.tryParse(json['size'])
				: json['size'].toInt();
	}
	if (json['num'] != null) {
		data.num = json['num'] is String
				? int.tryParse(json['num'])
				: json['num'].toInt();
	}
	if (json['rows'] != null) {
		data.rows = (json['rows'] as List).map((v) => ModelLiveListInfoRows().fromJson(v)).toList();
	}
	return data;
}

Map<String, dynamic> modelLiveListInfoEntityToJson(ModelLiveListInfoEntity entity) {
	final Map<String, dynamic> data = new Map<String, dynamic>();
	data['size'] = entity.size;
	data['num'] = entity.num;
	data['rows'] =  entity.rows?.map((v) => v.toJson())?.toList();
	return data;
}

modelLiveListInfoRowsFromJson(ModelLiveListInfoRows data, Map<String, dynamic> json) {
	if (json['liveId'] != null) {
		data.liveId = json['liveId'] is String
				? int.tryParse(json['liveId'])
				: json['liveId'].toInt();
	}
	if (json['roomId'] != null) {
		data.roomId = json['roomId'] is String
				? int.tryParse(json['roomId'])
				: json['roomId'].toInt();
	}
	if (json['title'] != null) {
		data.title = json['title'].toString();
	}
	if (json['language'] != null) {
		data.language = json['language'].toString();
	}
	if (json['type'] != null) {
		data.type = json['type'] is String
				? int.tryParse(json['type'])
				: json['type'].toInt();
	}
	if (json['cover'] != null) {
		data.cover = json['cover'].toString();
	}
	if (json['onlineNums'] != null) {
		data.onlineNums = json['onlineNums'] is String
				? int.tryParse(json['onlineNums'])
				: json['onlineNums'].toInt();
	}
	if (json['price'] != null) {
		data.price = json['price'] is String
				? int.tryParse(json['price'])
				: json['price'].toInt();
	}
	if (json['userId'] != null) {
		data.userId = json['userId'] is String
				? int.tryParse(json['userId'])
				: json['userId'].toInt();
	}
	if (json['isUnlock'] != null) {
		data.isUnlock = json['isUnlock'] is String
				? int.tryParse(json['isUnlock'])
				: json['isUnlock'].toInt();
	}
	if (json['mikeUsers'] != null) {
		data.mikeUsers = (json['mikeUsers'] as List).map((v) => ModelLiveListInfoRowsMikeUsers().fromJson(v)).toList();
	}
	if (json['onlineUsers'] != null) {
		data.onlineUsers = (json['onlineUsers'] as List).map((v) => ModelLiveListInfoRowsOnlineUsers().fromJson(v)).toList();
	}
	return data;
}

Map<String, dynamic> modelLiveListInfoRowsToJson(ModelLiveListInfoRows entity) {
	final Map<String, dynamic> data = new Map<String, dynamic>();
	data['liveId'] = entity.liveId;
	data['roomId'] = entity.roomId;
	data['title'] = entity.title;
	data['language'] = entity.language;
	data['type'] = entity.type;
	data['cover'] = entity.cover;
	data['onlineNums'] = entity.onlineNums;
	data['price'] = entity.price;
	data['userId'] = entity.userId;
	data['isUnlock'] = entity.isUnlock;
	data['mikeUsers'] =  entity.mikeUsers?.map((v) => v.toJson())?.toList();
	data['onlineUsers'] =  entity.onlineUsers?.map((v) => v.toJson())?.toList();
	return data;
}

modelLiveListInfoRowsMikeUsersFromJson(ModelLiveListInfoRowsMikeUsers data, Map<String, dynamic> json) {
	if (json['userId'] != null) {
		data.userId = json['userId'] is String
				? int.tryParse(json['userId'])
				: json['userId'].toInt();
	}
	if (json['nickname'] != null) {
		data.nickname = json['nickname'].toString();
	}
	if (json['headImage'] != null) {
		data.headImage = json['headImage'].toString();
	}
	return data;
}

Map<String, dynamic> modelLiveListInfoRowsMikeUsersToJson(ModelLiveListInfoRowsMikeUsers entity) {
	final Map<String, dynamic> data = new Map<String, dynamic>();
	data['userId'] = entity.userId;
	data['nickname'] = entity.nickname;
	data['headImage'] = entity.headImage;
	return data;
}

modelLiveListInfoRowsOnlineUsersFromJson(ModelLiveListInfoRowsOnlineUsers data, Map<String, dynamic> json) {
	if (json['userId'] != null) {
		data.userId = json['userId'] is String
				? int.tryParse(json['userId'])
				: json['userId'].toInt();
	}
	if (json['nickname'] != null) {
		data.nickname = json['nickname'].toString();
	}
	if (json['headImage'] != null) {
		data.headImage = json['headImage'].toString();
	}
	return data;
}

Map<String, dynamic> modelLiveListInfoRowsOnlineUsersToJson(ModelLiveListInfoRowsOnlineUsers entity) {
	final Map<String, dynamic> data = new Map<String, dynamic>();
	data['userId'] = entity.userId;
	data['nickname'] = entity.nickname;
	data['headImage'] = entity.headImage;
	return data;
}