import 'package:mmoo_live_room/Model/model_live_show_list_entity.dart';

modelLiveShowListEntityFromJson(ModelLiveShowListEntity data, Map<String, dynamic> json) {
	if (json['num'] != null) {
		data.num = json['num'] is String
				? int.tryParse(json['num'])
				: json['num'].toInt();
	}
	if (json['rows'] != null) {
		data.rows = (json['rows'] as List).map((v) => ModelLiveShowListRows().fromJson(v)).toList();
	}
	if (json['size'] != null) {
		data.size = json['size'] is String
				? int.tryParse(json['size'])
				: json['size'].toInt();
	}
	return data;
}

Map<String, dynamic> modelLiveShowListEntityToJson(ModelLiveShowListEntity entity) {
	final Map<String, dynamic> data = new Map<String, dynamic>();
	data['num'] = entity.num;
	data['rows'] =  entity.rows?.map((v) => v.toJson())?.toList();
	data['size'] = entity.size;
	return data;
}

modelLiveShowListRowsFromJson(ModelLiveShowListRows data, Map<String, dynamic> json) {
	if (json['gender'] != null) {
		data.gender = json['gender'] is String
				? int.tryParse(json['gender'])
				: json['gender'].toInt();
	}
	if (json['headImage'] != null) {
		data.headImage = json['headImage'].toString();
	}
	if (json['isAnchor'] != null) {
		data.isAnchor = json['isAnchor'] is String
				? int.tryParse(json['isAnchor'])
				: json['isAnchor'].toInt();
	}
	if (json['nickname'] != null) {
		data.nickname = json['nickname'].toString();
	}
	if (json['userId'] != null) {
		data.userId = json['userId'] is String
				? int.tryParse(json['userId'])
				: json['userId'].toInt();
	}
	return data;
}

Map<String, dynamic> modelLiveShowListRowsToJson(ModelLiveShowListRows entity) {
	final Map<String, dynamic> data = new Map<String, dynamic>();
	data['gender'] = entity.gender;
	data['headImage'] = entity.headImage;
	data['isAnchor'] = entity.isAnchor;
	data['nickname'] = entity.nickname;
	data['userId'] = entity.userId;
	return data;
}