import 'package:mmoo_live_room/Model/model_live_user_info_entity.dart';

modelLiveUserInfoEntityFromJson(ModelLiveUserInfoEntity data, Map<String, dynamic> json) {
	if (json['userId'] != null) {
		data.userId = json['userId'] is String
				? int.tryParse(json['userId'])
				: json['userId'].toInt();
	}
	if (json['nickname'] != null) {
		data.nickname = json['nickname'].toString();
	}
	if (json['headImage'] != null) {
		data.headImage = json['headImage'].toString();
	}
	if (json['country'] != null) {
		data.country = json['country'].toString();
	}
	if (json['birthday'] != null) {
		data.birthday = json['birthday'].toString();
	}
	if (json['signature'] != null) {
		data.signature = json['signature'].toString();
	}
	if (json['roomPlaceId'] != null) {
		data.roomPlaceId = json['roomPlaceId'] is String
				? int.tryParse(json['roomPlaceId'])
				: json['roomPlaceId'].toInt();
	}
	if (json['cost'] != null) {
		data.cost = json['cost'] is String
				? int.tryParse(json['cost'])
				: json['cost'].toInt();
	}
	if (json['gender'] != null) {
		data.gender = json['gender'] is String
				? int.tryParse(json['gender'])
				: json['gender'].toInt();
	}
	if (json['btn'] != null) {
		data.btn = (json['btn'] as List).map((v) => ModelLiveUserInfoBtn().fromJson(v)).toList();
	}
	return data;
}

Map<String, dynamic> modelLiveUserInfoEntityToJson(ModelLiveUserInfoEntity entity) {
	final Map<String, dynamic> data = new Map<String, dynamic>();
	data['userId'] = entity.userId;
	data['nickname'] = entity.nickname;
	data['headImage'] = entity.headImage;
	data['country'] = entity.country;
	data['birthday'] = entity.birthday;
	data['signature'] = entity.signature;
	data['roomPlaceId'] = entity.roomPlaceId;
	data['cost'] = entity.cost;
	data['gender'] = entity.gender;
	data['btn'] =  entity.btn?.map((v) => v.toJson())?.toList();
	return data;
}

modelLiveUserInfoBtnFromJson(ModelLiveUserInfoBtn data, Map<String, dynamic> json) {
	if (json['codeName'] != null) {
		data.codeName = json['codeName'].toString();
	}
	if (json['codeType'] != null) {
		data.codeType = json['codeType'] is String
				? int.tryParse(json['codeType'])
				: json['codeType'].toInt();
	}
	return data;
}

Map<String, dynamic> modelLiveUserInfoBtnToJson(ModelLiveUserInfoBtn entity) {
	final Map<String, dynamic> data = new Map<String, dynamic>();
	data['codeName'] = entity.codeName;
	data['codeType'] = entity.codeType;
	return data;
}