import 'package:mmoo_live_room/Model/model_live_user_list_entity.dart';

modelLiveUserListEntityFromJson(ModelLiveUserListEntity data, Map<String, dynamic> json) {
	if (json['users'] != null) {
		data.users = (json['users'] as List).map((v) => ModelLiveUserListUsers().fromJson(v)).toList();
	}
	if (json['num'] != null) {
		data.num = json['num'] is String
				? int.tryParse(json['num'])
				: json['num'].toInt();
	}
	if (json['applyNum'] != null) {
		data.applyNum = json['applyNum'] is String
				? int.tryParse(json['applyNum'])
				: json['applyNum'].toInt();
	}
	if (json['onlineNum'] != null) {
		data.onlineNum = json['onlineNum'] is String
				? int.tryParse(json['onlineNum'])
				: json['onlineNum'].toInt();
	}
	return data;
}

Map<String, dynamic> modelLiveUserListEntityToJson(ModelLiveUserListEntity entity) {
	final Map<String, dynamic> data = new Map<String, dynamic>();
	data['users'] =  entity.users?.map((v) => v.toJson())?.toList();
	data['num'] = entity.num;
	data['applyNum'] = entity.applyNum;
	data['onlineNum'] = entity.onlineNum;
	return data;
}

modelLiveUserListUsersFromJson(ModelLiveUserListUsers data, Map<String, dynamic> json) {
	if (json['userId'] != null) {
		data.userId = json['userId'] is String
				? int.tryParse(json['userId'])
				: json['userId'].toInt();
	}
	if (json['isHost'] != null) {
		data.isHost = json['isHost'] is String
				? int.tryParse(json['isHost'])
				: json['isHost'].toInt();
	}
	if (json['nickname'] != null) {
		data.nickname = json['nickname'].toString();
	}
	if (json['headImage'] != null) {
		data.headImage = json['headImage'].toString();
	}
	if (json['roomPlaceId'] != null) {
		data.roomPlaceId = json['roomPlaceId'] is String
				? int.tryParse(json['roomPlaceId'])
				: json['roomPlaceId'].toInt();
	}
	if (json['type'] != null) {
		data.type = json['type'] is String
				? int.tryParse(json['type'])
				: json['type'].toInt();
	}
	if (json['sort'] != null) {
		data.sort = json['sort'] is String
				? int.tryParse(json['sort'])
				: json['sort'].toInt();
	}
	if (json['roomUserId'] != null) {
		data.roomUserId = json['roomUserId'] is String
				? int.tryParse(json['roomUserId'])
				: json['roomUserId'].toInt();
	}
	if (json['invitedCOunt'] != null) {
		data.invitedCOunt = json['invitedCOunt'] is String
				? int.tryParse(json['invitedCOunt'])
				: json['invitedCOunt'].toInt();
	}
	return data;
}

Map<String, dynamic> modelLiveUserListUsersToJson(ModelLiveUserListUsers entity) {
	final Map<String, dynamic> data = new Map<String, dynamic>();
	data['userId'] = entity.userId;
	data['isHost'] = entity.isHost;
	data['nickname'] = entity.nickname;
	data['headImage'] = entity.headImage;
	data['roomPlaceId'] = entity.roomPlaceId;
	data['type'] = entity.type;
	data['sort'] = entity.sort;
	data['roomUserId'] = entity.roomUserId;
	data['invitedCOunt'] = entity.invitedCOunt;
	return data;
}